/***********************************************************************
 Copyright (C) 1993 CAD Framework Initiative, Inc.
 All Rights Reserved Worldwide.

 This program and its accompanying documentation are supplied pursuant
 to a license agreement from CAD Framework Initiative, Inc.
 The use, disclosure, and copying of this
 software and documentation are all governed by that license agreement,
 and any other use, disclosure, or copying of the software or
 documentation is expressly prohibited.
************************************************************************/


/* ***********************************************************************
 File contents : CFI-wide type definitions.
*********************************************************************** */
#ifdef __cplusplus
extern "C" {
#endif

#ifndef CFI_H
#define CFI_H

/*
 * These primitive types are compatible with the ANSI C Standard (ANSI/
 * X3.159-1990 Programming Language C Standard.) 
 */
typedef enum cfiBooleanEnum { CFI_FALSE = 0, CFI_TRUE = 1 } cfiBooleanT;
typedef long int  cfiLongT;
typedef float     cfiFloatT;
typedef double    cfiDoubleT;
typedef char*     cfiStringT;
typedef void      cfiVoidT;

typedef enum cfiTypeEnum {
   CFI_UNDEFINED_VALUETYPE = 0,
   CFI_BOOLEAN = 1,
   CFI_LONG = 2,
   CFI_FLOAT = 3,
   CFI_DOUBLE = 4,
   CFI_STRING = 5,
   CFI_VOID = 6,
   CFI_OID = 7,
   CFI_ITER = 8,
   CFI_MAX_VALUETYPE = 9
   } cfiTypeT;

/*
 * Size limits
 */

#define CFI_LONG_MAX   2147483647
#define CFI_LONG_MIN  -2147483647
#define CFI_ULONG_MAX  4294967295

/*
 * The CFI Architecture requires include file portability within a given 
 * hardware platform. Hence the size of an OID must set. The content is not
 * specified but the size is the same as two pointers. The structure is used to
 * set the size, no reliance on members v1 and v2 can be assumed.
*/
typedef struct cfiOID  {void *v1, *v2;} cfiObjectIdT;

/*
 * Iterators are blind handles the size a single pointer.
 */
typedef void *cfiIteratorIdT;


#endif /* CFI_H */

#ifdef __cplusplus
}
#endif
