//*********************************************************************
//
//   FILE-NAME: cfiinput.c
//
//   CREATION-DATE: Maerz 92
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Funktion fuer Schreiben des DCL-
//	Formats
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#ifdef FRAMEWORK
#include "extern.h"
#include "string_C.h"
#include "line_liste_C.h"
#include "line_C.h"
#include "gate_C.h"
#include "gate_liste_C.h"

void write_circuit()
{
line_C *line_item_p;
gate_C *gate_item_p;
ofstream out;
int i;
char c,s[2];

i = 1;
out.open((char *)(schaltungsname_s + string_C(".dcl")),ios::out);
out << "\n# logical circuit " << schaltungsname_s << "\n";
out << "makeCell " << schaltungsname_s << " {";
forall(line_item_p,input_lines_C)
	if (i%8 == 1)
		out << " \\\n{IN" << i++ << " 1 {}}";
	else
		out << " {IN" << i++ << " 1 {}}";
i = 1;
{forall(line_item_p,output_lines_C)
	if (i%8 == 1)
		out << " \\\n{OUT" << i++ << " 2 {}}";
	else
		out << " {OUT" << i++ << " 2 {}}";}
out << "}\nmakeNetP " << schaltungsname_s << " {";
i = 1;
{forall(line_item_p,input_lines_C)
	if (i%8 == 1)
		out << " \\\n{" << line_item_p->get_name() << " IN" << i++ << "}";
	else
		out << " {" << line_item_p->get_name() << " IN" << i++ << "}";}
i = 1;
{forall(line_item_p,output_lines_C)
	if (i%8 == 1)
		out << " \\\n{" << line_item_p->get_name() << " OUT" << i++ << "}";
	else
		out << " {" << line_item_p->get_name() << " OUT" << i++ << "}";}
i = 1;
{forall(line_item_p,lines_C)
	if ((line_item_p->is_primary_input() == TRUE) || (line_item_p->is_primary_output() == TRUE))
		continue;
	else if (i++%8 == 1)
		out << " \\\n{" << line_item_p->get_name() << " \"\"" << "}";
	else
		out << " {" << line_item_p->get_name() << " \"\"" << "}";}
out << "}\n";
{forall(gate_item_p,gates_C)
	{
	out << "makeInst " << schaltungsname_s << " " << gate_item_p->get_name() <<
		" " << gate_item_p->no_inputs();
	if (gate_item_p->gib_type() == INVERTER)
		out << "INV";
	else if (gate_item_p->gib_type() == DRIVER)
		out << "DR";
	else if (gate_item_p->gib_type() == D_FLIP_FLOP)
		out << "DFF";
	else if (gate_item_p->gib_type() == EXOR)
		out << "XOR";
	else
		out << gate_item_p->gib_type();
	out << gate_item_p->no_outputs() << " {";
	c = 'A';
	for (i=0;i<gate_item_p->no_inputs();i++)
		{
		s[0] = c++;
		s[1] = '\0';
		out << "{" << s << " " << (*gate_item_p->gib_inputs())[i]->get_name() << "} ";
		}//for
	out << "{Y " << (*gate_item_p->gib_outputs())[0]->get_name() << "}}\n";
	}}//forall
//out << "\n\nprint \"Saving design ...\"\nSave Object $lib\n\nQuit PI\n";
out.close();
exit(0);
}//write_circuit
#endif
