//*********************************************************************
//
//   FILE-NAME: classes.h
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Klassendefinitionen und
//	Trivialfunktionen auf den Klassen.
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class string_C;

extern void warning(string_C);
extern void error(string_C);

extern boolean hazard_test_ein_b;
extern struct stat_t statistic_u;
//*********************************************************************
//
//   CLASS-NAME: ofstream
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Ausgabe Funktionen
//
//   OPERATOREN: <<: Ausgabe auf stream fuer enumerationstypen
//
//   FUNKTIONEN: keine
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class ofstream{
public:
   ofstream(char* s,ios::open_mode m = ios::out){f.open(s,m);}
   ofstream(){};
#ifndef OPT_SPACE
   ofstream& operator<<(value_t);
   ofstream& operator<<(gate_t);
   ofstream& operator<<(line_t);
   ofstream& operator<<(object_t);
#endif
   ofstream& operator<<(io_t);
   ofstream& operator<<(fan_result_t);
   ofstream& operator<<(boolean);
   ofstream& operator<<(const char *);
   ofstream& operator<<(int);
   ofstream& operator<<(long);
   ofstream& operator<<(double);
   ofstream& operator<<(void *);
   void open(char *s,ios::open_mode m = ios::out){f.open(s,m);}
   void close(){f.close();}
private:
   ofstream f;
};

//*********************************************************************
//
//   CLASS-NAME: string_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Strings und alle notwendigen
//	Operationen auf Strings.
//
//   OPERATOREN: +: Konkatenation
//		 =: Zuweisung
//		 ==: Vergleich auf Gleichheit
//		 <<: Ausgabe auf stream
//		 char*: cast Operator fuer char* Typ
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer sowie char* Argument
//		 Destruktor, macht nichts, da Fehler bei delete in Destruktor
//		length: gibt aktuelle Laenge aus
//		max_length: gibt die Groesse des alloziierten Speichers aus
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class string_C {
public:
   string_C(int size_i = stringsize_i)
	{
	  // Ein String der Groesse size_i wird alloziiert
	  // Konstruktor ueber Integer.
	  // akt_groesse_i wird hier auf 0 gesetzt, die Klasse wird mit "" initialisiert.
	inhalt_s = new char[size_i + 1];
	if (inhalt_s == NULL)
		error("No more memory available");
	max_groesse_i = size_i;
	akt_groesse_i = 0;
	strcpy(inhalt_s,"");
	}

   string_C(char *name_s)
	{
	  // String wird mit Name initialisiert. akt_groesse_i und max_groesse_i bekommen
	  // die Stringlaenge von name_s zugewiesen.
	akt_groesse_i = strlen(name_s);
	max_groesse_i = akt_groesse_i;
	inhalt_s = new char[akt_groesse_i + 1];
	if (inhalt_s == NULL)
		error("No more memory available");
	strcpy(inhalt_s, name_s);
	}

   string_C(string_C &name_sC)
	{
	  // String wird mit Name initialisiert. akt_groesse_i und max_groesse_i bekommen
	  // die Stringlaenge von name_s zugewiesen.
	char *name_s = name_sC;

	akt_groesse_i = strlen(name_s);
	max_groesse_i = akt_groesse_i;
	inhalt_s = NULL;
	inhalt_s = new char[akt_groesse_i + 1];
	if (inhalt_s == NULL)
		error("No more memory available");
	strcpy(inhalt_s, name_s);
	}

   ~string_C()  // Destruktor fuehrt nur delete aus.
	{
	delete[] inhalt_s;
	}

   operator char *()
	{
	  // Kompatibilitaet zu char * wird hergestellt, der Inhalt wird ausgegeben.
	return inhalt_s;
	}

   friend string_C operator + (string_C, string_C);
	// Konkatenation zweier Strings

   friend boolean operator == (string_C,string_C);
	// Vergleich zweier Strings

   string_C& operator = (string_C s_sC)
	{
	  // Zuweisung eines Strings an einen anderen.
	akt_groesse_i = s_sC.akt_groesse_i;
	max_groesse_i = s_sC.max_groesse_i;
	strcpy(inhalt_s,s_sC.inhalt_s);
	return *this;
	}

   int length()
	{
	  // Die aktuelle Laenge des Strings wird zurueckgegeben.
	return(akt_groesse_i);
	}

   int max_length()
	{
	  // Die maximale Laenge des Strings wird zurueckgegeben.
	return(max_groesse_i);
	}
   int gib_id()
	{
	char s[10];
	int i,j=0;

	for (i=0;i<akt_groesse_i;i++)
	   if (inhalt_s[i] == 'x')
		return(-1);
	   else if ((inhalt_s[i] >= '0') && (inhalt_s[i] <= '9'))
		s[j++] = inhalt_s[i];
	s[j] = '\0';
	return (atoi(s));
	}//gib_id
   void gib_mixed_circuit_id(int &ci_i,int &bl_i);
   boolean tail(char *s)
	{
	int i,j;

	for (i=0;inhalt_s[i] != '\0';i++);
	for (j=0;s[j] != '\0';j++);
	for (;j>=0;i--,j--)
	   if (inhalt_s[i] != s[j])
		return(FALSE);
	return(TRUE);
	}//tail
   char *basename()
	{
	static char s[stringsize_i];

	for (int i=0;(inhalt_s[i] != '.') && (inhalt_s[i] != '\0');i++)
		{
		s[i] = inhalt_s[i];
		s[i+1] = '\0';
		}//for
	return(s);
	}//basename
private:
   int akt_groesse_i;  // Aktuelle String Groesse
   int max_groesse_i;  // Maximale String Groesse
   char *inhalt_s;     // Inhalt des Strings
};
const string_C empty_sC = "";

//*********************************************************************
//
//   CLASS-NAME: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Listen von Strings und alle
//	notwendigen Operationen auf Stringlisten. Die Listen werden mit FIFO
//	Prinzip verwaltet. Wichtig!!!!: zerstoerendes Lesen
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: Konstruktor ohne Argument
//		 Destruktor zerstoert Liste
//		 add_element(string_C): string_C wird in die Liste eingefuegt
//		 entnehme(): nimmt das aelteste Element aus der Liste (FIFO)
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class stringliste_C {
public:
   stringliste_C()
	{
	  // Initialisierung der Parameter
	liste_a = new string_C*[max_number_gates_i];
	if (liste_a == NULL)
		error("No more memory available");
	listengroesse_i = 0;
	max_listengroesse_i = 0;
	aktuell_i = 0;
	}
   ~stringliste_C()
	{
	  // zerstoert die Liste
	for (int i=0;i<max_listengroesse_i;i++)
		delete liste_a[i];
	delete[] liste_a;
	}
   void add_element(string_C);
   string_C entnehme();
private:
   int aktuell_i;
   string_C **liste_a;
   int listengroesse_i;
   int max_listengroesse_i;
};

class object_C;
class gate_C;
class line_C;
class liste_C;
class line_liste_C;
class gate_liste_C;
class line_value_liste_C;

struct line_value_t {
   line_C *line_p;
   value_t val_e;
};

//*********************************************************************
//
//   CLASS-NAME: liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Listen und alle notwendigen
//	Operationen auf Listen.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port_t sowie ohne Argument
//			2. Konstruktor definiert generische Listen (erweiterbar)
//		 Destruktor loescht connected_to_a array
//		 fuege_ein: fuegt in generische Listen ein Element ein
//		 print_all: gibt Inhalt der Listenelemente aus
//		 fuege_aus: fuegt Element in Liste aus
//		 reset_liste: setzt closed_b flag auf TRUE und spult an den
//			Anfang der Liste zurueck
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class liste_C {
public:
   liste_C()
	{
	number_elements_i = 0;
#ifndef OPT_SPACE
	connected_to_a = NULL;
#endif
	generisch_b = TRUE;
	actual_no_i = 0;
	closed_b = FALSE;
	max_elements_i = 0;
	}
   liste_C(int listengroesse_i,port_t io_e)
	{
#ifndef OPT_SPACE
	int j;

	if ((io_e == INPUT_PORT) && (listengroesse_i > max_number_gate_inputs_i))
		error("Gate with more than 10 inputs found");
	if ((io_e == OUTPUT_PORT) && (listengroesse_i > max_no_io_i))
		error("Line with more 1500 fanout-branches found");
	j = (io_e == OUTPUT_PORT) ? (int) O1 : (int) I1;
	connected_to_a = new io_t[listengroesse_i];
	if (connected_to_a == NULL)
		error("No more memory available");
	for (int i=0;i < listengroesse_i;i++)
		connected_to_a[i] = io_t(j++);
#else
	io_e = io_e;
#endif
	generisch_b = FALSE;
	number_elements_i = 0;
	max_elements_i = listengroesse_i;
	actual_no_i = 0;
	closed_b = FALSE;
	}
   ~liste_C()
	{
#ifndef OPT_SPACE
	delete[] connected_to_a;
#endif
	}
   void del_conn_to()
	{
#ifndef OPT_SPACE
	delete[] connected_to_a;
#endif
	}
   void fuege_ein()
	{
	if (generisch_b == FALSE)
		error("fuege_ein: not allowed for non-generic lists");
	number_elements_i++;
	}//fuege_ein
   void print_all(ofstream& datei_F)
	{
	datei_F << "\t" << "Anzahl Elemente:   " << number_elements_i << "\n";
#ifndef OPT_SPACE
	for (int i=0;i<number_elements_i;i++)
	datei_F << "\t" << "connected_to[" << i << "]:   " << connected_to_a[i] << "\n";
#endif
	}
   void fuege_aus()
	{
	if (number_elements_i == 0)
		error("fuege_aus:  list is empty");
	if (generisch_b == FALSE)
		error("fuege_aus: not allowed for non-generic lists");
	number_elements_i--;
	}
   boolean is_empty()
	{
	if (number_elements_i == 0)
		return(TRUE);
	else
		return(FALSE);
	}//is_empty
   int no_elements(){return(number_elements_i);}
   void loesche_liste()
	{
	number_elements_i = 0;
	}//loesche_liste
protected:
   boolean closed_b;
   boolean generisch_b;
   int number_elements_i; // Anzahl der Elemente in der Liste
#ifndef OPT_SPACE
   io_t *connected_to_a;   // Feld mit Information, an welche IO ID das Element
			   // zugewiesen wird.
#endif
   int actual_no_i;	// zum durchforsten einer Liste
   int max_elements_i;
};

class line_value_liste_C: public liste_C {
public:
   line_value_liste_C(){}
   void init(int size_i)
	{
	liste_a = new line_value_t *[size_i];
	if (liste_a == NULL)
		error("No more memory available");
	max_elements_i = size_i;
	for (int i=0;i<max_elements_i;i++)
		liste_a[i] = new line_value_t;
	}
   ~line_value_liste_C()
	{
	delete[] liste_a;
	}
   line_value_t *operator [] (int i){return(liste_a[i]);}
   line_value_t **gib_liste(){return(liste_a);}
   void fuege_ein(line_C *,value_t,boolean = TRUE);
   void fuege_aus(line_C *,value_t);
   boolean element_in_liste(line_C *,value_t,boolean = FALSE);
   line_value_t* find_a_aequi_class_member(int);
private:
   line_value_t **liste_a;  // Liste mit Lines, die an den aktuellen Block
			    // angeschlossen sind.
};

//*********************************************************************
//
//   CLASS-NAME: object_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Objekte (Gates, Lines) und
//	alle notwendigen Operationen auf Objekten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: Konstruktor mit char* Argument: Name des Objektes
//		 Destruktor loescht Objekt
//		 get_name(): gibt den Namen des Objektes aus
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class object_C {
public:
   object_C(string_C objectname_sC)
	{
	name_sC = objectname_sC;
	object_type_e = UNDEFINED_OBJECT;
	reconvergence_b = FALSE;
	}
   ~object_C(){}
   string_C &get_name()
	{
	return (name_sC);
	}
   inline void set_reconvergence(){reconvergence_b = TRUE;}
   inline boolean get_reconvergence(){return(reconvergence_b);}
protected:
   string_C name_sC; // 0 statt stringsize_i muesste auch gehen
   object_t object_type_e;
   boolean reconvergence_b; // Rekonvergenz hier
};

//*********************************************************************
//
//   CLASS-NAME: gate_C: Unterklasse von object_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Gatter und alle notwendigen
//	Operationen auf Gattern.
//
//   OPERATOREN: =: Zuweisung
//
//   FUNKTIONEN: Konstruktor mit char* Argument fuer objet_C Konstruktor
//		 Destruktor macht nichts
//		 print_all: Debug Routine, gibt Inhalt des Gates aus
//		 belege_gate: siehe friends.h
//		 connect_input: siehe friends.h
//		 connect_output: siehe friends.h
//		 compute_contby: siehe friends.h
//		 compute_observaby: siehe friends.h
//		 gib_zero_contby: gibt den Wert von zero_contby_f aus
//		 gib_one_contby: gibt den Wert von one_contby_f aus
//		 gib_observaby: gibt den Wert von observaby_f aus
//		 calculate_planes: siehe friends.h
//		 calculate_type: siehe friends.h
//		 gib_input: gibt die Liste der Eingaenge des Gatters aus
//		 gib_outputs: gibt die Liste der Ausgaenge des Gatters aus
//		 set_reconvergence: Gatter ist Endpunkt einer Pfadrekonvergenz
//			reconvergence_b wird auf TRUE gesetzt
//		 set_feedback: Gatter ist in Rueckkopplung, feedback_b wird auf
//			TRUE gesetzt
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class gate_C: public object_C {
public:
   gate_C(string_C);
   ~gate_C();
   void search_next_path(line_C*,boolean&);
   boolean search_off_path_signals(boolean&);
   void get_block_cube();
   cube_list_t *block_cubes(int i){return(block_cubes_a[i]);}
   void put_constraint_cube();
   void print_all(ofstream &);
   void belege_gate(gate_t gate_type_e,int no_inputs_i,int no_outputs_i);
   void connect_input(stringliste_C&);
   void connect_output(stringliste_C&);
   void compute_contby();
   void compute_observaby();
   void prob_compute_contby();
   void prob_compute_observaby();
   void level_compute_contby();
   void level_compute_observaby();
   void reko_compute_contby();
   void reko_compute_observaby();
   void calculate_planes();
   void calculate_type();
   void invert_type();
   void gib_constraints(cube_list_t*&source_p,cube_list_t*&target_p)
	{
	source_p = constraints_a[0];
	target_p = constraints_a[1];
	}//gib_constraints
   inline line_liste_C *gib_inputs(){return(input_p);}
   inline line_liste_C *gib_outputs(){return(output_p);}
   inline void set_feedback(){feedback_b = TRUE;}
   gate_t gib_type(){return(gate_e);}
   fan_result_t forward_implication();
   fan_result_t fast_forward_implication();
   fan_result_t backward_implication(boolean = TRUE);
   fan_result_t try_global_imp();
   void try_constraint_ana(ofstream&);
   void gate_C::mark_robust_signals();
   void analyse_result(int,ofstream&);
   void add_cube(line_C*,line_C*);
   int no_inputs(){return(no_input_i);}
   int no_outputs(){return(no_output_i);}
   cube_list_t *gib_cubes(value_t val_e);
   void reset_branch(){actual_branch_i = 0;}
   void print_constr()
	{
	ofstream datei_F("Constraints",ios::app);
	int i;
	cube_list_t *source_p,*target_p;
	belegung_t *bel_p;
	
	if (constraints_a[0] != NULL)
		{
		source_p = constraints_a[0];
		target_p = constraints_a[1];
		datei_F << name_sC << "\n";
		while (source_p != NULL)
		   {
		   bel_p = source_p->to_belegung_p;
		   i=1;
		   while (bel_p != NULL)
			{
			if (bel_p->val_e != VAL_X)
				datei_F << "I" << i << "=" << bel_p->val_e << " => ";
			i++;
			bel_p = bel_p->next_p;
			}//while
		   bel_p = target_p->to_belegung_p;
		   while (bel_p != NULL)
			{
			if (bel_p->val_e != VAL_X)
				datei_F << "I" << i << "=" << bel_p->val_e;
			i++;
			bel_p = bel_p->next_p;
			}//while
		   datei_F << "\n";
		   source_p = source_p->next_p;
		   target_p = target_p->next_p;
		   }//for
		}//if
	datei_F.close();
	}//print_constr
   void update_no_inputs();
   boolean hazard_checked(){return((hazard_bit_c == 0)?FALSE:TRUE);}
   boolean hazard_occured(){return((hazard_bit_c == 2)?TRUE:FALSE);}
   void set_hazard_bits(unsigned char c){hazard_bit_c = c;}
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(long int);
#endif
   boolean implikation_durchgefuehrt_b;
   boolean dyn_path_exist_b;
private:
   int actual_branch_i;
   line_liste_C *input_p;
   line_liste_C *output_p;
   cube_list_t *constraints_a[2];
   cube_list_t *block_cubes_a[2];
   int no_input_i;
   int no_output_i;
   gate_t gate_e;
   unsigned char hazard_bit_c;
   boolean feedback_b;	// Element in feedback
};

//*********************************************************************
//
//   CLASS-NAME: line_C: Unterklasse von object_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Lines und alle notwendigen
//	Operationen auf Lines.
//
//   OPERATOREN: =: Zuweisung
//
//   FUNKTIONEN: Konstruktor mit char* Argument: siehe friends.h
//		 Destruktor macht nichts
//		 set_primary_input: Line ist Primaereingang: prime_input_b
//			wird auf TRUE gesetzt
//		 set_primary_output: Line ist Primaerausgang: prime_output_b
//                      wird auf TRUE gesetzt
//		 print_all: alle Belegungen werden Ausgegeben fuer DEBUG
//		 verbinde: siehe friends.h
//		 compute_contby: siehe friends.h
//		 compute_observaby: siehe friends.h
//		 vorgaenger: gibt Liste mit Gattern aus, die Line als Ausgang
//			haben. (Die Liste sollte ein Element haben)
//		 nachfolger: gibt Gatterliste aus, die einen Input auf der Line
//			haben. (Elemente > 1 <==> Line hat fanout)
//		 calculate_planes: siehe friends.h
//		 calculate_type: siehe friends.h
//		 gib_plane_no: Die Nummer der Schaltungsebene, in der sich die
//			Line befindet wird Ausgegeben. Variable ist plane_no_i
//		 gib_type: Es wird Ausgegeben, ob die Line FREE_LINE, BOUND_LINE
//			oder HEAD_LINE ist. Variable line_type_e
//		 set_feedback: Line ist in Rueckkopplung. feedback_b wird auf
//			TRUE gesetzt.
//		 reset_value: test_value_e wird auf VAL_X gesetzt. init_value_e
//			wird auf letzte test_value_e gesetzt.
//		 should_be_tested: Belegt Line fuer den naechsten Rising oder Falling Test
//		 must_be_tested: Initialisiert  Line fuer den naechsten Rising oder
//			Falling Test
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class line_C: public object_C {
public:
   line_C(string_C,int = max_no_fanout_branches_i);
   ~line_C();
   boolean search_next_path(boolean&);
   boolean search_off_path_signals(boolean&);
   void set_primary_input(){prime_input_b = TRUE;}
   void set_primary_output(boolean b = TRUE){prime_output_b = b;}
   void set_pseudo_input(){pseudo_input_b = TRUE;}
   void set_pseudo_output(boolean b = TRUE){pseudo_output_b = b;}
   boolean is_primary_input(){return(prime_input_b);}
   boolean is_primary_output(){return(prime_output_b);}
   boolean is_pseudo_input(){return(pseudo_input_b);}
   boolean is_pseudo_output(){return(pseudo_output_b);}
   void print_all(ofstream &datei_F);
   io_t verbinde(gate_C *, port_t , io_t);
   void compute_contby();
   void compute_observaby();
   void prob_compute_contby();
   void prob_compute_observaby();
   void level_compute_contby();
   void level_compute_observaby();
   void reko_compute_contby();
   void reko_compute_observaby();
   inline double gib_zero_contby(){return(zero_contby_f);}
   inline double gib_one_contby(){return(one_contby_f);}
   inline double gib_observaby(){return(observaby_f);}
   inline double gib_testaby(){return(testaby_f);}
   inline gate_liste_C *vorgaenger(){return(vorgaenger_p);}
   inline gate_liste_C *nachfolger(){return(nachfolger_p);}
   void calculate_planes();
   void calculate_depth_to_output();
   void calculate_type();
   void learn(line_C *);
   void try_learning();
   fan_result_t dyn_learn(line_C *);
   fan_result_t dyn_try_learning();
   fan_result_t global_implication();
   void reset_dyn_learning()
	{
	tmp_global_implications[0].loesche_liste();
	tmp_global_implications[1].loesche_liste();
	}//reset_dyn_learning
   inline int gib_plane_no(){return(plane_no_i);}
   inline int gib_output_depth(){return(output_depth_i);}
   inline line_t gib_type(){return(line_type_e);}
   friend void line_structure();
   inline void set_feedback(){feedback_b = TRUE;}
   inline void reset_value(fan_result_t result_e)
	{
	if (result_e == SUCCESS)
		init_value_e = good_value_e;
	good_value_e = VAL_X;
	bad_value_e = VAL_X;
	}//reset_value
   boolean gib_fanout(){return(fanout_b);}
   boolean is_set_in_forw_imp(){return(set_in_forw_imp_b);}
   void set_in_forw_imp(){set_in_forw_imp_b = TRUE;}
   void reset_in_forw_imp(){set_in_forw_imp_b = FALSE;}
   void set_good_value(value_t val_e){good_value_e = val_e;}
   void set_bad_value(value_t val_e){bad_value_e = val_e;}
   boolean must_be_tested(value_t);
   boolean should_be_tested(value_t);
   boolean test_done_or_aborted();
   value_t get_good_value(){return(good_value_e);}
   value_t get_bad_value(){return(bad_value_e);}
   value_t get_init_value(){return(init_value_e);}
   boolean check_generated_test(line_C *,value_t);
   void check_iddq_test(value_t);
   void reset_non_robust()
	{
	hazard_occured_b = FALSE;
	if (rising_non_robust_b == TRUE)
		rising_aborted_b = FALSE;
	if (falling_non_robust_b == TRUE)
		falling_aborted_b = FALSE;
	rising_non_robust_b = FALSE;
	falling_non_robust_b = FALSE;
	}//reset_non_robust
   void reset_aborted_faults()
	{
	s_a_0_aborted_b = FALSE;
	s_a_1_aborted_b = FALSE;
	rising_aborted_b = FALSE;
	falling_aborted_b = FALSE;
	}//reset_aborted_faults
   void set_s_a_0_aborted(boolean b){s_a_0_aborted_b = b;}
   void set_s_a_1_aborted(boolean b){s_a_1_aborted_b = b;}
   void set_s_a_0_untestable(){s_a_0_untestable_b = TRUE;}
   void set_s_a_1_untestable(){s_a_1_untestable_b = TRUE;}
   void set_s_a_0_test(){s_a_0_test_b = TRUE;}
   void set_s_a_1_test(){s_a_1_test_b = TRUE;}
   void set_stuck_at_test(){stuck_at_test_b = TRUE;}
   boolean get_s_a_0_aborted(){return(s_a_0_aborted_b);}
   boolean get_s_a_1_aborted(){return(s_a_1_aborted_b);}
   boolean get_s_a_0_untestable(){return(s_a_0_untestable_b);}
   boolean get_s_a_1_untestable(){return(s_a_1_untestable_b);}
   boolean get_s_a_0_test(){return(s_a_0_test_b);}
   boolean get_s_a_1_test(){return(s_a_1_test_b);}
   boolean get_stuck_at_test(){return(stuck_at_test_b);}
   void mark_result(fan_result_t,value_t);
   friend void print_result();
   friend void nachanalyse();
   void hazard_occured(){hazard_occured_b = TRUE;}
   boolean in_input_kegel(){return(input_kegel_b);}
   boolean in_output_kegel(){return(output_kegel_b);}
   boolean path_blocked(){return(path_blocked_b);}
   void set_path_blocked(){path_blocked_b = TRUE;}
   void reset_path_blocked(){path_blocked_b = FALSE;}
   void mark_input_kegel(){input_kegel_b = TRUE;}
   void mark_output_kegel(){output_kegel_b = TRUE;}
   void clear_kegel(){input_kegel_b = FALSE;output_kegel_b = FALSE;}
   boolean lookup_testability()
	{
	if (((good_value_e == VAL_1) && (s_a_0_untestable_b == TRUE)) ||
	    ((bad_value_e == VAL_0) && (s_a_1_untestable_b == TRUE)))
		return(FALSE);
	else
		return(TRUE);
	}//lookup_testability
   value_t get_only_value(){return(only_value_e);}
   void set_only_value(value_t val_e){only_value_e = val_e;}
   boolean geprueft_b; // wird in feedback Analyse und Fehlersimulation gebraucht
   boolean signal_path_exist_b;	// wird in Fehlersimulation gebraucht
   void reset_test_done(){test_done_b = FALSE;}
   void set_test_done(){test_done_b = TRUE;}
   boolean get_test_done(){return(test_done_b);}
   void reset_testaby()
	{
	one_contby_f = 0.0;
	zero_contby_f = 0.0;
	contby_f = 0.0;
	observaby_f = 0.0;
	testaby_f = 0.0;
	}//reset_testaby
   void berechne_testaby_kehrwert()
	{
	one_contby_f = 1.0 / one_contby_f;
	zero_contby_f = 1.0 / zero_contby_f;
	contby_f = 1.0 / contby_f;
	observaby_f = 1.0 / observaby_f;
	testaby_f = 1.0 / testaby_f;
	}//berechne_testaby_kehrwert
   void set_static_dominator(line_C *line_item_p){static_dominator_p = line_item_p;}
   void set_dynamic_dominator(line_C *line_item_p){dynamic_dominator_p = line_item_p;}
   void clear_dynamic_dominator(){dynamic_dominator_p = NULL;}
   line_C *get_static_dominator(){return(static_dominator_p);}
   line_C *get_dynamic_dominator(){return(dynamic_dominator_p);}
   friend boolean exist_signal_path_to_output(line_C*,value_t);
   friend void analyse_signal_path(line_C*);
   int gib_number(){return(number_i);}
   int gib_aequiklass_at_0_nr_i(){return(aequiklass_at_0_nr_i);}
   int gib_aequiklass_at_1_nr_i(){return(aequiklass_at_1_nr_i);}
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(long int);
#endif
   int aequiklass_at_0_nr_i;
   int aequiklass_at_1_nr_i;
private:
   int number_i;
   int output_depth_i;		// Abstand zum Primaerausgang
   boolean path_blocked_b;	// Ist Pfad zum Ausgang blockiert
   boolean input_kegel_b;	// Ist Line im Input Kegel der Ziel Line
   boolean output_kegel_b;	// Ist Line im Output Kegel der Ziel Line
   boolean prime_input_b;	// Ist Line Primaereingang
   boolean prime_output_b;	// Ist Line Primaerausgang
   boolean pseudo_input_b;	// Ist Line Pseudoeingang
   boolean pseudo_output_b;	// Ist Line Pseudoausgang
   boolean fanout_b;		// Hat Line Fanout
   boolean set_in_forw_imp_b;	// Hat Line Fanout
   boolean feedback_b;		// Ist Line in Rueckkopplung
   boolean hazard_occured_b;	// Ist Line Hazardbehaftet
   boolean rising_test_b;	// Ist rising Test durchgefuehrt
   boolean falling_test_b;	// Ist falling Test durchgefuehrt
   boolean rising_aborted_b;	// Ist rising Test aborted
   boolean falling_aborted_b;	// Ist falling Test aborted
   boolean rising_untestable_b;	// Ist rising Test unmoeglich
   boolean falling_untestable_b;// Ist falling Test unmoeglich
   boolean s_a_0_untestable_b;	// Ist Line nicht testbar auf stuck-at 0
   boolean s_a_1_untestable_b;	// Ist Line nicht testbar auf stuck-at 1
   boolean s_a_0_aborted_b;	// Ist Line aborted Fault auf stuck-at 0
   boolean s_a_1_aborted_b;	// Ist Line aborted Fault auf stuck-at 1
   boolean falling_non_robust_b;// Ist Line non_robust auf Falling
   boolean rising_non_robust_b;	// Ist Line non_robust auf Rising
   boolean test_done_b;		// Ist beabsichtigter Test durchgefuehrt
   boolean stuck_at_test_b;	// Ist stuck at Test durchgefuehrt
   boolean s_a_0_test_b;	// Ist stuck at 0 Test durchgefuehrt
   boolean s_a_1_test_b;	// Ist stuck at 1 Test durchgefuehrt
   line_t line_type_e;		// Line Typ (FREE_LINE, BOUND_LINE, HEAD_LINE)
   value_t init_value_e;	// Init Value
   value_t good_value_e;	// Gut-Wert
   value_t bad_value_e;		// Fehler-Wert
   value_t only_value_e;	// Einzig moegliche Value
   gate_liste_C *vorgaenger_p;	// Vorgaengerliste
   gate_liste_C *nachfolger_p;	// Nachfolger Liste
   line_value_liste_C global_implications[2];	// globale Implikationen
   line_value_liste_C tmp_global_implications[2];	// temporaere globale Implikationen
   int plane_no_i;		// Nummer der Ebene, in der Line sich befindet
   double one_contby_f;
   double zero_contby_f;
   double contby_f;
   double observaby_f;
   double testaby_f;
   line_C *static_dominator_p;
   line_C *dynamic_dominator_p;
};

//*********************************************************************
//
//   CLASS-NAME: gate_liste_C Unterklasse von liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Gatterlisten und alle notwendigen
//	Operationen auf Gatterlisten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port sowie ohne Argument
//			ohne Argumente => generische Liste
//		 Destruktor loescht Liste
//		 print_all: gibt Inhalt aller Listenelemente aus (DEBUG)
//		 fuege_ein: fuegt Element ein (siehe friends.h)
//		 fuege_aus: fuegt Element aus Liste aus (gate_C* Argument)
//		 element_in_liste: prueft, ob Element gate_C* in Liste ist
//		 search: siehe friends.h
//		 next: gibt aktuelles Element von Liste aus (aktuell entspricht
//			aktual_no_i), wenn Liste geschlossen ist (closed_b == TRUE)
//			beim letzten Element wird Liste geoeffnet
//		 verbinde: siehe friends.h
//		 gib_only_gate: wenn ein Element in der Liste ist, wird dieses
//			Ausgegeben, sonst Fehlermeldung
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class gate_liste_C : public liste_C {
public:
   gate_liste_C(int listengroesse_i,port_t io_e):liste_C(listengroesse_i,io_e)
	{
	liste_a = new gate_C *[listengroesse_i];
	if (liste_a == NULL)
		error("No more memory available");
	}
   gate_liste_C(){}
   void init(int size_i)
	{
	liste_a = new gate_C *[size_i];
	if (liste_a == NULL)
		error("No more memory available");
	}
   void resize()
	{
	gate_liste_C *tmp_C;

	tmp_C = new gate_liste_C;
	tmp_C->init(number_elements_i);
	for (int i=0;i<number_elements_i;i++)
		tmp_C->fuege_ein(liste_a[i]);
	delete[] liste_a;
	liste_a = new gate_C *[number_elements_i];
	for (i=0;i<number_elements_i;i++)
		liste_a[i] = (*tmp_C)[i];
	delete tmp_C;
	}
   ~gate_liste_C()
	{
	delete[] liste_a;
	}
   gate_C *operator [] (int i){return(liste_a[i]);}
   void print_all(ofstream& datei_F)
	{
	liste_C::print_all(datei_F);
	for (int i=0;i<number_elements_i;i++)
	datei_F << "\t" << "element[" << i << "]:   " << liste_a[i]->get_name() << "\n";
	}
   void fuege_ein(gate_C *gate_item_p);
   void fuege_aus(gate_C *gate_item_p);
   boolean element_in_liste(gate_C *,boolean = FALSE);
   io_t verbinde(gate_C *, io_t);
   gate_C *gib_only_gate()
	{
	if (number_elements_i != 1)
		error("gib_only_gate: more than 1 gate in list");
	return(liste_a[0]);
	}//gib_only_gate
   void loesche_liste()
	{
	for (int i=0;i<number_elements_i;i++)
		liste_a[i] = NULL;
	number_elements_i = 0;
	}//loesche_liste
   void loesche_liste_und_pointer()
	{
	delete[] liste_a;
	number_elements_i = 0;
	liste_a = new gate_C *[1];
	max_elements_i = 1;
	generisch_b = FALSE;
	actual_no_i = 0;
	closed_b = FALSE;
	}//loesche_liste
   void change_connection(char *name_s,gate_C *gate_item_p)
	{
	int i;

	for (i=0;i<number_elements_i;i++)
	   if (liste_a[i]->get_name() == string_C(name_s))
		{
		liste_a[i] = gate_item_p;
		break;
		}//if
	}//change_connection
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(long int);
#endif
private:
   gate_C **liste_a;  // Liste mit Blocken, die an die aktuelle Line
		      // angeschlossen sind.
};

//*********************************************************************
//
//   CLASS-NAME: line_liste_C Unterklasse von liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Linelisten und alle notwendigen
//	Operationen auf Linelisten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port sowie ohne Argument
//			ohne Argumente => generische Liste
//		 Destruktor loescht Liste
//		 print_all: gibt Inhalt aller Listenelemente aus (DEBUG)
//		 fuege_ein: fuegt Element ein (siehe friends.h)
//		 fuege_aus: fuegt Element aus Liste aus (gate_C* Argument)
//		 element_in_liste: prueft, ob Element gate_C* in Liste ist
//		 next: gibt aktuelles Element von Liste aus (aktuell entspricht
//			aktual_no_i), wenn Liste geschlossen ist (closed_b == TRUE)
//			beim letzten Element wird Liste geoeffnet
//		 search: siehe friends.h
//		 verbinde: siehe friends.h
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class line_liste_C: public liste_C {
public:
   line_liste_C(int listengroesse_i, port_t io_e):liste_C(listengroesse_i,io_e)
	{
	liste_a = new line_C *[listengroesse_i];
	if (liste_a == NULL)
		error("No more memory available");
	}
   line_liste_C(){}
   void init(int size_i)
	{
	liste_a = new line_C *[size_i];
	if (liste_a == NULL)
		error("No more memory available");
	}
   void merge_list(line_liste_C*);
   void resize()
	{
	line_liste_C *tmp_C;

	tmp_C = new line_liste_C;
	tmp_C->init(number_elements_i);
	for (int i=0;i<number_elements_i;i++)
		tmp_C->fuege_ein(liste_a[i]);
	delete[] liste_a;
	liste_a = new line_C *[number_elements_i];
	for (i=0;i<number_elements_i;i++)
		liste_a[i] = (*tmp_C)[i];
	delete tmp_C;
	}
   ~line_liste_C()
	{
	delete[] liste_a;
	}
   line_C *operator [] (int i){return(liste_a[i]);}
   void print_all(ofstream& datei_F)
	{
	liste_C::print_all(datei_F);
	for (int i=0;i<number_elements_i;i++)
	datei_F << "\t" << "element[" << i << "]:   " << liste_a[i]->get_name() << "\n";
	}
   void fuege_ein(line_C *line_item_p);
   void fuege_aus(line_C *line_item_p);
   boolean element_in_liste(line_C *,boolean = FALSE);
   void verbinde(line_C *, io_t, int);
   line_C *gib_only_line()
	{
	if (number_elements_i != 1)
		error("gib_only_line: more than 1 gate in list");
	return(liste_a[0]);
	}//gib_only_gate
   void change_connection(char *name_s,line_C *line_item_p)
	{
	int i;

	for (i=0;i<number_elements_i;i++)
	   if (liste_a[i]->get_name() == string_C(name_s))
		{
		liste_a[i] = line_item_p;
		break;
		}//if
	}//change_connection
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(long int);
#endif
private:
   line_C **liste_a;  // Liste mit Lines, die an den aktuellen Block
                     // angeschlossen sind.
};

class protocol_type_C {
public:
   protocol_type_C()
	{
	line_p = NULL;
	optional_b = 0;
	ujust_bound_in_b = 0;
	ujust_bound_out_b = 0;
	d_front_in_b = 0;
	d_front_out_b = 0;
	old_good_value_e = UNDEFINED_VALUE;
	new_good_value_e = UNDEFINED_VALUE;
	old_bad_value_e = UNDEFINED_VALUE;
	new_bad_value_e = UNDEFINED_VALUE;
	}//protocol_type_C
   ~protocol_type_C(){}
   line_C *line_p;
   boolean optional(){return((optional_b == 1)?TRUE:FALSE);}
   boolean ujust_bound_in(){return((ujust_bound_in_b == 1)?TRUE:FALSE);}
   boolean ujust_bound_out(){return((ujust_bound_out_b == 1)?TRUE:FALSE);}
   boolean d_front_in(){return((d_front_in_b == 1)?TRUE:FALSE);}
   boolean d_front_out(){return((d_front_out_b == 1)?TRUE:FALSE);}
   value_t old_good_value(){return(value_t(old_good_value_e));}
   value_t new_good_value(){return(value_t(new_good_value_e));}
   value_t old_bad_value(){return(value_t(old_bad_value_e));}
   value_t new_bad_value(){return(value_t(new_bad_value_e));}
   void set_optional(boolean b){optional_b = (b == TRUE)?1:0;}
   void set_ujust_bound_in(boolean b){ujust_bound_in_b = (b == TRUE)?1:0;}
   void set_ujust_bound_out(boolean b){ujust_bound_out_b = (b == TRUE)?1:0;}
   void set_d_front_in(boolean b){d_front_in_b = (b == TRUE)?1:0;}
   void set_d_front_out(boolean b){d_front_out_b = (b == TRUE)?1:0;}
   void set_old_good_value(value_t val_e){old_good_value_e = int(val_e);}
   void set_new_good_value(value_t val_e){new_good_value_e = int(val_e);}
   void set_old_bad_value(value_t val_e){old_bad_value_e = int(val_e);}
   void set_new_bad_value(value_t val_e){new_bad_value_e = int(val_e);}
private:
   unsigned int optional_b : 1;
   unsigned int ujust_bound_in_b : 1;
   unsigned int ujust_bound_out_b : 1;
   unsigned int d_front_in_b : 1;
   unsigned int d_front_out_b : 1;
   unsigned int old_good_value_e : 4;
   unsigned int new_good_value_e : 4;
   unsigned int old_bad_value_e : 4;
   unsigned int new_bad_value_e : 4;
};

class protocol_stack_C : public liste_C{
public:
   protocol_stack_C(){}
   void init()
	{
	int i;

	max_elements_i = 5 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i);
	protocol_stack_a = new protocol_type_C*[max_elements_i];
	if (protocol_stack_a == NULL)
		error("No more memory available");
	for (i=0;i<max_elements_i;i++)
		{
		protocol_stack_a[i] = new protocol_type_C;
		if (protocol_stack_a[i] == NULL)
			error("No more memory available");
		}//for
	}//protocol_stack_C
   ~protocol_stack_C()
	{
	delete[] protocol_stack_a;
	}//~protocol_stack_C
   void push(line_C *line_item_p,boolean opt_b,
	     boolean bound_in_b = FALSE,boolean bound_out_b = FALSE,boolean df_in_b = FALSE,
	     boolean df_out_b = FALSE,value_t old_good_e = UNDEFINED_VALUE,
	     value_t new_good_e = UNDEFINED_VALUE,value_t old_bad_e = UNDEFINED_VALUE,
	     value_t new_bad_e = UNDEFINED_VALUE);
   protocol_type_C *pop();
   void print_data()
	{
	ofstream datei_F;

	datei_F.open("protocol_C.debug");
	for(int i = 0;i<number_elements_i;i++)
		{
		datei_F << "********** Element_ Nr.:  " << i << "\n";
		datei_F << "Line:  " << protocol_stack_a[i]->line_p->get_name() << "\n";
		datei_F << "Optionale Zuweisung:  " << protocol_stack_a[i]->optional() << "\n";
		datei_F << "Bound Liste eingefuegt:  " << protocol_stack_a[i]->ujust_bound_in() << "\n";
		datei_F << "Bound Liste ausgefuegt:  " << protocol_stack_a[i]->ujust_bound_out() << "\n";
		datei_F << "D_Front eingefuegt:  " << protocol_stack_a[i]->d_front_in() << "\n";
		datei_F << "D_Front ausgefuegt:  " << protocol_stack_a[i]->d_front_out() << "\n";
		datei_F << "Alter Gut-Wert:  " << protocol_stack_a[i]->old_good_value() << "\n";
		datei_F << "Neuer Gut-Wert:  " << protocol_stack_a[i]->new_good_value() << "\n";
		datei_F << "Alter Schlecht-Wert:  " << protocol_stack_a[i]->old_bad_value() << "\n";
		datei_F << "Neuer Schlecht-Wert:  " << protocol_stack_a[i]->new_bad_value() << "\n";
		}//for
	datei_F.close();
	}//print_data
private:
   protocol_type_C **protocol_stack_a;
};

struct objective_type_u {
line_C *line_p;
int n0_i;
int n1_i;
};

class objective_liste_C: public liste_C {
public:
   objective_liste_C(){}
   void init(int size_i)
	{
	liste_a = new objective_type_u *[size_i];
	if (liste_a == NULL)
		error("No more memory available");
	max_elements_i = size_i;
	for(int i=0;i<size_i;i++)
		{
		liste_a[i] = new objective_type_u;
		if (liste_a[i] == NULL)
			error("No more memory available");
		}//for
	}
   ~objective_liste_C()
	{
	for(int i=0;i<max_elements_i;i++)
		delete liste_a[i];
	delete[] liste_a;
	}
   objective_type_u *operator [] (int i){return(liste_a[i]);}
   void fuege_ein(line_C *line_item_p,int no_0_i,int no_1_i);
   void fuege_aus(line_C *line_item_p);
   boolean element_in_liste(line_C *,boolean = FALSE);
   objective_type_u *pop()
	{
	number_elements_i--;
	return(liste_a[number_elements_i]);
	}//pop
   void print_data()
	{
	ofstream datei_F("objective_liste");
	for(int i = 0;i<number_elements_i;i++)
		{
		datei_F << liste_a[i]->line_p->get_name() << "  n0:";
		datei_F << liste_a[i]->n0_i << "  n1:";
		datei_F << liste_a[i]->n1_i << "\n";
		}//for
	}//print_data
private:
   objective_type_u **liste_a;
};

#if DEBUG
struct opt_line{
line_C *line_p;
value_t val_e;
boolean optional_b;
};

class opt_line_liste_C{
public:
opt_line_liste_C()
	{
	liste_a = new opt_line *[max_number_lines_i];
	if (liste_a == NULL)
		error("No more memory available");
	number_elements_i = 0;
	max_elements_i = 0;
	}
~opt_line_liste_C(){delete[] liste_a;}
void insert(line_C *line_item_p,value_t val_e,boolean opt_b)
	{
	if (number_elements_i >= max_number_lines_i)
		error("opt_line_liste_C::insert: list overflow");
	if (number_elements_i == max_elements_i)
		{
		liste_a[number_elements_i] = new opt_line;
		if (liste_a[number_elements_i] == NULL)
			error("No more memory available");
		max_elements_i++;
		}//if
	number_elements_i++;
	liste_a[number_elements_i - 1]->line_p = line_item_p;
	liste_a[number_elements_i - 1]->val_e = val_e;
	liste_a[number_elements_i - 1]->optional_b = opt_b;
	}/*insert*/
void loesche_liste(){number_elements_i = 0;}
void print_all()
	{
	ofstream datei_F("optional_lines");
	
	for (int i=0;i<number_elements_i;i++)
		{
		datei_F << liste_a[i]->line_p->get_name() << ":  " << liste_a[i]->val_e;
		datei_F << ((liste_a[i]->optional_b == TRUE)?"   optional":"   backtrack") << "\n";
		}//for
	datei_F.close();
	}//print_all
private:
opt_line **liste_a;
int number_elements_i;
int max_elements_i;
};
#endif

struct line_tree_u{
	line_tree_u *left;
	line_tree_u *right;
	boolean left_done_b;
	boolean right_done_b;
	boolean element_done_b;
	int bal_i;
	line_C *line_p;
};

struct gate_tree_u{
	gate_tree_u *left;
	gate_tree_u *right;
	int bal_i;
	gate_C *gate_p;
};
