#ifndef consts_h
#define consts_h

//*********************************************************************
//
//   FILE-NAME: consts.h
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Konstanten und enumerations Typen
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include <stream.h>
#include <iostream.h>
#include <fstream.h>
#include <strings.h>
#include <string.h>
#include <values.h>
#include <stdlib.h>
#include <stdio.h>

class gate_C;
class line_C;

#ifndef OPT_SPACE
enum AEQUIVALENZ_TYP {no_Aequivalenz, no_Dominanz, Stuck_at_0, Stuck_at_1, UNKNOWN_AEQUIVALENCE} ; //Eb
enum object_t { GATE, LINE, UNDEFINED_OBJECT }; // Object Typen 
enum value_t {VAL_0S, VAL_0, VAL_1S, VAL_1, VAL_0X, VAL_1X, VAL_U0, VAL_U1,
	      VAL_U, VAL_X, VAL_D, VAL_D_BAR, IMPOSSIBLE_VALUE, UNDEFINED_VALUE};
					// Values fuer LINES
enum boolean {FALSE = 0, TRUE = 1}; // Type Boolean
enum gate_t {AND, OR, NAND, NOR, EXOR, INVERTER, DRIVER, D_FLIP_FLOP, D_LATCH,
	     BLOCK, FANOUT, UNDEFINED_GATE};
					// Gatter Typen
enum line_t {FREE_LINE, BOUND_LINE, HEAD_LINE, UNDEFINED_LINE};
					// Verbindungstypen
#else
#define no_Aequivalenz 0
#define no_Dominanz 1
#define Stuck_at_0 2
#define Stuck_at_1 3
#define UNKNOWN_AEQUIVALENCE 4
typedef char AEQUIVALENZ_TYP;

#define GATE 0
#define LINE 1
#define UNDEFINED_OBJECT 2
typedef char object_t;

#define VAL_0S 0
#define VAL_0 1
#define VAL_1S 2
#define VAL_1 3
#define VAL_0X 4
#define VAL_1X 5
#define VAL_U0 6
#define VAL_U1 7
#define VAL_U 8
#define VAL_X 9
#define VAL_D 10
#define VAL_D_BAR 11
#define IMPOSSIBLE_VALUE 12
#define UNDEFINED_VALUE 13
typedef char value_t;

#define FALSE 0
#define TRUE 1
typedef char boolean;

#define AND 0
#define OR 1
#define NAND 2
#define NOR 3
#define EXOR 4
#define INVERTER 5
#define DRIVER 6
#define D_FLIP_FLOP 7
#define D_LATCH 8
#define BLOCK 9
#define FANOUT 10
#define UNDEFINED_GATE 11
typedef char gate_t;

#define FREE_LINE 0
#define BOUND_LINE 1
#define HEAD_LINE 2
#define UNDEFINED_LINE 3
typedef char line_t;
#endif

enum fan_result_t {SUCCESS, ABORTED_FAULT, REDUNDANT_FAULT, INCONSISTENT, NO_IMPLICATION,
			IMPLICATION_DONE};
				// Rueckgabewerte des Fan Algorithmus
enum entry_exit_t {ENTRY_A, ENTRY_B, EXIT_C, EXIT_D};
				// Werte fuer Multibacktrace in Fan Alg.

const int stringsize_i = 800;		// Stringgroesse
const int max_number_gates_i = 350000;   // Maximale Gatteranzahl
const int max_number_lines_i = 400000;	// Maximale Signalanzahl
const int max_number_gate_inputs_i = 100;	// maximale Anzahl der Gatter Eingaenge
const int max_no_fanout_branches_i = 5;	// maximale Anzahl der fanout Zweige
						// bei Aenderung den io_t aendern
const int max_no_io_i = 20000;

struct stat_t {
	int number_gates_i;
	int number_or_gates_i;
	int number_and_gates_i;
	int number_nand_gates_i;
	int number_nor_gates_i;
	int number_exor_gates_i;
	int number_drivers_i;
	int number_inverters_i;
	int number_flipflops_i;
	int number_blocks_i;
	int number_lines_i;
	int number_inputs_i;
	int number_outputs_i;
	int number_fanouts_i;
	int number_fanout_branches_i;
	boolean feedback_b;
};			// Statistik der Schaltung

struct belegung_t{
value_t val_e;
belegung_t *next_p;
};
struct cube_list_t{
belegung_t *to_belegung_p;
cube_list_t *next_p;
};

struct ctest_belegung_t{
char val_c;
ctest_belegung_t *next_p;
};
struct ctest_cube_list_t{
ctest_belegung_t *to_belegung_p;
ctest_cube_list_t *next_p;
};

struct dominanz_result_t{
boolean VAL_0_b;
boolean VAL_1_b;
};

struct line_tree_u{
	line_tree_u *left;
	line_tree_u *right;
	boolean left_done_b;
	boolean right_done_b;
	boolean element_done_b;
	int bal_i;
	line_C *line_p;
};
extern line_tree_u *milef_line_tree_root_p;

struct gate_tree_u{
	gate_tree_u *left;
	gate_tree_u *right;
	int bal_i;
	gate_C *gate_p;
};
extern gate_tree_u *milef_gate_tree_root_p;

struct objective_type_u {
line_C *line_p;
int n0_i;
int n1_i;
};

#define forall(item,liste) \
	int forall_index = 0; \
	for((item) = ((liste).no_elements() == 0)?NULL:((liste)[0]);forall_index<(liste).no_elements(); \
	    item = ((++forall_index) == ((liste).no_elements())) ? NULL \
	    : (liste)[forall_index])
#endif







