//*********************************************************************
//
//   FILE-NAME: cubes.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Routinen fuer Kuben im Zusammenhang
//	mit der Anbindung von CTEST
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include "extern.h"
#include "prot.h"
#include "gate_C.h"
#include "line_C.h"
#include "line_liste_C.h"

ctest_cube_list_t *head_of_cube_list_p = NULL;
extern value_t mynot(value_t);

cube_list_t *gate_C::gib_cubes(value_t val_e)
{
if (val_e == VAL_0)
	return(block_cubes_a[0]);
else if (val_e == VAL_1)
	return(block_cubes_a[1]);
else
	error("gate_C::gib_cubes: Unknown Value in input");
}//gib_cubes
//*********************************************************************
//
//   FUNCTION-NAME: get_block_cube
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ruft die Block Funktionalitaet von CTEST ab.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::get_block_cube()
{
  cout << "Blocks not implemented anymore";
exit(0);
/*
ctest_cube_list_t *ptr_to_cube_list_p;
ctest_belegung_t *ptr_to_belegung_p;
int output_id_i,block_id_i,output_val_i,instance_id_i,status_i;
cube_list_t *cube_list_p;
belegung_t *belegung_p;

	//rufe block_id und output_id ab
block_id_i = name_sC.gib_id();
if (block_id_i == -1)
	{
	name_sC.gib_mixed_circuit_id(instance_id_i,block_id_i);
	select_instance(&instance_id_i,&status_i);
	if (status_i != 0)
		error("gate_C::get_block_cube: select_instance terminated with error status");
	}//if
output_id_i = output_p->gib_only_line()->get_name().gib_id();

for (output_val_i=0;output_val_i<2;output_val_i++)
   {
   get_cubes(&block_id_i,&output_id_i,&output_val_i,&head_of_cube_list_p);
   for(ptr_to_cube_list_p = head_of_cube_list_p;
       ptr_to_cube_list_p != NULL;ptr_to_cube_list_p = ptr_to_cube_list_p->next_p)
	{
	if (block_cubes_a[output_val_i] == NULL)
		{
		block_cubes_a[output_val_i] = new cube_list_t;
		if (block_cubes_a[output_val_i] == NULL)
			error("no free memory available");
		cube_list_p = block_cubes_a[output_val_i];
		}//if
	else
		{
		cube_list_p->next_p = new cube_list_t;
		if (cube_list_p->next_p == NULL)
			error("no free memory available");
		cube_list_p = cube_list_p->next_p;
		}//else
	cube_list_p->to_belegung_p = NULL;
	cube_list_p->next_p = NULL;
	for(ptr_to_belegung_p = ptr_to_cube_list_p->to_belegung_p;
	    ptr_to_belegung_p != NULL;ptr_to_belegung_p = ptr_to_belegung_p->next_p)
		{
		if (cube_list_p->to_belegung_p == NULL)
			{
			cube_list_p->to_belegung_p = new belegung_t;
			if (cube_list_p->to_belegung_p == NULL)
				error("no free memory available");
			belegung_p = cube_list_p->to_belegung_p;
			}//if
		else
			{
			belegung_p->next_p = new belegung_t;
			if (belegung_p->next_p == NULL)
				error("no free memory available");
			belegung_p = belegung_p->next_p;
			}//else
		belegung_p->next_p = NULL;
		switch(ptr_to_belegung_p->val_c)
		   {
		   case '0':
			belegung_p->val_e = VAL_0;
			break;
		   case '1':
			belegung_p->val_e = VAL_1;
			break;
		   case 'X':
			belegung_p->val_e = VAL_X;
			break;
		   default:
			error("get_block_cube: wrong value");
		   }//switch
		}//for
	}//for
   }//for
*/
}//get_block_cube

//*********************************************************************
//
//   FUNCTION-NAME: put_constraint_cube
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Uebergibt Constraints an CTEST
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::put_constraint_cube()
{
/*
line_C *line_item_p;
ctest_cube_list_t *head_of_constraint_list_p = NULL;
ctest_cube_list_t *ptr_to_cube_list_p;
ctest_belegung_t *ptr_to_belegung_p;
int output_id_i,block_id_i,instance_id_i,status_i;
value_t val_e;
cube_list_t *source_p,*target_p;
belegung_t *s_bel_p,*t_bel_p;
boolean put_constraints_entry_b = FALSE;
			
	//rufe block_id und output_id ab
block_id_i = name_sC.gib_id();
if (block_id_i == -1)
	{
	name_sC.gib_mixed_circuit_id(instance_id_i,block_id_i);
	select_instance(&instance_id_i,&status_i);
	if (status_i != 0)
		error("gate_C::get_block_cube: select_instance terminated with error status");
	}//if
output_id_i = output_p->gib_only_line()->get_name().gib_id();

forall(line_item_p,*input_p)
	if (line_item_p->get_only_value() != VAL_X)
		put_constraints_entry_b = TRUE;

if ((constraints_a[0] == NULL) && (put_constraints_entry_b == FALSE))
	put_constraints(&block_id_i,&output_id_i,&head_of_constraint_list_p);
else
	{
	source_p = constraints_a[0];
	target_p = constraints_a[1];
	head_of_constraint_list_p = new ctest_cube_list_t;
	ptr_to_cube_list_p = head_of_constraint_list_p;
	head_of_constraint_list_p->to_belegung_p = NULL;
	head_of_constraint_list_p->next_p = NULL;
	while (source_p != NULL)
		{
		s_bel_p = source_p->to_belegung_p;
		t_bel_p = target_p->to_belegung_p;
		ptr_to_cube_list_p->to_belegung_p = new ctest_belegung_t;
		ptr_to_belegung_p = ptr_to_cube_list_p->to_belegung_p;
		while (s_bel_p != NULL)
			{
			boolean imp_val_found_b = FALSE;

			if (imp_val_found_b == TRUE)
				val_e = VAL_X;
			else if (t_bel_p->val_e == IMPOSSIBLE_VALUE)
				{
				ctest_belegung_t *hilf_bel_p;

				for(hilf_bel_p = ptr_to_cube_list_p->to_belegung_p;
				    hilf_bel_p != ptr_to_belegung_p;hilf_bel_p = hilf_bel_p->next_p)
					hilf_bel_p->val_c = 'X';
				imp_val_found_b = TRUE;
				val_e = s_bel_p->val_e;
				}//if
			else if (t_bel_p->val_e == VAL_X)
				val_e = s_bel_p->val_e;
			else
				val_e = mynot(t_bel_p->val_e);
			switch (val_e)
				{
				case VAL_X:
					ptr_to_belegung_p->val_c = 'X';
					break;
				case VAL_0:
					ptr_to_belegung_p->val_c = '0';
					break;
				case VAL_1:
					ptr_to_belegung_p->val_c = '1';
					break;
				default:
					error("gate_C::put_constraint_cube: wrong value in constraint");
				}
			s_bel_p = s_bel_p->next_p;
			t_bel_p = t_bel_p->next_p;
			if (s_bel_p != NULL)
				{
				ptr_to_belegung_p->next_p = new ctest_belegung_t;
				ptr_to_belegung_p = ptr_to_belegung_p->next_p;
				ptr_to_belegung_p->next_p = NULL;
				}//if
			}//while
		source_p = source_p->next_p;
		target_p = target_p->next_p;
		if (source_p != NULL)
			{
			ptr_to_cube_list_p->next_p = new ctest_cube_list_t;
			ptr_to_cube_list_p = ptr_to_cube_list_p->next_p;
			ptr_to_cube_list_p->next_p = NULL;
			}//if
		}//while
	forall(line_item_p,*input_p)
	   if (line_item_p->get_only_value() != VAL_X)
		{
		int i;

		if (ptr_to_cube_list_p->to_belegung_p != NULL)
			{
			ptr_to_cube_list_p->next_p = new ctest_cube_list_t;
			ptr_to_cube_list_p = ptr_to_cube_list_p->next_p;
			ptr_to_cube_list_p->next_p = NULL;
			}//if
		
		for (i=0;i<no_input_i;i++)
			{
			if (i != 0)
				{
				ptr_to_belegung_p->next_p = new ctest_belegung_t;
				ptr_to_belegung_p = ptr_to_belegung_p->next_p;
				}//if
			else
				{
				ptr_to_cube_list_p->to_belegung_p = new ctest_belegung_t;
				ptr_to_belegung_p = ptr_to_cube_list_p->to_belegung_p;
				}//else
			ptr_to_belegung_p->next_p = NULL;
			if ((*input_p)[i] == line_item_p)
				val_e = mynot(line_item_p->get_only_value());
			else
				val_e = VAL_X;
			switch (val_e)
				{
				case VAL_X:
					ptr_to_belegung_p->val_c = 'X';
					break;
				case VAL_0:
					ptr_to_belegung_p->val_c = '0';
					break;
				case VAL_1:
					ptr_to_belegung_p->val_c = '1';
					break;
				default:
					error("gate_C::put_constraint_cube:  wrong value in constraint");
				}
			}//for
		}//forall
	put_constraints(&block_id_i,&output_id_i,&head_of_constraint_list_p);
		// Freigabe der Datenstruktur
	ptr_to_cube_list_p = head_of_constraint_list_p;
	while (ptr_to_cube_list_p != NULL)
		{
		ptr_to_belegung_p = ptr_to_cube_list_p->to_belegung_p;
		while (ptr_to_belegung_p != NULL)
			{
			ctest_belegung_t *old_bel_p = ptr_to_belegung_p;
			
			while (ptr_to_belegung_p->next_p != NULL)
				{
				old_bel_p = ptr_to_belegung_p;
				ptr_to_belegung_p = ptr_to_belegung_p->next_p;
				}//while
			ptr_to_belegung_p = ptr_to_cube_list_p->to_belegung_p;
			if (old_bel_p->next_p != NULL)
				{
				delete old_bel_p->next_p;
				old_bel_p->next_p = NULL;
				}//if
			if (ptr_to_cube_list_p->to_belegung_p->next_p == NULL)
				{
				delete ptr_to_cube_list_p->to_belegung_p;
				ptr_to_belegung_p = NULL;
				}//if
			}//while
		ptr_to_cube_list_p = ptr_to_cube_list_p->next_p;
		}//while
	while (head_of_constraint_list_p != NULL)
		{
		ctest_cube_list_t *old_cube_p = head_of_constraint_list_p;
		
		ptr_to_cube_list_p = head_of_constraint_list_p;
		while (ptr_to_cube_list_p->next_p != NULL)
			{
			old_cube_p = ptr_to_cube_list_p;
			ptr_to_cube_list_p = ptr_to_cube_list_p->next_p;
			}//while
		if (old_cube_p->next_p != NULL)
			{
			delete old_cube_p->next_p;
			old_cube_p->next_p = NULL;
			}//if
		if (head_of_constraint_list_p->next_p == NULL)
			{
			delete head_of_constraint_list_p;
			head_of_constraint_list_p = NULL;
			}//if
		}//while
	}//else
*/
}//put_constraint_cube

//*********************************************************************
//
//   FUNCTION-NAME: add_constraints
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: November 92
//
//   FUNCTIONAL-DESCRIPTION: Modifiziert die zwei Kuben unter
//	Beruecksichtigung von den lokalen Constraints
//
//   FORMAL PARAMETERS: gate_C *gate_p: Das Gatter
//			int cube_0_a[]: zu modifizierende 0-Kube
//			int cube_1_a[]: zu modifizierende 1-Kube
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void add_constraints(gate_C *gate_p, int cube_a[])
{
/*
int i,j;
cube_list_t *source_p,*target_p;
belegung_t *bel_s_p,*bel_t_p;

gate_p->gib_constraints(source_p,target_p);
while(source_p != NULL)
	{
	bel_s_p = source_p->to_belegung_p;
	bel_t_p = target_p->to_belegung_p;
	for (i=0;i<gate_p->no_inputs();i++,bel_s_p=bel_s_p->next_p)
		{
		if (bel_s_p->val_e == VAL_X)
			continue;
		if (((bel_s_p->val_e == VAL_1) && (cube_a[i] == 1)) ||
		    ((bel_s_p->val_e == VAL_0) && (cube_a[i] == 0)))
			for(j=0,bel_t_p=target_p->to_belegung_p;j<gate_p->no_inputs();j++,bel_t_p=bel_t_p->next_p)
				{
				if (bel_t_p->val_e == VAL_X)
					continue;
				if (bel_t_p->val_e == VAL_1)
					if (cube_a[j] == 1)
						continue;
					else if (cube_a[j] == 0)
						continue;//error("add_constraints: cube doesn`t fit");
					else
						cube_a[j] = 1;
				else if (bel_t_p->val_e == VAL_0)
					if (cube_a[j] == 0)
						continue;
					else if (cube_a[j] == 1)
						continue;//error("add_constraints: cube doesn`t fit");
					else
						cube_a[j] = 0;
				else
					error("add_constraints: wrong constraint");
				}//for
		}//for
	source_p = source_p->next_p;
	target_p = target_p->next_p;
	}//while
return;
*/
}//add_constraints















