/*
 * @(#)data.h   1.1
 * $Id: data2.h,v 2.2 1995/12/04 12:00:40 glaeser Exp $
 *
 * $Log: data2.h,v $
 * Revision 2.2  1995/12/04 12:00:40  glaeser
 * *** empty log message ***
 *
 * Revision 1.5  1995/11/24  12:55:27  corno
 * Version 2.00 create() from Edif:
 * now handles VDD, GND, generic Flip-Flops (through the .ff_type field),
 * pin names (see library.h and get_pin_pos(), accessible trough the .date_id
 * field).
 *
 * Revision 1.4  1995/11/24  12:52:50  corno
 * cleaned up definitions
 *
 */

extern "C" {
/* OBSOLETE codes DO NOT USE */
#define MMAND     0     /* codici per la lettura del .DEE */
#define MMNAND    1
#define MMOR      2
#define MMNOR     3
#define MMBUF     4
#define MMNOT     5
#define MMEXOR    30
#define MMEXNOR   31
#define MMFF      44

/* gate TYPES */
#define E_AND   0     /* codici interni */
#define E_NAND      1
#define E_OR    2
#define E_NOR   3
#define E_BUF   4
#define E_NOT   5
#define E_EXOR      6
#define E_EXNOR     7
#define E_FF   10

/* Extend FF type */
#define	FFD	0
#define	FFDR	1
#define	FFDP	2
#define	FFDRP	3

/* gate ATTRIBUTES */
#define INTERNAL   0
#define PI     1
#define PO         2

#define MAX(a,b)  (a>b)? a:b
#define MIN(c,d)  (c<d)? c:d
#define MOZ_VERSION20   20
#define MOZ_VERSION22   22
#define MOZ_VERSION23   23

#define MAX_FILENAME_LEN  80    /* lunghezza massima nome file di input      */
#define MAX_FANOUT_BRANCH 400    /* massimo fanout consentito nella rete      */
#define MAX_FANIN      50    /* massimo fanin consentito nella rete       */
#define MAX_LONG   0xffffffff   /* massimo numero intero senza segno su 32
				 * bit */
#define MAX_DOUBLE 1.7E+30  /* massimo numero in floating point su 8 byte */
#define MAX_LINE      80
#define MAX_LEN_ID        16    /* maximum length of an identifier */

/* costanti per la struttura di propagazione */
#define FINE        -1
#define PRESENT     1
#define ABSENT      0

/* valori assunti dai descritori */
#define ICS 1
#define ZERO    0
#define UNO -1

#define NULL    0

/* struttura singolo descrittore */
typedef struct
{
	char	attr,    /* PI, PO, INTERNAL */
		type;    /* AND NAND .... FF */
	int	fanin, fanout; /* number of gate inputs/outputs */
	char	*to_name;	/* name of the output net */
	int	level;		/* distance from PIs or PPIs */
	int	*to, *from;	/* pointers to arrays of gate indexes */
	char        *name;	/* gate instance name */

	char	ff_type;	/* FFD   = FF
				   FFDR  = FF with reset 
				   FFDP  = FF with preset
				   FFDRP = FF with reset and preset */
	int	gate_id;	/* index to a structure describing library */
}DESCRIPTOR;

/* prototype della create() */
int create (char *name) ;

/* global variables */

int n_descr ;	/* number of gates */
DESCRIPTOR       *descr;       /* gate structures */

int              n_pi;
int              n_po;
int              n_ff;
int 		max_level;

int      *pi_array;
int      *po_array;
int      *ppi_array;
extern int      *ppo_array;
}
