//*********************************************************************
//
//   FILE-NAME: errors.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet error und debug Routinen
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include "extern.h"
#include "protocol_stack_C.h"
#include "objective_liste_C.h"
#include "gate_liste_C.h"
#include "line_liste_C.h"
#include "gate_C.h"
#include "line_C.h"
#include "modify.h"

extern protocol_stack_C protocol_C;
extern objective_liste_C current_objectives_C;
extern objective_liste_C head_objectives_C;
extern objective_liste_C fanout_objectives_C;
#if DEBUG
extern opt_line_liste_C optional_lines_C;
#endif

void warning(string_C error_sC)
	{	// gibt Warnung mit dem Inhalt error_sC aus
	ofstream datei_F(string_C(schaltungsname_s) + ".stat",ios::app);
	static boolean first_entry_b = TRUE;
	
	cout << "\nWARNING:  ";
	cout << error_sC << "\n" << flush;
	if (first_entry_b == TRUE)
		{
		datei_F << "WARNING:  ";
		first_entry_b = FALSE;
		}//if
	datei_F << error_sC << "\n";
	datei_F.close();
	}

void print_all()
	{   // gibt alle gates, lines, inputs und outputs aus
	cout << "Print the hole Datastructure in .debug File\n" << flush;
	gate_C *akt_gate_p;
	line_C *akt_line_p;
	ofstream errdat_F(string_C(schaltungsname_s) + ".debug");
	int i;

	errdat_F << "******************** Gatter ***********************\n";
	for (i=0;i<gates_C.no_elements();i++)
		{
		akt_gate_p = gates_C[i];
		akt_gate_p->print_all(errdat_F);
		}//while

	errdat_F << "******************** Signale ***********************\n";
	for (i=0;i<lines_C.no_elements();i++)
		{
		akt_line_p = lines_C[i];
		akt_line_p->print_all(errdat_F);
		}//while

	errdat_F << "******************** Eingaenge ***********************\n";
	for (i=0;i<input_lines_C.no_elements();i++)
		{
		akt_line_p = input_lines_C[i];
		akt_line_p->print_all(errdat_F);
		}//while

	errdat_F << "******************** Ausgaenge ***********************\n";
	for (i=0;i<output_lines_C.no_elements();i++)
		{
		akt_line_p = output_lines_C[i];
		akt_line_p->print_all(errdat_F);
		}//while
	errdat_F.close();
	}//print_all

void error(string_C error_sC)
	{	// gibt Fehler mit dem Inhalt error_sC aus und verlaesst das Programm
	ofstream datei_F(string_C(schaltungsname_s) + ".stat",ios::app);
	
	cout << "\nERROR!!!\n";
	cout << error_sC << "\n";
	datei_F << "ERROR!!!\t\t";
	datei_F << error_sC << "\n";
	datei_F.close();
	print_all();
	abort();
	}


void print_statistic()
{	// gibt Statistik der Schaltung aus
ofstream stat_F(string_C(schaltungsname_s) + ".stat");

stat_F << "Number of gates:   " << statistic_u.number_gates_i << "\n";
stat_F << "Number of Or gates:   " << statistic_u.number_or_gates_i << "\n";
stat_F << "Number of And gates:   " << statistic_u.number_and_gates_i << "\n";
stat_F << "Number of Nand gates:   " << statistic_u.number_nand_gates_i << "\n";
stat_F << "Number of Nor gates:   " << statistic_u.number_nor_gates_i << "\n";
stat_F << "Number of Exor gates:   " << statistic_u.number_exor_gates_i << "\n";
stat_F << "Number of Drivers:   " << statistic_u.number_drivers_i << "\n";
stat_F << "Number of Inverters:   " << statistic_u.number_inverters_i << "\n";
stat_F << "Number of Blocks (Transistor Nets or Complex gates):   " << statistic_u.number_blocks_i << "\n";
stat_F << "Number of Flip-Flops:   " << statistic_u.number_flipflops_i << "\n";
stat_F << "Number of Signals:   " << statistic_u.number_lines_i << "\n";
stat_F << "Number of primary inputs:   " << statistic_u.number_inputs_i << "\n";
stat_F << "Number of primary outputs:   " << statistic_u.number_outputs_i << "\n";
stat_F << "Number of Fanout gates:   " << statistic_u.number_fanouts_i << "\n";
stat_F << "Number of Fanout branches:   " << statistic_u.number_fanout_branches_i << "\n";
stat_F << "Number of target faults:   " << 2 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i) << "\n";
stat_F << "Feedback in circuit:   " << statistic_u.feedback_b << "\n";

stat_F.close();
}//print_statistic
