//*********************************************************************
//
//   FILE-NAME: fault_simu.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet die Hauptroutinen fuer die
//	Fehlersimulation sowie den hazard Test
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include <sys/types.h>
#include <sys/times.h>
#include "extern.h"
#include "line_value_liste_C.h"
#include "line_line_liste_C.h"
#include "protocol_stack_C.h"
#include "line_C.h"
#include "gate_liste_C.h"
#include "gate_C.h"
#include "line_liste_C.h"
#include "modify.h"

extern fan_result_t implication();
boolean robustness_test(line_C*,value_t);
extern value_t mynot(value_t);
extern void add_time(clock_t&);
extern line_liste_C implication_line_C;

extern protocol_stack_C protocol_C;
extern line_liste_C unjustified_bound_line_C;
extern line_value_liste_C zielfehler_C;
extern line_value_liste_C hilf_C;
extern line_line_liste_C zielfehler2_C;
extern boolean hazard_test_ein_b;
extern boolean hazard_occured_b;
extern boolean only_stuck_at_test_b;
extern boolean stuck_at_test_without_branches_b;
extern boolean transition_test_b;
extern boolean stuck_open_test_b;
extern boolean iddq_stuck_on_test_b;
extern boolean only_iddq_test_b;
extern boolean bridging_iddq_b;
extern boolean bridging_b;
extern boolean ctest_pattern_b;
extern boolean init_pattern_b;
void ctest_fault_simulation(gate_C *);
void analyse_signal_path(line_C *);
extern line_liste_C d_front_C;
extern line_liste_C common_line_liste_C;
extern line_liste_C tmp_line_liste_C;
extern void mark_all(line_C *,AEQUIVALENZ_TYP);
extern void reset_net(fan_result_t);
extern line_C *ziel_line_p;
extern int no_testpattern_i;
extern int elements_to_test_i;
ofstream simu_F;
extern clock_t cpu_sons_l,cpu_fs_l;
boolean simulate_pattern_called_b = FALSE;
line_line_C *simulated_element_p;
line_C *appoint_propagation_signal(line_C *, line_C *);
//extern line_C signal_to_propagate(line_C *, line_C *);
//*********************************************************************
//
//   FUNCTION-NAME: check_iddq_test
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft den Test an der entsprechenden Line
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void line_C::check_iddq_test(value_t value_e)
{
if (bridging_iddq_b == TRUE)
   {
   if (((good_value_e == VAL_0) && (simulated_element_p->line2_p->good_value_e == VAL_1)) ||
       ((good_value_e == VAL_1) && (simulated_element_p->line2_p->good_value_e == VAL_0)))
      {
      simulated_element_p->set_tested();
      elements_to_test_i--;
      }//if
   return;
   }//if
if (test_done_b == TRUE)
	return;
if (iddq_stuck_on_test_b == TRUE)
   {
   if ((prime_output_b == FALSE) && (value_e != VAL_X))
	{
	gate_C *follow_p = nachfolger_p->gib_only_gate();
	line_C *line_item_p;
	boolean stuck_open_init_b = TRUE;

			//nicht kontrollierende Werte muessen gefunden werden am Nachfolger
	switch ((*nachfolger_p)[0]->gib_type())
		{
		case AND:
		case NAND:
			{forall(line_item_p,*follow_p->gib_inputs())
				{
				if (line_item_p == this)
					continue;
				if (line_item_p->get_good_value() == VAL_1)
					continue;
				else
					stuck_open_init_b = FALSE;
				}}//forall
			break;
		case OR:
		case NOR:
			{forall(line_item_p,*follow_p->gib_inputs())
				{
				if (line_item_p == this)
					continue;
				if (line_item_p->get_good_value() == VAL_0)
					continue;
				else
					stuck_open_init_b = FALSE;
				}}//forall
			break;
		default:
			break;
		}//switch
	if (stuck_open_init_b == FALSE)
		return;
	}//if
   if (value_e == VAL_X)
	{
	ctest_fault_simulation((*vorgaenger_p)[0]);
	return;
	}//if
   }//if
if ((good_value_e == VAL_0) && ((value_e == VAL_1) || (value_e == VAL_U0)))
	{
	s_a_1_test_b = TRUE;
	s_a_1_aborted_b = FALSE;
	falling_test_b = TRUE;		// nur zur Sicherheit
	if (iddq_stuck_on_test_b == TRUE)
		{
		hilf_C.fuege_ein(this,VAL_U0);
		simu_F << "I-s-on-0: "<< name_sC << ", ";
		}//if
	else
		{
		hilf_C.fuege_ein(this,VAL_1);
		simu_F << "s-a-1: "<< name_sC << ", ";
		}//else
	}//if
if ((good_value_e == VAL_1) && ((value_e == VAL_0) || (value_e == VAL_U1)))
	{
	s_a_0_test_b = TRUE;
	s_a_0_aborted_b = FALSE;
	rising_test_b = TRUE;          // nur zur Sicherheit
	if (iddq_stuck_on_test_b == TRUE)
		{
		hilf_C.fuege_ein(this,VAL_U1);
		simu_F << "I-s-on-1: "<< name_sC << ", ";
		}//if
	else
		{
		hilf_C.fuege_ein(this,VAL_0);
		simu_F << "s-a-0: "<< name_sC << ", ";
		}//else
	}//if
if ((prime_input_b == TRUE) || ((*vorgaenger_p)[0]->gib_type() != BLOCK) || (only_iddq_test_b == TRUE))
   {
   if ((s_a_1_test_b == TRUE) && (s_a_0_test_b == TRUE))
	{
	stuck_at_test_b = TRUE;
	test_done_b = TRUE;
	}//if
   }//if
}//check_iddq_test

//*********************************************************************
//
//   FUNCTION-NAME: iddq_fault_simulation
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft, ob mit dem zuletzt durchgefuehrten Test
//	auch andere Fehler bezgl. IDDQ ueberdeckt wurden. Diese werden dann als
//	getestet markiert.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void iddq_fault_simulation()
{
line_C *line_item_p;
line_value_t *liva_p;

#ifndef GENERATE_X_PATTERN
{forall(line_item_p,input_lines_C)
	if (line_item_p->get_good_value() == VAL_X)
		{
		if (line_item_p->get_init_value() != VAL_X)
			line_item_p->set_good_value(mynot(line_item_p->get_init_value())); // Vielleicht sollte man es auch mit VAL_1 versuchen
		else
			line_item_p->set_good_value(VAL_0);
		implication_line_C.fuege_ein(line_item_p);
		}//if
}
{forall(line_item_p,implication_line_C)
	if (line_item_p->is_primary_output() == FALSE)
		if ((*line_item_p->nachfolger())[0]->fast_forward_implication() == INCONSISTENT)
			error("fault_simulation: Implikation inconsistent");}
implication_line_C.loesche_liste();
#endif
if ((bridging_iddq_b == FALSE) && (bridging_b == FALSE))
   {
   forall(liva_p,zielfehler_C)
	liva_p->line_p->check_iddq_test(liva_p->val_e);
   }//if
else
   {
   forall(simulated_element_p,zielfehler2_C)
      if ((simulated_element_p->test_required() == TRUE) || (simulated_element_p->is_aborted() == TRUE))
	 simulated_element_p->line1_p->check_iddq_test(VAL_X);
   }//else
}//iddq_fault_simulation

//*********************************************************************
//
//   FUNCTION-NAME: mark_robust_signals
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: Mai 92
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft, welche Signale mit dem zuletzt durchgefuehrten Test
//	hazardfrei sind.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void mark_robust_signals()
{
line_C *line_item_p;

{forall(line_item_p,lines_C)
	if (line_item_p->get_good_value() == VAL_1)
		line_item_p->set_good_value(VAL_1X);
	else if (line_item_p->get_good_value() == VAL_0)
		line_item_p->set_good_value(VAL_0X);}
{forall(line_item_p,input_lines_C)
	if (line_item_p->get_good_value() == VAL_1X)
		line_item_p->set_good_value(VAL_1S);
	else if (line_item_p->get_good_value() == VAL_0X)
		line_item_p->set_good_value(VAL_0S);}
{forall(line_item_p,input_lines_C)
	if (line_item_p->is_primary_output() == FALSE)
		(*line_item_p->nachfolger())[0]->mark_robust_signals();}
}//mark_robust_signals

//*********************************************************************
//
//   FUNCTION-NAME: mark_robust_signals
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: Mai 92
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft, welche Signale mit dem zuletzt durchgefuehrten Test
//	hazardfrei sind.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::mark_robust_signals()
{
line_C *line_item_p;
line_C *gate_output_line_p = (*output_p)[0];

if ((gate_output_line_p->get_good_value() != VAL_1X) && (gate_output_line_p->get_good_value() != VAL_0X))
	return;
{forall(line_item_p,*input_p)
	if ((line_item_p->get_good_value() == VAL_1X) || (line_item_p->get_good_value() == VAL_0X))
		return;}
if ((((gate_output_line_p->get_good_value() == VAL_1X) &&
      (gate_output_line_p->get_init_value() == VAL_0)) ||
     ((gate_output_line_p->get_good_value() == VAL_0X) &&
      (gate_output_line_p->get_init_value() == VAL_1))) &&
    (this->gib_type() != FANOUT))
	{
	if (gate_output_line_p->get_good_value() == VAL_0X)
		gate_output_line_p->set_good_value(VAL_0S);
	else
		gate_output_line_p->set_good_value(VAL_1S);
	}//if
else switch(gate_e)
	{
	case AND:
		{forall(line_item_p,*input_p)
                 {
		    if ((line_item_p->get_good_value() == VAL_0S) &&
			(line_item_p->get_init_value() == VAL_0))
			{
			gate_output_line_p->set_good_value(VAL_0S);
			break;
			}//if
		    if ((line_item_p->get_good_value() == VAL_1) &&
		       (gate_output_line_p->get_good_value() == VAL_1X))
			{
			gate_output_line_p->set_good_value(VAL_1);
			break;
			}//if
		    }}//forall
		if (gate_output_line_p->get_good_value() == VAL_1X)
			gate_output_line_p->set_good_value(VAL_1S);
		else if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0);
		break;
	case OR:
		{forall(line_item_p,*input_p)
                 {
		    if ((line_item_p->get_good_value() == VAL_1S) &&
			(line_item_p->get_init_value() == VAL_1))
			{
			gate_output_line_p->set_good_value(VAL_1S);
			break;
			}//if
		    if ((line_item_p->get_good_value() == VAL_0) &&
		       (gate_output_line_p->get_good_value() == VAL_0X))
			{
			gate_output_line_p->set_good_value(VAL_0);
			break;
			}//if
		    }}//forall
		if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0S);
		else if (gate_output_line_p->get_good_value() == VAL_1X)
			gate_output_line_p->set_good_value(VAL_1);
		break;
	case NAND:
		{forall(line_item_p,*input_p)
                 {
		    if ((line_item_p->get_good_value() == VAL_0S) &&
			(line_item_p->get_init_value() == VAL_0))
			{
			gate_output_line_p->set_good_value(VAL_1S);
			break;
			}//if
		    if ((line_item_p->get_good_value() == VAL_1) &&
		       (gate_output_line_p->get_good_value() == VAL_0X))
			{
			gate_output_line_p->set_good_value(VAL_0);
			break;
			}//if
		    }}//forall
		if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0S);
		else if (gate_output_line_p->get_good_value() == VAL_1X)
			gate_output_line_p->set_good_value(VAL_1);
		break;
	case NOR:
		{forall(line_item_p,*input_p)
                 {
		    if ((line_item_p->get_good_value() == VAL_1S) &&
			(line_item_p->get_init_value() == VAL_1))
			{
			gate_output_line_p->set_good_value(VAL_0S);
			break;
			}//if
		    if ((line_item_p->get_good_value() == VAL_0) &&
		       (gate_output_line_p->get_good_value() == VAL_1X))
			{
			gate_output_line_p->set_good_value(VAL_1);
			break;
			}//if
		    }}//forall
		if (gate_output_line_p->get_good_value() == VAL_1X)
			gate_output_line_p->set_good_value(VAL_1S);
		else if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0);
		break;
	case FANOUT:
	case DRIVER:
		{forall(line_item_p,*output_p)
		   {
		   line_item_p->set_good_value((*input_p)[0]->get_good_value());
		   }}//forall
		break;
	case INVERTER:
		gate_output_line_p->set_good_value(mynot((*input_p)[0]->get_good_value()));
		break;
	case EXOR:
		value_t val_0;
		value_t val_1;

		val_0 = (*input_p)[0]->get_good_value();
		val_1 = (*input_p)[1]->get_good_value();
		if ((((val_0 == VAL_0S) && ((*input_p)[0]->get_init_value() == VAL_0)) ||
		     ((val_0 == VAL_1S) && ((*input_p)[0]->get_init_value() == VAL_1))) &&
		    (((val_1 == VAL_0S) && ((*input_p)[1]->get_init_value() == VAL_0)) ||
		     ((val_1 == VAL_1S) && ((*input_p)[1]->get_init_value() == VAL_1))))
			if (gate_output_line_p->get_good_value() == VAL_1X)
				gate_output_line_p->set_good_value(VAL_1S);
			else
				gate_output_line_p->set_good_value(VAL_0S);
		else
			if (gate_output_line_p->get_good_value() == VAL_1X)
				gate_output_line_p->set_good_value(VAL_1);
			else
				gate_output_line_p->set_good_value(VAL_0);
		break;
	case BLOCK:
	  {
		int j;
		value_t value_e;
		cube_list_t *cube_list_p;
		belegung_t *belegung_p;
		boolean hazardfrei_b = TRUE;

		if (gate_output_line_p->get_good_value() == VAL_0X)
			cube_list_p = block_cubes_a[1];
		else
			cube_list_p = block_cubes_a[0];
		for (;cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
		   {
		   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
			{
			if ((((*input_p)[j]->get_good_value() == VAL_0S) && ((*input_p)[j]->get_init_value() == VAL_0)) ||
			    (((*input_p)[j]->get_good_value() == VAL_1S) && ((*input_p)[j]->get_init_value() == VAL_1)))
				value_e = (*input_p)[j]->get_init_value();
			else
				value_e = VAL_X;
			if ((value_e == VAL_X) || (belegung_p->val_e == VAL_X))
				continue;
			if ((belegung_p->val_e == VAL_0) && (value_e != VAL_0))
				break;
			if ((belegung_p->val_e == VAL_1) && (value_e != VAL_1))
				break;
			}//for
		   if (j==no_input_i)
			hazardfrei_b = FALSE;
		   }//for
		if (hazardfrei_b == TRUE)
		   if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0S);
		   else
			gate_output_line_p->set_good_value(VAL_1S);
		else
		   if (gate_output_line_p->get_good_value() == VAL_0X)
			gate_output_line_p->set_good_value(VAL_0);
		   else
			gate_output_line_p->set_good_value(VAL_1);
		break;
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("mark_robust_signals: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("mark_robust_signals:  undefined gate found");
	}//switch
{forall(line_item_p,*output_p)
	if (line_item_p->is_primary_output() == FALSE)
		(*line_item_p->nachfolger())[0]->mark_robust_signals();}
}//gate_C::mark_robust_signals

//*********************************************************************
//
//   FUNCTION-NAME: fault_simulation
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft, ob mit dem zuletzt durchgefuehrten Test
//	auch andere Fehler ueberdeckt wurden. Diese werden dann als getestet markiert.
//
//   FORMAL PARAMETERS: line_C *line_p: Die gerade getestete Line
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY: Eberhard April : Simulation nur fuer Zielfehler (der Rest wird in der
//
//					    Simulation durch Fault collapsing erschlagen)
//					Funktion zum traversieren der Zielfehlerliste ohne loeschen muss
//					noch eingefuegt werden !!!!!
//*********************************************************************
void fault_simulation(line_C *line_p, value_t value_e)
{
line_C *line_item_p;
line_value_t *liva_p;
line_line_C *lili_p;
boolean korrekt_b = TRUE;

#ifndef GENERATE_X_PATTERN
{forall(line_item_p,input_lines_C)
	if (line_item_p->get_good_value() == VAL_X)
		{
		if (line_item_p->get_init_value() != VAL_X)
			line_item_p->set_good_value(mynot(line_item_p->get_init_value())); // Vielleicht sollte man es auch mit VAL_1 versuchen
		else
			line_item_p->set_good_value(VAL_0);
		implication_line_C.fuege_ein(line_item_p);
		}//if
}
{forall(line_item_p,implication_line_C)
	if (line_item_p->is_primary_output() == FALSE)
		if ((*line_item_p->nachfolger())[0]->fast_forward_implication() == INCONSISTENT)
			error("fault_simulation: Implikation inconsistent");}
implication_line_C.loesche_liste();
#endif
if ((hazard_test_ein_b == TRUE) && (robustness_test(line_p,value_e) == TRUE))
	{
	line_p->hazard_occured();
	hazard_occured_b = TRUE;
	line_p->mark_result(ABORTED_FAULT,value_e);
	}//if
if (hazard_test_ein_b == TRUE)
	mark_robust_signals();
forall(liva_p,zielfehler_C)
	{
	liva_p->line_p->geprueft_b = FALSE;
	liva_p->line_p->signal_path_exist_b = FALSE;
	}//forall
#ifndef O_FS
if (bridging_b == FALSE)
  {forall(liva_p,zielfehler_C)
    if ((korrekt_b == TRUE) && ((liva_p->line_p->geprueft_b == FALSE)) ||
       (liva_p->line_p->signal_path_exist_b == FALSE))
        {
	protocol_type_C *prot_item_p;

	protocol_C.loesche_liste();
	if ((liva_p->val_e != VAL_X) && (((liva_p->val_e == VAL_0) &&
					  (liva_p->line_p->get_good_value() != VAL_1) &&
					  (liva_p->line_p->get_good_value() != VAL_1S)) ||
					 ((liva_p->val_e == VAL_1) &&
					  (liva_p->line_p->get_good_value() != VAL_0) &&
					  (liva_p->line_p->get_good_value() != VAL_0S))))
		continue;
	korrekt_b = liva_p->line_p->check_generated_test(line_p,liva_p->val_e);
	if (korrekt_b == FALSE)
		error("fault_simulation: testpattern-generatin or faultsimulation is untrue");
	for(;;)
	        {
	        prot_item_p = protocol_C.pop();
	        if (prot_item_p == NULL)
	                break;
	        if (prot_item_p->line_p == NULL)
	                error("fault_simulation: Line Pointer is zero");
                prot_item_p->line_p->set_good_value(prot_item_p->old_good_value());
		}//forever
	}}//if
else
   {forall(lili_p,zielfehler2_C)
        {
	protocol_type_C *prot_item_p;
	line_C *line_weak_item_p;

	protocol_C.loesche_liste();
	if ((lili_p->line1_p->get_good_value() == VAL_X) ||
	    (lili_p->line2_p->get_good_value() == VAL_X) ||
	    (lili_p->line2_p->get_good_value() == lili_p->line1_p->get_good_value()) ||
	    (lili_p->is_tested() == TRUE) || (lili_p->is_redundant() == TRUE))
	   continue;

	line_weak_item_p = appoint_propagation_signal(lili_p->line1_p, lili_p->line2_p);

	if (line_weak_item_p == NULL)
	   continue;
	korrekt_b = exist_signal_path_to_output(line_weak_item_p,VAL_U);
 
	if (korrekt_b == TRUE)
	   {
//	   simu_F << lili_p->line1_p->get_name() << " <--> " <<  lili_p->line2_p->get_name() << endl;
	   lili_p->set_tested();
	   elements_to_test_i--;
	   }//if
	for(;;)
	        {
	        prot_item_p = protocol_C.pop();
	        if (prot_item_p == NULL)
	                break;
	        if (prot_item_p->line_p == NULL)
	                error("fault_simulation: Line Pointer is zero");
                prot_item_p->line_p->set_good_value(prot_item_p->old_good_value());
		}//forever
	}}//else
#else
#if DEBUG
   gate_C *gate_item_p;

   {forall(gate_item_p,gates_C)
	if (gate_item_p->implication() == INCONSISTENT)
		cout << "fault_simulation: Inkonsistente Belegung beim Gatter" << gate_item_p->get_name()
		     << "beim Test von Signal" << line_p->get_name() << "\n";
   }
#endif
   int dummy = 0;
   korrekt_b = line_p->check_generated_test(line_p,value_e);
   zielfehler_C.fuege_aus(line_p,line_p->get_bad_value());
   if (korrekt_b == FALSE)
	error("fault_simulation: testpattern-generatin or faultsimulation is untrue");
#endif
if (hazard_test_ein_b == TRUE)
	{
	forall(line_item_p,lines_C)
		if (line_item_p->get_good_value() == VAL_0S)
			line_item_p->set_good_value(VAL_0);
		else if (line_item_p->get_good_value() == VAL_1S)
			line_item_p->set_good_value(VAL_1);
	}//if
}//fault_simulation

//*********************************************************************
//
//   FUNCTION-NAME: appoint_propagation_signal
//
//   CREATION-DATE: 4.3.1994
//
//   Die Funktion bestimmt das zu propagierende ('schwache') Signal 
//
//*********************************************************************
line_C* appoint_propagation_signal(line_C *line1_item_p, line_C *line2_item_p)
{
gate_t gate1_e, gate2_e;

if (line1_item_p->is_primary_input() == FALSE)        // Abfrage nach Primaereingang   
   gate1_e = (*line1_item_p->vorgaenger())[0]->gib_type();
else
   gate1_e = DRIVER;
if (line2_item_p->is_primary_input() == FALSE)
   gate2_e = (*line2_item_p->vorgaenger())[0]->gib_type();
else
   gate2_e = DRIVER;

if ((gate1_e == FANOUT) || (gate2_e == FANOUT) ||
    (gate1_e == EXOR) || (gate2_e == EXOR) ||
    (gate1_e == BLOCK) || (gate2_e == BLOCK) ||
    (gate1_e == D_FLIP_FLOP) || (gate2_e == D_FLIP_FLOP) ||
    (gate1_e == D_LATCH) || (gate2_e == D_LATCH) ||
    (gate1_e == UNDEFINED_GATE) || (gate2_e == UNDEFINED_GATE))
   return(NULL);

else if ((gate1_e == AND) || (gate1_e == OR) ||
	 (gate1_e == INVERTER) || (gate1_e == DRIVER))
   if (gate2_e == NOR)
      if (line2_item_p->get_good_value() == VAL_1)
	 return(line2_item_p);
      else
	 return(NULL);
   else if (gate2_e == NAND)
      if (line2_item_p->get_good_value() == VAL_0)
	 return(line2_item_p);
      else
	 return(NULL);
   else
      return(NULL);

else if (gate1_e == NOR)
   if ((gate2_e == AND) || (gate2_e == OR) ||
       (gate2_e == INVERTER) || (gate2_e == DRIVER))
      if (line1_item_p->get_good_value() == VAL_1)
         return(line1_item_p);
      else
         return(NULL);

   else if (gate2_e == NOR)
      if (line1_item_p->get_good_value() == VAL_1)
         return(line1_item_p);
      else if (line2_item_p->get_good_value() == VAL_1)
	 return(line2_item_p);
      else
         return(NULL);
   else
      return(NULL);

else if (gate1_e == NAND)
   if ((gate2_e == AND) || (gate2_e == OR) ||
       (gate2_e == INVERTER) || (gate2_e == DRIVER))
      if (line1_item_p->get_good_value() == VAL_0)
         return(line1_item_p);
      else
         return(NULL);

   else if (gate2_e == NAND)
      if (line1_item_p->get_good_value() == VAL_0)
         return(line1_item_p);
      else if (line2_item_p->get_good_value() == VAL_0)
         return(line2_item_p);
      else
         return(NULL);
   else
      return(NULL);
else
   return(NULL);
}//appoint_propagation_signal

//*********************************************************************
//
//   FUNCTION-NAME: exist_signal_path_to_output
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft rekursiv, ob das Signal von line_p
//      am Primaerausgang sichtbar ist.
//
//   FORMAL PARAMETERS: line_C *line_p: Die entsprechende Line
//
//   IMPLICIT INPUT/OUTPUT: kegel wird bei Bloecken zerstoert. bad value wird veraendert
//
//   FUNCTION-VALUE: boolean: TRUE, wenn Signal am Ausgang sichtbar ist.
//
//   MODIFICATION-HISTORY: Signal sei jetzt D ,D_bar //Eb im Maerz
//
//			'entrekursivert von Uwe' 
//
//*********************************************************************
boolean exist_signal_path_to_output(line_C *line_p,value_t ziel_val_e)
{
line_C *gate_output_line_p;
gate_C *gate_item_p;
line_C *test_line_p;
value_t line_value_e = line_p->get_good_value(),old_value_e;
boolean fanflag_b = FALSE;
int min_D_front_plane_no_i = max_number_lines_i; //Eb!!!
line_C *hilf_D_line_p;
line_C *hilf_line_p;
boolean erfolg_b,dummy_b;

if (line_value_e == VAL_X)  //sollte es sowieso nicht mehr geben
        return(FALSE);
d_front_C.loesche_liste();
if (bridging_b == FALSE)
 {
 if ((line_value_e == VAL_1) || (line_value_e == VAL_1S))  // vor dem rekursiven Aufruf keine Simulation mehr noetig
   if ((ziel_val_e != VAL_X) && (((only_stuck_at_test_b == TRUE) && (line_p->s_a_0_test_b == TRUE)) ||
       (line_p->s_a_0_untestable_b == TRUE) || (line_p->rising_test_b == TRUE)))
         return(FALSE);
        else {
              line_p->set_good_value( VAL_D);
	      protocol_C.push(line_p,FALSE,FALSE,FALSE,FALSE,FALSE,line_value_e,VAL_D);
              d_front_C.fuege_ein(line_p);
	};

 if ((line_value_e == VAL_0) || (line_value_e == VAL_0S))   // vor dem rekursiven Aufruf 
   if ((ziel_val_e != VAL_X) && (((only_stuck_at_test_b == TRUE) && (line_p->s_a_1_test_b == TRUE)) ||
       (line_p->s_a_1_untestable_b == TRUE) || (line_p->falling_test_b == TRUE)))
         return(FALSE);
        else {
             line_p->set_good_value(VAL_D_BAR);
	      protocol_C.push(line_p,FALSE,FALSE,FALSE,FALSE,FALSE,line_value_e,VAL_D_BAR);
             d_front_C.fuege_ein(line_p);
	};
 }//if
else
   if ((line_value_e == VAL_1) || (line_value_e == VAL_1S))
      {
      line_p->set_good_value( VAL_D);
      protocol_C.push(line_p,FALSE,FALSE,FALSE,FALSE,FALSE,line_value_e,VAL_D);
      d_front_C.fuege_ein(line_p);
      }//if
   else
      {
      line_p->set_good_value( VAL_D_BAR);
      protocol_C.push(line_p,FALSE,FALSE,FALSE,FALSE,FALSE,line_value_e,VAL_D_BAR);
      d_front_C.fuege_ein(line_p);
      }//if

while (d_front_C.is_empty() == FALSE)
   {
   min_D_front_plane_no_i = max_number_lines_i;
   erfolg_b = TRUE;
   test_line_p = NULL;
   for (int i=0;i<d_front_C.no_elements();i++)
   	{
	hilf_D_line_p = d_front_C[i];
	if (hilf_D_line_p->is_primary_output() == TRUE)
		return(TRUE);
	gate_item_p = hilf_D_line_p->nachfolger()->gib_only_gate();
   	gate_output_line_p = (*gate_item_p->gib_outputs())[0];
   	if (gate_output_line_p->plane_no_i < min_D_front_plane_no_i)   //Eb!!!+
   		{
		min_D_front_plane_no_i = gate_output_line_p->plane_no_i;
		test_line_p = hilf_D_line_p ;
   		}//if
   	}//for
   if ((test_line_p == NULL) || (test_line_p->is_primary_output() == TRUE))
	continue;
   line_value_e = test_line_p->get_good_value();
   gate_item_p = test_line_p->nachfolger()->gib_only_gate();
   gate_output_line_p = (*gate_item_p->gib_outputs())[0];
   forall(hilf_D_line_p,*gate_item_p->gib_inputs())
	dummy_b = d_front_C.element_in_liste(hilf_D_line_p,TRUE);
   switch (gate_item_p->gib_type())
        {
        case AND:
		{forall(hilf_line_p,*gate_item_p->gib_inputs())
                    if ((((hilf_line_p->get_good_value() == VAL_0) ||
			  (hilf_line_p->get_good_value() == VAL_X) ||
			  (hilf_line_p->get_good_value() == VAL_0S)) && (hilf_line_p != test_line_p))
                     || ((hilf_line_p->get_good_value() == VAL_D ) &&
                        ( test_line_p->get_good_value() == VAL_D_BAR))
                     || ((hilf_line_p->get_good_value() == VAL_D_BAR ) &&
                        ( test_line_p->get_good_value() == VAL_D)))
                        erfolg_b = FALSE;
			if (erfolg_b == TRUE)
				{
				old_value_e = gate_output_line_p->get_good_value();
				gate_output_line_p->set_good_value(line_value_e); //Eb!!!
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,line_value_e);
				d_front_C.fuege_ein(gate_output_line_p);
				}//if
		}
		break;
	case OR:
                {forall(hilf_line_p,*gate_item_p->gib_inputs())
                        if ((((hilf_line_p->get_good_value() == VAL_1) ||
			      (hilf_line_p->get_good_value() == VAL_X) ||
			      (hilf_line_p->get_good_value() == VAL_1S)) && (hilf_line_p != test_line_p))
                                || ((hilf_line_p->get_good_value() == VAL_D ) &&
                                ( test_line_p->get_good_value() == VAL_D_BAR))
                             || ((hilf_line_p->get_good_value() == VAL_D_BAR ) &&
                                ( test_line_p->get_good_value() == VAL_D)))
                                erfolg_b = FALSE;
                if (erfolg_b == TRUE)
                                {
				old_value_e = gate_output_line_p->get_good_value();
                                gate_output_line_p->set_good_value(line_value_e); //Eb!!!
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,line_value_e);
                                d_front_C.fuege_ein(gate_output_line_p);
				}//if
		}
		break;
        case NAND:
                {forall(hilf_line_p,*gate_item_p->gib_inputs())
                        if ((((hilf_line_p->get_good_value() == VAL_0) ||
			      (hilf_line_p->get_good_value() == VAL_X) ||
			      (hilf_line_p->get_good_value() == VAL_0S)) && (hilf_line_p != test_line_p))
                                || ((hilf_line_p->get_good_value() == VAL_D ) &&
                                ( test_line_p->get_good_value() == VAL_D_BAR))
                             || ((hilf_line_p->get_good_value() == VAL_D_BAR ) &&
                                ( test_line_p->get_good_value() == VAL_D)))
                                erfolg_b = FALSE;
                if (erfolg_b == TRUE)
                                {
				old_value_e = gate_output_line_p->get_good_value();
                                gate_output_line_p->set_good_value(mynot(line_value_e)); //Eb!!!
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,mynot(line_value_e));
                                d_front_C.fuege_ein(gate_output_line_p);
				}//if
		}
		break;
        case NOR:
                {forall(hilf_line_p,*gate_item_p->gib_inputs())
                        if ((((hilf_line_p->get_good_value() == VAL_1) ||
			      (hilf_line_p->get_good_value() == VAL_X) ||
			      (hilf_line_p->get_good_value() == VAL_1S)) && (hilf_line_p != test_line_p))
                                || ((hilf_line_p->get_good_value() == VAL_D ) &&
                                ( test_line_p->get_good_value() == VAL_D_BAR))
                             || ((hilf_line_p->get_good_value() == VAL_D_BAR ) &&
                                ( test_line_p->get_good_value() == VAL_D)))
                                erfolg_b = FALSE;
                if (erfolg_b == TRUE)
                                {
				old_value_e = gate_output_line_p->get_good_value();
                                gate_output_line_p->set_good_value(mynot(line_value_e)); //Eb!!!
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,mynot(line_value_e));
                                d_front_C.fuege_ein(gate_output_line_p);
				}//if
		}
		break;
        case FANOUT:
                {forall(gate_output_line_p,*gate_item_p->gib_outputs())
                  {
		  d_front_C.fuege_ein(gate_output_line_p);
		old_value_e = gate_output_line_p->get_good_value();
		  gate_output_line_p->set_good_value(line_value_e); //Eb!!!
		protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,line_value_e);
		  }//forall
		}break;
        case INVERTER:
		old_value_e = gate_output_line_p->get_good_value();
                gate_output_line_p->set_good_value(mynot(line_value_e)); //Eb!!!
		protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,mynot(line_value_e));
		d_front_C.fuege_ein(gate_output_line_p);
		break;
        case DRIVER:
		{old_value_e = gate_output_line_p->get_good_value();
                gate_output_line_p->set_good_value(line_value_e);
		protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,line_value_e);
		d_front_C.fuege_ein(gate_output_line_p);
		}
		break;
        case EXOR:
                if (test_line_p == (*gate_item_p->gib_inputs())[0])
			hilf_line_p = (*gate_item_p->gib_inputs())[1];
		else
			hilf_line_p = (*gate_item_p->gib_inputs())[0];
		if ((hilf_line_p->get_good_value() == VAL_D) || (hilf_line_p->get_good_value() == VAL_D_BAR) ||
		    (hilf_line_p->get_good_value() == VAL_X))
			erfolg_b = FALSE;
		else
			{
			old_value_e = gate_output_line_p->get_good_value();
			if ((hilf_line_p->get_good_value() == VAL_0) || (hilf_line_p->get_good_value() == VAL_0S))
				{
				gate_output_line_p->set_good_value(line_value_e); //Eb!!!
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,line_value_e);
				}//if
			else   // test_value == 1
				{
				gate_output_line_p->set_good_value(mynot(line_value_e)); //Eb!!! 14.4 Hallo Uwe hier hast du
										  // das not vergessen
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,mynot(line_value_e));
				}//else
			d_front_C.fuege_ein(gate_output_line_p);
			}//else
                break;
        case BLOCK:
		line_C *old_ziel_line_p;

		old_ziel_line_p = ziel_line_p;
		old_value_e = gate_output_line_p->get_good_value();
                if ((old_value_e == VAL_0) || (old_value_e == VAL_0S))
                        {
			gate_output_line_p->set_good_value(VAL_0);
			gate_output_line_p->set_bad_value(VAL_0);
			}//if
                else if ((old_value_e == VAL_1) || (old_value_e == VAL_1S))
			{
                        gate_output_line_p->set_good_value(VAL_1);
                        gate_output_line_p->set_bad_value(VAL_1);
			}//else
                else
                        error("exist_signal_path_to_output: output of block`s not covered");
		gate_output_line_p->mark_output_kegel();
		{forall(hilf_line_p,*gate_item_p->gib_inputs())
			{
			if (hilf_line_p->get_good_value() == VAL_D)
				{
				hilf_line_p->mark_output_kegel();
				hilf_line_p->set_good_value(VAL_1);
				hilf_line_p->set_bad_value(VAL_0);
				}//if
			else if (hilf_line_p->get_good_value() == VAL_D_BAR)
				{
				hilf_line_p->mark_output_kegel();
				hilf_line_p->set_good_value(VAL_0);
				hilf_line_p->set_bad_value(VAL_1);
				}//else if
			else
				{
				hilf_line_p->clear_kegel();
				hilf_line_p->set_bad_value(VAL_X);
				}//else
			}}//forall
		ziel_line_p = input_lines_C[0];
                if (gate_item_p->fast_forward_implication() != INCONSISTENT)
			{
			ziel_line_p = old_ziel_line_p;
			{forall(hilf_line_p,*gate_item_p->gib_inputs())
				{
				if (hilf_line_p->get_bad_value() == VAL_0)
					hilf_line_p->set_good_value(VAL_D);
				else if (hilf_line_p->get_bad_value() == VAL_1)
					hilf_line_p->set_good_value(VAL_D_BAR);
				hilf_line_p->set_bad_value(VAL_X);
				}}//forall
			gate_output_line_p->set_good_value(old_value_e);
			gate_output_line_p->set_bad_value(VAL_X);
			}//if

                else
			{
			ziel_line_p = old_ziel_line_p;
			{forall(hilf_line_p,*gate_item_p->gib_inputs())
				{
				if (hilf_line_p->get_bad_value() == VAL_0)
					hilf_line_p->set_good_value(VAL_D);
				else if (hilf_line_p->get_bad_value() == VAL_1)
					hilf_line_p->set_good_value(VAL_D_BAR);
				hilf_line_p->set_bad_value(VAL_X);
				}}//forall
	                if (gate_output_line_p->get_good_value() == VAL_0)
	                        gate_output_line_p->set_good_value(VAL_D_BAR);
	                else if (gate_output_line_p->get_good_value() == VAL_1)
	                        gate_output_line_p->set_good_value(VAL_D);
			gate_output_line_p->set_bad_value(VAL_X);
			if (gate_output_line_p->get_good_value() == VAL_D)
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,VAL_D);
			else if (gate_output_line_p->get_good_value() == VAL_D_BAR)
				protocol_C.push(gate_output_line_p,FALSE,FALSE,FALSE,FALSE,FALSE,old_value_e,VAL_D_BAR);
			else
				error("exist_signal_path: fault at blocks");
                        d_front_C.fuege_ein(gate_output_line_p);
			}//else
                break;
        case D_FLIP_FLOP:
        case D_LATCH:
                error("exist_signal_path_to_output: not implemented for sequential gates");
        case UNDEFINED_GATE:
                error("exist_signal_path_to_output: undefined gate found");
	}//switch
   }//while
return(FALSE);
}//exist_signal_path_to_output

//*********************************************************************
//
//   FUNCTION-NAME: check_generated_test
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ueberprueft, ob mit dem zuletzt durchgefuehrten Test
//
//   FORMAL PARAMETERS: line_C *line_p: Die gerade getestete Line
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn kein Fehler aufgetreten ist.
//
//   MODIFICATION-HISTORY: Eberhard April 92: nachdem fuer einen Zielfehler die
//
//			   Fehlersimulation durchfgefuehrt wurde, werden in seiner Fanout-freien Zone
//				
//			   seine Aequivalenz und Dominanzbeziehungen (Faultcollapsing) zum markieren
//
//			   von mitgetesteten Fehlern genutzt(mark_aequivalenzen(this),mark_dominanzen(this)).
//
//*********************************************************************
boolean line_C::check_generated_test(line_C *line_p,value_t ziel_val_e)
{
value_t ival_e,tval_e;
boolean switch_entry_b = FALSE;
boolean stuck_open_init_b = TRUE;

ival_e = init_value_e;
tval_e = good_value_e;

if (((ziel_val_e == VAL_1) || (ziel_val_e == VAL_U0)) && ((tval_e == VAL_1) || (tval_e == VAL_1S)))
	return(TRUE);
if (((ziel_val_e == VAL_0) || (ziel_val_e == VAL_U1)) && ((tval_e == VAL_0) || (tval_e == VAL_0S)))
	return(TRUE);
if (hilf_C.element_in_liste(this,ziel_val_e) == TRUE)
	return(TRUE);
if ((stuck_open_test_b == TRUE) && (prime_output_b == FALSE) &&
    ((ziel_val_e == VAL_U0) || (ziel_val_e == VAL_U1)))
	{
	gate_C *follow_p = nachfolger_p->gib_only_gate();
	line_C *line_item_p;

	if (((ival_e == VAL_0) || (ival_e == VAL_0S) || (ival_e == VAL_D_BAR)) &&
	    ((tval_e == VAL_0) || (tval_e == VAL_0S) || (tval_e == VAL_D_BAR)))
		return(TRUE);
	if (((ival_e == VAL_1) || (ival_e == VAL_1S) || (ival_e == VAL_D)) &&
	    ((tval_e == VAL_1) || (tval_e == VAL_1S) || (tval_e == VAL_D)))
		return(TRUE);
			//nicht kontrollierende Werte muessen gefunden werden am Nachfolger
	switch ((*nachfolger_p)[0]->gib_type())
		{
		case AND:
		case NAND:
			{forall(line_item_p,*follow_p->gib_inputs())
				{
				if (line_item_p == this)
					continue;
				if ((line_item_p->get_init_value() == VAL_1) &&
				    ((line_item_p->get_good_value() == VAL_1S) ||
				     ((line_item_p->get_good_value() == VAL_1) &&
				      (hazard_test_ein_b == FALSE))))
					continue;
				else
					stuck_open_init_b = FALSE;
				}}//forall
			break;
		case OR:
		case NOR:
			{forall(line_item_p,*follow_p->gib_inputs())
				{
				if (line_item_p == this)
					continue;
				if ((line_item_p->get_init_value() == VAL_0) &&
				    ((line_item_p->get_good_value() == VAL_0S) ||
				     ((line_item_p->get_good_value() == VAL_0) &&
				      (hazard_test_ein_b == FALSE))))
					continue;
				else
					stuck_open_init_b = FALSE;
				}}//forall
			break;
		default:
			break;
		}//switch
	if (stuck_open_init_b == FALSE)
		return(TRUE);
	}//if
if ((stuck_at_test_without_branches_b == TRUE) && (prime_input_b == FALSE) &&
    (vorgaenger_p->gib_only_gate()->gib_type() == FANOUT))
	return(TRUE);
if ((tval_e == VAL_X) || (test_done_b == TRUE))
	return(TRUE);
if ((prime_input_b == TRUE) || (ziel_val_e != VAL_X) || (only_stuck_at_test_b == TRUE))
   {
   if ((tval_e == VAL_1) && (rising_test_b == TRUE))
	return(TRUE);
   if ((tval_e == VAL_0) && (falling_test_b == TRUE))
	return(TRUE);
   if ((tval_e == VAL_0) && (ival_e == VAL_0) && (s_a_1_test_b == TRUE))
	return(TRUE);
   if ((tval_e == VAL_1) && (ival_e == VAL_1) && (s_a_0_test_b == TRUE))
	return(TRUE);
   }//if

#ifndef DEBUG
if (((line_p == this) && (init_pattern_b == FALSE)) || (exist_signal_path_to_output(this,ziel_val_e) == TRUE))
	switch_entry_b = TRUE;
//if ((line_p == this) && (init_pattern_b == FALSE))
//   if (exist_signal_path_to_output(this,ziel_val_e) == FALSE)
//	error("fault in exist_signal_path: there`s no path from the target line to the output");
#else
if (exist_signal_path_to_output(this,ziel_val_e) == TRUE)
	switch_entry_b = TRUE;
else
	cout << "check_generated_test: Test fuer Signal" << name_sC << " nicht korrekt \n";
#endif
if (switch_entry_b == TRUE)
   if (ziel_val_e != VAL_X)
     {
     switch(ival_e)
	{
	case VAL_1:
		if (((tval_e == VAL_D) || (tval_e == VAL_1) || (tval_e == VAL_1S)) &&
		    (s_a_0_test_b == FALSE))
			{ //Eb!!!
			s_a_0_test_b = TRUE;
			s_a_0_aborted_b = FALSE;
			hilf_C.fuege_ein(this,VAL_0);
			simu_F << "s-a-0: "<< name_sC << ", ";
#ifndef O_FS
			mark_all(this, Stuck_at_0);
#endif
			} //Eb!!!
		else if ((stuck_open_init_b == TRUE) &&	(ziel_val_e == VAL_U0))
			{	// tval_e == VAL_D_BAR oder VAL_0
			hilf_C.fuege_ein(this,VAL_U0);
			simu_F << "falling: "<< name_sC << ", ";
			falling_test_b = TRUE;
			falling_aborted_b = FALSE;
			falling_non_robust_b = FALSE;
			}//else
                else if ((stuck_open_init_b == TRUE) && (ziel_val_e == VAL_1) && (s_a_1_test_b == FALSE))
                        { //Eb!!!
                        s_a_1_test_b = TRUE;
                        s_a_1_aborted_b = FALSE;
                        hilf_C.fuege_ein(this,VAL_1);
                        simu_F << "s-a-1: "<< name_sC << ", ";
#ifndef O_FS
                        mark_all(this, Stuck_at_1);
#endif
			} //Eb!!!
break;
	case VAL_0:
		if (((tval_e == VAL_D_BAR) || (tval_e == VAL_0) || (tval_e == VAL_0S)) &&
		    (s_a_1_test_b == FALSE))
			{ //Eb!!!
			s_a_1_test_b = TRUE;
			s_a_1_aborted_b = FALSE;
			hilf_C.fuege_ein(this,VAL_1);
			simu_F << "s-a-1: "<< name_sC << ", ";
#ifndef O_FS
			mark_all(this, Stuck_at_1);
#endif
			}
		else if ((stuck_open_init_b == TRUE) && (ziel_val_e == VAL_U1))
			{	// tval_e == VAL_D oder VAL_1
			rising_test_b = TRUE;
			rising_aborted_b = FALSE;
			rising_non_robust_b = FALSE;
			hilf_C.fuege_ein(this,VAL_U1);
			simu_F << "rising: "<< name_sC << ", ";
			}//else
                else if ((stuck_open_init_b == TRUE) && (ziel_val_e == VAL_0) && (s_a_0_test_b == FALSE))
                        { //Eb!!!
                        s_a_0_test_b = TRUE;
                        s_a_0_aborted_b = FALSE;
                        hilf_C.fuege_ein(this,VAL_0);
                        simu_F << "s-a-0: "<< name_sC << ", ";
#ifndef O_FS
                        mark_all(this, Stuck_at_0);
#endif
			} //Eb!!!
		break;
	case VAL_X:
		if ((tval_e == VAL_D) || (tval_e == VAL_1) || (tval_e == VAL_1S))
			{
			s_a_0_test_b = TRUE;
			s_a_0_aborted_b = FALSE;
			hilf_C.fuege_ein(this,VAL_0);
			simu_F << "s-a-0: "<< name_sC << ", ";
#ifndef O_FS
			mark_all(this, Stuck_at_0);
#endif
			}//Eb!!!
		else // tval_e == VAL_D_BAR oder VAL_0
			{
			s_a_1_test_b = TRUE;
			s_a_1_aborted_b = FALSE;
			hilf_C.fuege_ein(this,VAL_1);
			simu_F << "s-a-1: "<< name_sC << ", ";
#ifndef O_FS
			mark_all(this, Stuck_at_1);
#endif
			}//Eb!!!
		break;
	case UNDEFINED_VALUE:
		error("fault_simulation: undefined value in Init Value found");
	}//switch
     }//if
   else if (only_stuck_at_test_b == FALSE)
	ctest_fault_simulation((*vorgaenger_p)[0]);
if ((rising_non_robust_b == FALSE) && (falling_non_robust_b == FALSE))
	hazard_occured_b = FALSE;
if (rising_test_b == TRUE)
	{
	if (s_a_0_test_b == FALSE)
		{
		s_a_0_test_b = TRUE;
		s_a_0_aborted_b = FALSE;
		hilf_C.fuege_ein(this,VAL_0);
		simu_F << "s-a-0: "<< name_sC << ", ";
#ifndef O_FS
		mark_all(this, Stuck_at_0);//Eb!!!
#endif
		}//if
	if ((hazard_occured_b == FALSE) && (falling_test_b == TRUE) &&
	    ((prime_input_b == TRUE) ||	((*vorgaenger_p)[0]->gib_type() != BLOCK) ||
	     (only_stuck_at_test_b == TRUE)))
		test_done_b = TRUE;
	}//if
if ((falling_test_b == TRUE) && (s_a_1_test_b == FALSE))
	{
	s_a_1_test_b = TRUE;
	s_a_1_aborted_b = FALSE;
	hilf_C.fuege_ein(this,VAL_1);
	simu_F << "s-a-1: "<< name_sC << ", ";
#ifndef O_FS
	mark_all(this, Stuck_at_1);
#endif
	}//if

if ((s_a_0_test_b == TRUE) && (s_a_1_test_b == TRUE))
	{
	stuck_at_test_b = TRUE;
	if (only_stuck_at_test_b == TRUE)
		test_done_b = TRUE;
	}//if
if (((s_a_1_test_b == TRUE) && (s_a_1_untestable_b == TRUE)) ||
    ((s_a_0_test_b == TRUE) && (s_a_0_untestable_b == TRUE)) ||
    ((rising_test_b == TRUE) && (rising_untestable_b == TRUE)) ||
    ((falling_test_b == TRUE) && (falling_untestable_b == TRUE)))
	return(FALSE);
return(TRUE);
}//check_generated_test

//*********************************************************************
//
//   FUNCTION-NAME: clear_hazard_bits
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Loescht die hazard_bits,die bis zum Fehlerort gesetzt
//	sind.
//
//   FORMAL PARAMETERS: gate_C *gate_p: Das betreffende Gatter
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: NONE
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void clear_hazard_bits(gate_C *gate_p)
{
line_C *line_item_p;

if (gate_p->hazard_checked() == FALSE)
	return;
gate_p->set_hazard_bits(0);
forall(line_item_p,*gate_p->gib_outputs())
   if ((line_item_p->is_primary_output() == FALSE) && (line_item_p->is_pseudo_output() == FALSE))
	clear_hazard_bits(line_item_p->nachfolger()->gib_only_gate());
}//clear_hazard_bits

//*********************************************************************
//
//   FUNCTION-NAME: hazard_test
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Stellt fest, ob im Eingangskegel der betreffenden Line
//	ein Hazard aufgetreten ist.
//
//   FORMAL PARAMETERS: line_C *line_p: Die betreffende Line
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn Hazard im Eingangskegel aufgetreten ist.
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean hazard_test(line_C *line_p)
{
gate_C *gate_item_p;
line_C *line_item_p;
value_t controlling_value_e,ival_e,tval_e;
boolean controlling_value_found_b = FALSE;
boolean hazard_found_b = FALSE;
boolean first_switch_b = FALSE;
boolean no_hazard_b = FALSE;

if ((line_p->is_primary_input() == TRUE) || (line_p->get_init_value() == VAL_X))	//ersetes Muster
	return(FALSE);
gate_item_p = line_p->vorgaenger()->gib_only_gate();
if (gate_item_p->hazard_checked() == TRUE)
	return(gate_item_p->hazard_occured());
if (gate_item_p->gib_type() == FANOUT)
	return(hazard_test(gate_item_p->gib_inputs()->gib_only_line()));
ival_e = gate_item_p->gib_outputs()->gib_only_line()->get_init_value();
tval_e = gate_item_p->gib_outputs()->gib_only_line()->get_good_value();
if (((ival_e == VAL_0) && (tval_e != VAL_0)) || ((ival_e == VAL_1) && (tval_e != VAL_1)) ||
    (tval_e == VAL_X))
	return(FALSE);
switch (gate_item_p->gib_type())
   {
   case AND:
   case NAND:
	controlling_value_e = VAL_0;
	break;
   case OR:
   case NOR:
	controlling_value_e = VAL_1;
	break;
   case DRIVER:
   case INVERTER:
	return(hazard_test(gate_item_p->gib_inputs()->gib_only_line()));
   case EXOR:
	if (((*gate_item_p->gib_inputs())[0]->get_init_value() != (*gate_item_p->gib_inputs())[0]->get_good_value()) &&
	    ((*gate_item_p->gib_inputs())[1]->get_init_value() != (*gate_item_p->gib_inputs())[1]->get_good_value()))
		{
		gate_item_p->set_hazard_bits(2);
		return(TRUE);
		}//if
	controlling_value_e = VAL_U;
	break;
   case BLOCK:
	int j;
	value_t value_e;
	cube_list_t *cube_list_p;
	belegung_t *belegung_p;

	if (line_p->get_good_value() == VAL_0)
		cube_list_p = gate_item_p->block_cubes(1);
	else
		cube_list_p = gate_item_p->block_cubes(0);
	for (;cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
	   {
	   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<gate_item_p->no_inputs();j++,belegung_p=belegung_p->next_p)
		{
		if ((*gate_item_p->gib_inputs())[j]->get_good_value() == VAL_X)
			{
			gate_item_p->set_hazard_bits(1);
			return(FALSE);
			}//if
		if (((*gate_item_p->gib_inputs())[j]->get_good_value() == (*gate_item_p->gib_inputs())[j]->get_init_value()) &&
		    (hazard_test((*gate_item_p->gib_inputs())[j]) == FALSE))
			value_e = (*gate_item_p->gib_inputs())[j]->get_init_value();
		else
			value_e = VAL_X;
		if ((value_e == VAL_X) || (belegung_p->val_e == VAL_X))
			continue;
		if ((belegung_p->val_e == VAL_0) && (value_e != VAL_0))
			break;
		if ((belegung_p->val_e == VAL_1) && (value_e != VAL_1))
			break;
		}//for
	   if (j==gate_item_p->no_inputs())
		{
		gate_item_p->set_hazard_bits(2);
		return(TRUE);
		}//if
	   }//for
	gate_item_p->set_hazard_bits(1);
	return(FALSE);
   case FANOUT:
   case D_LATCH:
   case D_FLIP_FLOP:
	error("hazard_test: not implemented for sequential gates");
   case UNDEFINED_GATE:
	error("hazard_test: undefined gate found");
   }//switch

{forall(line_item_p,*gate_item_p->gib_inputs())
	{
	if (line_item_p->get_good_value() == VAL_X)
		continue;
	if (line_item_p->get_good_value() == controlling_value_e)
		controlling_value_found_b = TRUE;
	if ((line_item_p->get_good_value() == controlling_value_e) && (line_item_p->get_init_value() == controlling_value_e))
		{
		hazard_found_b = hazard_test(line_item_p);
		if (hazard_found_b == FALSE)
			no_hazard_b = TRUE;
		}//if
	if (no_hazard_b == TRUE)
		continue;
	if ((line_item_p->get_good_value() == controlling_value_e) && (line_item_p->get_init_value() == mynot(controlling_value_e)))
		hazard_found_b = TRUE;
	}}//forall
if (controlling_value_found_b == TRUE)
	{
	if (hazard_found_b == TRUE)
		gate_item_p->set_hazard_bits(2);
	else
		gate_item_p->set_hazard_bits(1);
	return(hazard_found_b);
	}//if
{forall(line_item_p,*gate_item_p->gib_inputs())
	{
	if (hazard_found_b == TRUE)
		continue;
	if (line_item_p->get_good_value() == VAL_X)
		continue;
	hazard_found_b = hazard_test(line_item_p);
	}}//forall
if (hazard_found_b == TRUE)
	gate_item_p->set_hazard_bits(2);
else
	gate_item_p->set_hazard_bits(1);
return(hazard_found_b);
}//hazard_test

//*********************************************************************
//
//   FUNCTION-NAME: robustness_test
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Stellt fest, ob im Eingangskegel des nachfolgenden Gatters
//	von line_p ein Hazard aufgetreten ist.
//
//   FORMAL PARAMETERS: line_C *line_p: Die betreffende Line
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn Hazard im Eingangskegel aufgetreten ist.
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean robustness_test(line_C *line_p,value_t ziel_val_e)
{
gate_C *gate_item_p;
line_C *line_item_p;
boolean haz_b = FALSE;

if (line_p->is_primary_output() == TRUE)
	return(FALSE);
if (ziel_val_e != VAL_X)
        gate_item_p = line_p->nachfolger()->gib_only_gate();
else
        gate_item_p = line_p->vorgaenger()->gib_only_gate();
forall(line_item_p,*gate_item_p->gib_inputs())
   if (haz_b == FALSE)
	haz_b = hazard_test(line_item_p);
return(haz_b);
}//robustness_test

//*********************************************************************
//
//   FUNCTION-NAME: ctest_fault_simulation
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ruft CTEST auf fuer die Fehlersimulation des gegebenen
//	Blocks.
//
//   FORMAL PARAMETERS: gate_C *gate_p: Der betreffende Block
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: NONE
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void ctest_fault_simulation(gate_C *gate_p)
{
/*
ctest_belegung_t *init_cube_p,*test_cube_p;
ctest_belegung_t *init_cube_ptr,*test_cube_ptr;
int block_id_i,output_id_i,init_value_i,i;
int status_i,instance_id_i;

if ((gate_p->gib_outputs()->gib_only_line()->get_init_value() == VAL_X) ||
    ((gate_p->gib_outputs()->gib_only_line()->get_init_value() == VAL_1) &&
     ((gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_1) ||
      (gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_D) ||
      (gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_1S))) ||
    ((gate_p->gib_outputs()->gib_only_line()->get_init_value() == VAL_0) &&
     ((gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_0) ||
      (gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_D_BAR) ||
      (gate_p->gib_outputs()->gib_only_line()->get_good_value() == VAL_0S))))
	return;
switch (gate_p->gib_outputs()->gib_only_line()->get_init_value())
	{
	case VAL_0:
	case VAL_0S:
		init_value_i = 0;
		break;
	case VAL_1:
	case VAL_1S:
		init_value_i = 1;
		break;
	default:
		error("ctest_fault_simulation: wrong value at the output of the block");
	}//switch

block_id_i = gate_p->get_name().gib_id();
if (block_id_i == -1)
        {
	gate_p->get_name().gib_mixed_circuit_id(instance_id_i,block_id_i);
	select_instance(&instance_id_i,&status_i);
	if (status_i != 0)
		error("ctest_fault_simulation: select_instance terminated with error status");
	}//if
output_id_i = gate_p->gib_outputs()->gib_only_line()->get_name().gib_id();

	// Speicher reservieren
init_cube_p = new ctest_belegung_t;
test_cube_p = new ctest_belegung_t;
init_cube_ptr = init_cube_p;
test_cube_ptr = test_cube_p;
init_cube_ptr->next_p = NULL;
test_cube_ptr->next_p = NULL;
for (i = 1;i<gate_p->no_inputs();i++)
	{
	init_cube_ptr->next_p = new ctest_belegung_t;
	test_cube_ptr->next_p = new ctest_belegung_t;
	init_cube_ptr = init_cube_ptr->next_p;
	test_cube_ptr = test_cube_ptr->next_p;
	init_cube_ptr->next_p = NULL;
	test_cube_ptr->next_p = NULL;
	}//for

	// Kuben belegen
init_cube_ptr = init_cube_p;
test_cube_ptr = test_cube_p;
for (i = 0;i<gate_p->no_inputs();i++)
	{
	switch ((*gate_p->gib_inputs())[i]->get_init_value())
		{
		case VAL_0:
		case VAL_0S:
			init_cube_ptr->val_c = '0';
			break;
		case VAL_1:
		case VAL_1S:
			init_cube_ptr->val_c = '1';
			break;
		default:
			error("ctest_fault_simulation: wrong value at some input of the block");
		}//switch
	switch ((*gate_p->gib_inputs())[i]->get_good_value())
		{
		case VAL_0:
			test_cube_ptr->val_c = 'J';
			break;
		case VAL_0S:
			test_cube_ptr->val_c = '0';
			break;
		case VAL_1:
			test_cube_ptr->val_c = 'T';
			break;
		case VAL_1S:
			test_cube_ptr->val_c = '1';
			break;
		default:
			error("ctest_fault_simulation: wrong value at some input of the block");
		}//switch
	init_cube_ptr = init_cube_ptr->next_p;
	test_cube_ptr = test_cube_ptr->next_p;
	}//for
simulate_pattern(&block_id_i,&output_id_i,&init_value_i,&init_cube_p,&test_cube_p);
if (init_value_i)
	simulate_pattern_called_b = TRUE;

//printf("MILEF: BLOCK_ID %d\nNumber testpattern: ",block_id_i);
//printf("%d\nRemaining: %d",no_testpattern_i,zielfehler_C.no_elements());
//printf("\nZielfehler: %s\n",(char*)ziel_line_p->get_name());
	// Speicher freigeben
while (init_cube_p->next_p != NULL)
	{
	ctest_belegung_t *old_init_p;
	ctest_belegung_t *old_test_p;
                                                                  	
	init_cube_ptr = init_cube_p;
	test_cube_ptr = test_cube_p;
	while (init_cube_ptr->next_p != NULL)
		{
		old_init_p = init_cube_ptr;
		old_test_p = test_cube_ptr;
		init_cube_ptr = init_cube_ptr->next_p;
		test_cube_ptr = test_cube_ptr->next_p;
		}//while
	delete old_init_p->next_p;
	old_init_p->next_p = NULL;
	delete old_test_p->next_p;
	old_test_p->next_p = NULL;
	}//while
delete init_cube_p;
delete test_cube_p;
*/
}//ctest_fault_simulation

void simulate_circuit()
{
ifstream pattern_F;
char s[stringsize_i],*t,c;
line_C *line_item_p;
line_line_C *lili_p;

cout << "\tPattern File is " << (char*)(string_C(schaltungsname_s) + ".pat") << "\n" << flush;
pattern_F.open((char*)(string_C(schaltungsname_s) + ".pat"));
if (!pattern_F)
   error("simulate_circuit: Pattern File not found");
{forall(line_item_p,lines_C)
   {
   line_item_p->set_s_a_0_aborted(TRUE);
   line_item_p->set_s_a_1_aborted(TRUE);
   }}//forall
if ((bridging_iddq_b == TRUE) || (bridging_b == TRUE))
   {
   forall(lili_p,zielfehler2_C)
      lili_p->set_aborted();
   }//if
pattern_F >> s;
if (strcmp(s,"*") != 0)
   error("simulate_circuit: Pattern File corrupt (1. Line)");
pattern_F >> s;
if (strcmp(s,"Input_lines:") != 0)
   error("simulate_circuit: Pattern File corrupt (Input_lines: not found)");
forall(line_item_p,input_lines_C)
   {
   pattern_F >> s;
   if (strcmp(s,(char*)line_item_p->get_name()) != 0)
     {
      cout << "Index: " << forall_index << "     input: " << s;
      error("simulate_circuit: Order of input lines not correct");
     }//if
   }//forall
pattern_F >> s;
if (strcmp(s,"*") != 0)
   error("simulate_circuit: Pattern File corrupt (2. Line)");
pattern_F >> s;
if (strcmp(s,"Output_lines:") != 0)
   error("simulate_circuit: Pattern File corrupt (Output_lines: not found)");
{forall(line_item_p,output_lines_C)
   {
   pattern_F >> s;
   if (strcmp(s,(char*)line_item_p->get_name()) != 0)
     {
      cout << "Index: " << forall_index << "     Output: " << s;
      warning("simulate_circuit: Order of output lines not correct");
     }//if
   }}//forall
t = new char[input_lines_C.no_elements()+1];
while (!pattern_F.eof())
   {
   pattern_F >> t;
   if (t[0] == '*')
      {
      c = 'a'; 	// any dummy != \n
      while ((c!='\n') && (!pattern_F.eof()))
      	c = pattern_F.get();
      continue;
      }//if
   forall(line_item_p,input_lines_C)
      switch (t[forall_index])
	{
      	case '0':
	   line_item_p->set_good_value(VAL_0);
	   if (line_item_p->is_primary_output() == FALSE)
	      (*line_item_p->nachfolger())[0]->fast_forward_implication();
	   break;
      	case '1':
	   line_item_p->set_good_value(VAL_1);
	   if (line_item_p->is_primary_output() == FALSE)
	      (*line_item_p->nachfolger())[0]->fast_forward_implication();
	   break;
      	case 'X':
	   line_item_p->set_good_value(VAL_X);
	   break;
      	default:
	  cout << "forall_index: " << forall_index << "     t: " << t << "\n";
	   error("simulate_circuit: Unknown Value found in pattern file");
	   }//switch
   c = 'a'; 	// any dummy != \n
   while ((c!='\n') && (!pattern_F.eof()))
      c = pattern_F.get();
   add_time(cpu_sons_l);
   if ((only_iddq_test_b == TRUE) || (iddq_stuck_on_test_b == TRUE) || (bridging_iddq_b == TRUE))
      iddq_fault_simulation();
   else
      fault_simulation(NULL,VAL_U);
   hilf_C.loesche_liste();
   add_time(cpu_fs_l);
   reset_net(SUCCESS);
   }//while
print_result();
delete[] t;
}//simulate_circuit
