//*********************************************************************
//
//   FILE-NAME: friends.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Funktionen, die in Klassen definiert sind
//	und Freunde von Klassen.
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include "extern.h"
	// Prototypen
extern void milef_add_to_line_tree(line_tree_u *&,line_C *,boolean = FALSE);
extern line_liste_C unjustified_bound_line_C;
extern boolean only_iddq_test_b;
extern boolean stuck_open_test_b;
extern boolean transition_test_b;
extern boolean only_stuck_at_test_b;
extern boolean ujust_bound_changed_b;
extern objective_liste_C fanout_objectives_C;
extern line_liste_C tmp_line_liste_C;
extern line_liste_C free_lines_C;
extern line_value_liste_C zielfehler_C;
extern line_value_liste_C hilf_C;

	// Freunde der String Klasse
string_C operator + (string_C s1_sC, string_C s2_sC)
	{
	  // Die Konkatenation zweier Strings. Vorsicht: a+b+c geht nicht.
	  // Der Ergebnisstring erhaelt die minimale Groesse.
	string_C result_sC = string_C(s2_sC.akt_groesse_i + s1_sC.akt_groesse_i);

	strcpy(result_sC.inhalt_s,s1_sC.inhalt_s);
	strcat(result_sC.inhalt_s,s2_sC.inhalt_s);
	result_sC.akt_groesse_i = s2_sC.akt_groesse_i + s1_sC.akt_groesse_i;
	return(result_sC);
	}

boolean operator == (string_C s1_sC,string_C s2_sC)
	{
	  // Vergleich zweier Strings. Ergebnis wird auf boolean abgebildet.
	if (strcmp(s2_sC.inhalt_s,s1_sC.inhalt_s) == 0)
		return(TRUE);
	else
		return(FALSE);
	}

void string_C::gib_mixed_circuit_id(int &ci_i,int &bl_i)
{
char s[stringsize_i];

sscanf(inhalt_s,"%[A-Z]x%dx%d",s,&ci_i,&bl_i);
}//gib_mixed_circuit_id

//*********************************************************************
//
//   FUNCTION-NAME: element_in_liste
//
//   CLASS: gate_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion stellt fest, ob ein Gate in der Liste
//	vorhanden ist.
//
//   FORMAL PARAMETERS: gate_C *gate_item_p: das Gatter, das gesucht wird
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn das Gatter in der Liste ist
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean gate_liste_C::element_in_liste(gate_C *gate_item_p,boolean fuege_aus_b)
{
int i=0;
gate_C *ausgefuegtes_element_p;

if (this == &gates_C)
	{
	string_C s_sC(gate_item_p->get_name());

	if (fuege_aus_b == TRUE)
		error("element_in_liste: fuege_aus in gates_C nicht erlaubt");
	gate_C *gate_item_p = search(&s_sC,milef_gate_tree_root_p);
	if (gate_item_p == NULL)
		return FALSE;
	return TRUE;
	}//if
for (;i < number_elements_i;i++)
   if (liste_a[i] == gate_item_p)
	if (fuege_aus_b == FALSE)
		return TRUE;
	else
		{
                ausgefuegtes_element_p = liste_a[i];
                break;
		}//else
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return FALSE;
liste_C::fuege_aus();
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}/*element_in_liste*/

gate_C::gate_C(string_C s_sC):object_C(s_sC)
	{
	object_type_e = GATE;
	actual_branch_i = 0;
	input_p = NULL;
	output_p = NULL;
	constraints_a[0] = NULL;
	constraints_a[1] = NULL;
	block_cubes_a[0] = NULL;
	block_cubes_a[1] = NULL;
	no_input_i = 0;
	no_output_i = 0;
	gate_e = UNDEFINED_GATE;
	feedback_b = FALSE;
	implikation_durchgefuehrt_b = FALSE;
	hazard_bit_c = 0;
	}

gate_C::~gate_C()
	{
	delete input_p;
	delete output_p;
	}

line_C::line_C(string_C s_sC,int number_of_outputs_i):object_C(s_sC)
	{
	  // Konstruktor fuer Lines, Initialisierung der line
	aequiklass_at_0_nr_i = 0;
	aequiklass_at_1_nr_i = 0;
	number_i = 0;
	output_depth_i = 0;
	path_blocked_b = FALSE;
	input_kegel_b = FALSE;
	output_kegel_b = FALSE;
	prime_input_b = FALSE;
	prime_output_b = FALSE;
	pseudo_input_b = FALSE;
	pseudo_output_b = FALSE;
	fanout_b = FALSE;
	set_in_forw_imp_b = FALSE;
	feedback_b = FALSE;
	hazard_occured_b = FALSE;
	rising_test_b = FALSE;
	falling_test_b = FALSE;
	rising_aborted_b = FALSE;
	falling_aborted_b = FALSE;
	rising_untestable_b = FALSE;
	falling_untestable_b = FALSE;
	s_a_0_untestable_b = FALSE;
	s_a_1_untestable_b = FALSE;
	s_a_0_aborted_b = FALSE;
	s_a_1_aborted_b = FALSE;
	rising_non_robust_b = FALSE;
	falling_non_robust_b = FALSE;
	s_a_0_test_b = FALSE;
	s_a_1_test_b = FALSE;
	line_type_e = UNDEFINED_LINE;
	init_value_e = VAL_X;
	good_value_e = VAL_X;
	bad_value_e = VAL_X;
	only_value_e = VAL_X;
	vorgaenger_p = new gate_liste_C(1,INPUT_PORT);
	if (vorgaenger_p == NULL)
		error("no memory available");
	nachfolger_p = new gate_liste_C(number_of_outputs_i,OUTPUT_PORT);
	if (nachfolger_p == NULL)
		error("no memory available");
	object_type_e = LINE;
	plane_no_i = 0;
	geprueft_b = FALSE;
	signal_path_exist_b = FALSE;
	test_done_b = FALSE;
	stuck_at_test_b = FALSE;
	one_contby_f = 0.0;
	zero_contby_f = 0.0;
	contby_f = 0.0;
	observaby_f = 0.0;
	testaby_f = 0.0;
	static_dominator_p = NULL;
	dynamic_dominator_p = NULL;
	}

line_C::~line_C()
	{
	delete vorgaenger_p;
	delete nachfolger_p;
	}

//*********************************************************************
//
//   FUNCTION-NAME: element_in_liste
//
//   CLASS: line_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion stellt fest, ob eine Line in der Liste
//	vorhanden ist.
//
//   FORMAL PARAMETERS: line_C *line_item_p: die Line, die gesucht wird
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn die Line in der Liste ist
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean line_liste_C::element_in_liste(line_C *line_item_p,boolean fuege_aus_b)
{
int i=0;
line_C *ausgefuegtes_element_p;

if (this == &lines_C)
	{
	string_C s_sC(line_item_p->get_name());

	if (fuege_aus_b == TRUE)
		error("element_in_liste: fuege_aus in lines_C isn't allowed");
	line_C *line_item_p = search(&s_sC,milef_line_tree_root_p);
	if (line_item_p == NULL)
		return FALSE;
	return TRUE;
	}//if
for (;i < number_elements_i;i++)
   if (liste_a[i] == line_item_p)
	if (fuege_aus_b == FALSE)
		return TRUE;
	else
		{
                ausgefuegtes_element_p = liste_a[i];
                break;
		}//else
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return FALSE;
liste_C::fuege_aus();
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}/*element_in_liste*/

boolean line_value_liste_C::element_in_liste(line_C *line_item_p,value_t val_e,boolean fuege_aus_b)
{
int i=0;
line_value_t *ausgefuegtes_element_p;

for (;i < number_elements_i;i++)
   if ((liste_a[i]->line_p == line_item_p) && (liste_a[i]->val_e == val_e))
	if (fuege_aus_b == FALSE)
		return TRUE;
	else
		{
                ausgefuegtes_element_p = liste_a[i];
                break;
		}//else
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return FALSE;
liste_C::fuege_aus();
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}/*element_in_liste*/

line_value_t* line_value_liste_C::find_a_aequi_class_member(int i)
{
int j;
for (j=0 ; j < number_elements_i ; j++)
   if (((liste_a[j]->line_p->gib_aequiklass_at_0_nr_i() == i ) && (liste_a[j]->val_e == VAL_0))
       || ((liste_a[j]->line_p->gib_aequiklass_at_1_nr_i() == i ) && (liste_a[j]->val_e == VAL_1)))
		return this->liste_a[j];

return NULL;
}

//*********************************************************************
//
//   FUNCTION-NAME: search
//
//   CLASS: line_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion sucht rekursiv eine Line in dem AVL Baum, die 
//	den vorgegebenen Namen hat.
//
//   FORMAL PARAMETERS: string_C name_sC: der String, der gesucht wird
//			line_tree_u *tree_p: AVL Baum mit Lines
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: line_C*: das Gatter mit entsprechendem Namen
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
line_C *search(string_C *name_p,line_tree_u *tree_p)
{
if (tree_p == NULL)
	return(NULL);
if (*name_p == tree_p->line_p->get_name())
	return(tree_p->line_p);
if (strcmp((char *)*name_p,(char *)tree_p->line_p->get_name()) < 0)
	return(search(name_p,tree_p->left));
else // >0 bleibt uebrig
	return(search(name_p,tree_p->right));
}/*element_in_liste*/

gate_C *search(string_C *name_p,gate_tree_u *tree_p)
{
if (tree_p == NULL)
	return(NULL);
if (*name_p == tree_p->gate_p->get_name())
	return(tree_p->gate_p);
if (strcmp((char *)*name_p,(char *)tree_p->gate_p->get_name()) < 0)
	return(search(name_p,tree_p->left));
else // >0 bleibt uebrig
	return(search(name_p,tree_p->right));
}/*element_in_liste*/

//*********************************************************************
//
//   FUNCTION-NAME: belege_gate
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Dem Gatter werden Werte zugewiesen. Gatter Typ
//	Anzahl Ein- und Ausgaenge werden belegt, sowie Stringlisten dafuer
//	Alloziiert.
//
//   FORMAL PARAMETERS: gate_t gate_type_e: der Typ des Gatters (AND, OR,...)
//		int no_inputs_i: Anzahl der Eingaenge
//		int no_outputs_i: Anzahl der Ausgaenge
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::belege_gate(gate_t gate_type_e,int no_inputs_i,int no_outputs_i)
	{
	gate_e = gate_type_e;
	no_input_i = no_inputs_i;
	no_output_i = no_outputs_i;
	input_p = new line_liste_C(no_inputs_i,INPUT_PORT);
	if (input_p == NULL)
		error("no memory available");
	output_p = new line_liste_C(no_outputs_i,OUTPUT_PORT);
	if (output_p == NULL)
		error("no memory available");
	return;
	}

//*********************************************************************
//
//   FUNCTION-NAME: entnehme
//
//   CLASS: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Der erste String wird aus der Liste genommen
//	und Ausgegeben. Das Element wird in der Liste geloescht. (zerstoerendes
//	Lesen). Die Listenindizes aller Element werden dann herabgesetzt um 1.
//
//   FORMAL PARAMETERS: NONE
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: string_C: der entsprechende String
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
string_C stringliste_C::entnehme()
	{
	string_C s_sC = string_C(stringsize_i);
	string_C *hilf_p;

	if (listengroesse_i == 0)
		return("");
	s_sC = *liste_a[0];
	listengroesse_i--;
	hilf_p = liste_a[0];
	for (int i=0;i<listengroesse_i;i++)
		liste_a[i] = liste_a[i + 1];
	liste_a[listengroesse_i] = hilf_p;
	return(s_sC);
	}

//*********************************************************************
//
//   FUNCTION-NAME: add_element
//
//   CLASS: stringliste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Der String wird ans Ende der Liste angehaengt.
//	listengroesse_i wird um 1 erhoeht
//
//   FORMAL PARAMETERS: string_C s_sC: der entsprechende String
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void stringliste_C::add_element(string_C s_sC)
{
char *s_s = s_sC;
	
if (listengroesse_i == max_listengroesse_i)
	{
	liste_a[listengroesse_i] = new string_C();
	if (liste_a[listengroesse_i] == NULL)
		error("no memory available");
	*liste_a[listengroesse_i] = s_s;
	max_listengroesse_i++;
	}//if
else
	*liste_a[listengroesse_i] = s_s;
listengroesse_i++;
}

//*********************************************************************
//
//   FUNCTION-NAME: fuege_ein
//
//   CLASS: gate_liste_C (line_liste_C)
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ein(e) Gate (Line) wird ans Ende der Liste eingefuegt
//
//   FORMAL PARAMETERS: gate_C *gate_item_p: das entsprechende Gatter
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_liste_C::fuege_ein(gate_C *gate_item_p)
{
if (this == &gates_C) // baut den AVL Baum fuer gates_C auf
	milef_add_to_gate_tree(milef_gate_tree_root_p,gate_item_p);
liste_C::fuege_ein();
liste_a[number_elements_i - 1] = gate_item_p;
return;
}/*fuege_ein*/

void line_liste_C::fuege_ein(line_C *line_item_p)
{
#if DEBUG
if (this->element_in_liste(line_item_p) == TRUE)
	{
	warning("fuege_ein: Line is already in list, is not inserted");
	return;
	}//if
if (this == &unjustified_bound_line_C)
	if (line_item_p->get_test_value() == VAL_X)
		error("line_liste_C::fuege_ein: Unjustified bound Line has Test Value VAL_X");
	else if (element_in_liste(line_item_p) == TRUE)
		error("line_liste_C::fuege_ein: Unjustified bound Line was already in Liste");
#endif
if (this == &lines_C) // baut den AVL Baum fuer lines_C auf
	milef_add_to_line_tree(milef_line_tree_root_p,line_item_p);
liste_C::fuege_ein();
liste_a[number_elements_i - 1] = line_item_p;
if (this == &tmp_line_liste_C)
   {
   int upper_i=number_elements_i-1,lower_i=-1,middle_i=0;
   line_C *hilf_p;

   hilf_p = liste_a[number_elements_i-1];
   while (lower_i < upper_i - 1)
   	{
   	middle_i = (upper_i+lower_i)/2;
   	if (((*liste_a[middle_i]->nachfolger()->gib_only_gate()->gib_outputs())[0]->gib_plane_no() > (*line_item_p->nachfolger()->gib_only_gate()->gib_outputs())[0]->gib_plane_no()) ||
   	    (((*liste_a[middle_i]->nachfolger()->gib_only_gate()->gib_outputs())[0]->gib_plane_no() == (*line_item_p->nachfolger()->gib_only_gate()->gib_outputs())[0]->gib_plane_no()) &&
   	     (liste_a[middle_i]->gib_number() < line_item_p->gib_number())))
   		lower_i = middle_i;
   	else
   		upper_i = middle_i;
   	}//while
   for (middle_i=number_elements_i-1;middle_i>upper_i;middle_i--)
   	liste_a[middle_i] = liste_a[middle_i-1];
   liste_a[upper_i] = hilf_p;
   }//if
return;
}/*fuege_ein*/

void line_value_liste_C::fuege_ein(line_C *line_item_p,value_t val_e,boolean sort_b)
{
if ((this == &hilf_C) && (number_elements_i > max_elements_i/2) &&
    (element_in_liste(line_item_p,val_e) == TRUE))
	return;
liste_C::fuege_ein();
if (number_elements_i > max_elements_i)
        {
        int i;

	if (number_elements_i > statistic_u.number_lines_i + statistic_u.number_fanout_branches_i)
		error("line_value_liste_C::fuege_ein: Listen overflow");
        max_elements_i += 50;
        if (max_elements_i > 50)
                {
                line_value_t **tmp_p;

                tmp_p = new line_value_t *[max_elements_i-50];
                for (i=0;i<max_elements_i-50;i++)
                        tmp_p[i] = liste_a[i];
                delete[] liste_a;
                liste_a = new line_value_t *[max_elements_i];
                for (i=0;i<max_elements_i-50;i++)
                        liste_a[i] = tmp_p[i];
		delete[] tmp_p;
		}//if
        else
                liste_a = new line_value_t *[max_elements_i];
        for (i=max_elements_i-50;i<max_elements_i;i++)
                {
                liste_a[i] = new line_value_t;
                liste_a[i]->line_p = NULL;
                liste_a[i]->val_e = UNDEFINED_VALUE;
		}//for
	}//if
liste_a[number_elements_i - 1]->line_p = line_item_p;
liste_a[number_elements_i - 1]->val_e = val_e;
if ((this == &zielfehler_C) && (sort_b == TRUE))
   {	// sortiere Zielfehler Liste
   int upper_i=number_elements_i-1,lower_i=-1,middle_i=0;
   line_value_t *hilf_p;
   double prod_i,prod_mid_i;

   if (val_e == VAL_0)
     if ((stuck_open_test_b == FALSE) && (transition_test_b == FALSE))
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby();
     else
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby() - 1.0;
   else if (val_e == VAL_1)
     if ((stuck_open_test_b == FALSE) && (transition_test_b == FALSE))
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby();
     else
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby() - 1.0;
   else if (val_e == VAL_U0)
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby();
   else if (val_e == VAL_U1)
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby();
   else
	prod_i = line_item_p->gib_testaby();
   hilf_p = liste_a[number_elements_i-1];
   while (lower_i < upper_i - 1)
   	{
   	middle_i = (upper_i+lower_i)/2;
	if (liste_a[middle_i]->val_e == VAL_0)
		prod_mid_i = liste_a[middle_i]->line_p->gib_observaby() * liste_a[middle_i]->line_p->gib_zero_contby();
	else if (liste_a[middle_i]->val_e == VAL_1)
		prod_mid_i = liste_a[middle_i]->line_p->gib_observaby() * liste_a[middle_i]->line_p->gib_one_contby();
	else
		prod_mid_i = liste_a[middle_i]->line_p->gib_testaby();
	if (prod_i > prod_mid_i)
   		lower_i = middle_i;
   	else
   		upper_i = middle_i;
   	}//while
   for (middle_i=number_elements_i-1;middle_i>upper_i;middle_i--)
   	liste_a[middle_i] = liste_a[middle_i-1];
   liste_a[upper_i] = hilf_p;
   }//if
return;
}/*fuege_ein*/

void objective_liste_C::fuege_ein(line_C *line_item_p,int no_0_i,int no_1_i)
{
liste_a[number_elements_i]->line_p = line_item_p;
liste_a[number_elements_i]->n0_i = no_0_i;
liste_a[number_elements_i]->n1_i = no_1_i;
if (this == &fanout_objectives_C)
   {
   int upper_i=number_elements_i,lower_i=-1,middle_i=0;
   objective_type_u *hilf_p;

   hilf_p = liste_a[number_elements_i];
   while (lower_i < upper_i - 1)
   	{
   	middle_i = (upper_i+lower_i)/2;
   	if ((liste_a[middle_i]->line_p->gib_plane_no() < line_item_p->gib_plane_no()) ||
   	    ((liste_a[middle_i]->line_p->gib_plane_no() == line_item_p->gib_plane_no()) &&
   	     (liste_a[middle_i]->line_p->gib_number() < line_item_p->gib_number())))
   		lower_i = middle_i;
   	else
   		upper_i = middle_i;
   	}//while
   for (middle_i=number_elements_i;middle_i>upper_i;middle_i--)
   	liste_a[middle_i] = liste_a[middle_i-1];
   liste_a[upper_i] = hilf_p;
   }//if
number_elements_i++;
}//fuege_ein

//*********************************************************************
//
//   FUNCTION-NAME: fuege_aus
//
//   CLASS: gate_liste_C (line_liste_C)
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ein(e) Gate (Line) wird aus der Liste ausgefuegt
//
//   FORMAL PARAMETERS: line_C *line_item_p: die entsprechende Line
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_liste_C::fuege_aus(gate_C *gate_item_p)
{
int i;
gate_C *ausgefuegtes_element_p;

liste_C::fuege_aus();
for (i=0;i <= number_elements_i;i++)
	if (liste_a[i] == gate_item_p)
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/

void line_liste_C::fuege_aus(line_C *line_item_p)
{
int i;
line_C *ausgefuegtes_element_p;

liste_C::fuege_aus();
if (liste_a[number_elements_i] == line_item_p)
	return;
for (i=0;i <= number_elements_i;i++)
	if (liste_a[i] == line_item_p)
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/

void line_value_liste_C::fuege_aus(line_C *line_item_p,value_t val_e)
{
int i;
line_value_t *ausgefuegtes_element_p;

liste_C::fuege_aus();
if ((liste_a[number_elements_i]->line_p == line_item_p) && (liste_a[number_elements_i]->val_e == val_e))
	return;
for (i=0;i <= number_elements_i;i++)
	if ((liste_a[i]->line_p == line_item_p) && (liste_a[i]->val_e == val_e))
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/

void objective_liste_C::fuege_aus(line_C *line_item_p)
{
int i;
objective_type_u * ausgefuegtes_element_p;

liste_C::fuege_aus();
if (liste_a[number_elements_i]->line_p == line_item_p)
	return;
for (i=0;i <= number_elements_i;i++)
	if (liste_a[i]->line_p == line_item_p)
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/

//*********************************************************************
//
//   FUNCTION-NAME: connect_input
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Die Inputs eines Gatters werden angeschlossen.
//	Es wird festgestellt ob die Anzahl der Inputs mit der Definition
//	uebereinstimmt.
//
//   FORMAL PARAMETERS: stringliste_C &namen_sC: die Namen der Eingaenge
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::connect_input(stringliste_C& namen_sC)
{
string_C akt_element_sC(stringsize_i);
line_C *line_item_p;
io_t line_io_e,input_io_e;

for (int i=1;i<=no_input_i;i++)
	if ((akt_element_sC = namen_sC.entnehme()) == string_C(""))
		error("element has less io's than defined");
	else
		{
		input_io_e = (io_t) (i-1);
		line_item_p = search(&akt_element_sC,milef_line_tree_root_p);
		if (line_item_p == NULL)
			error("Line not found in list");
		line_io_e = line_item_p->verbinde(this,OUTPUT_PORT,input_io_e);
		input_p->verbinde(line_item_p,line_io_e,i);
		}
if (((akt_element_sC = namen_sC.entnehme()) == string_C("")) == FALSE)
	error("element has more io's than defined");
}//connect_input

//*********************************************************************
//
//   FUNCTION-NAME: connect_output
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Die Outputs eines Gatters werden angeschlossen.
//	Es wird festgestellt ob die Anzahl der Outputs mit der Definition
//	uebereinstimmt.
//
//   FORMAL PARAMETERS: stringliste_C &namen_sC: die Namen der Ausgaenge
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::connect_output(stringliste_C& namen_sC)
{
string_C akt_element_sC(stringsize_i);
line_C *line_item_p;
io_t line_io_e,output_io_e;

for (int i=1;i<=no_output_i;i++)
	if ((akt_element_sC = namen_sC.entnehme()) == string_C(""))
		error("element has less io's than defined");
	else
		{
		output_io_e = (io_t) (i - 1 + (int) O1);
		line_item_p = search(&akt_element_sC,milef_line_tree_root_p);
		if (line_item_p == NULL)
			error("line not found in list");
		line_io_e = line_item_p->verbinde(this,INPUT_PORT,output_io_e);
		output_p->verbinde(line_item_p,line_io_e,i);
		}
if (((akt_element_sC = namen_sC.entnehme()) == string_C("")) == FALSE)
	error("element has more io's than defined");
}//connect_output

//*********************************************************************
//
//   FUNCTION-NAME: verbinde
//
//   CLASS: line_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ein Line wird in die Input/Output Liste eines
//	Gatters eingefuegt. Der Port, der Line wird in connected_to_a an der
//	entsprechenden Stelle vermerkt
//
//   FORMAL PARAMETERS: line_C *line_item_p: die entsprechende Line
//		io_t conn_io_e: Der Port der Line, wo das Gatter angeschlossen wird
//		int io_no_i: Der Index, an den die Line angeschlossen wird in Liste
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void line_liste_C::verbinde(line_C *line_item_p, io_t conn_io_e, int io_no_i)
	{
	number_elements_i++;
	if (number_elements_i > max_no_io_i)
		error("some gate has too many inputs or outputs");
	liste_a[io_no_i - 1] = line_item_p;
#ifndef OPT_SPACE
	connected_to_a[io_no_i - 1] = conn_io_e;
#else
        conn_io_e = conn_io_e;
#endif
	}//verbinde

//*********************************************************************
//
//   FUNCTION-NAME: verbinde
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ein Gate wird an eine Line angeschlossen. In abhaengigkeit
//	von port_e ist das Gate Vorgaenger oder Nachfolger. Wenn die Line schon
//	einen nachfolger hat und das Gate ist auch Nachfolger wird fanout_b gesetzt.
//
//   FORMAL PARAMETERS: gate_C *gate_item_p: das entsprechende Gatter
//		port_t port_e: INPUT fuer Vorgaenger, OUTPUT fuer Nachfolger
//		io_t gate_io_e: Der Port, an dem die Line an das Gatter angeschlossen wurde.
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: io_t: Der Port, an dem angeschlossen wird in Vorgaenger/Nachfolger
//				Liste
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
io_t line_C::verbinde(gate_C *gate_item_p, port_t port_e, io_t gate_io_e)
	{
	io_t io_e;

	if (port_e == OUTPUT_PORT)
		{
		io_e = (io_t) (nachfolger_p->verbinde(gate_item_p, gate_io_e) + O1);
		if ((io_e > O1) || (prime_output_b == TRUE))
			fanout_b = TRUE;
		return(io_e);
		}//if
	else
		return(vorgaenger_p->verbinde(gate_item_p, gate_io_e));
	}//verbinde

//*********************************************************************
//
//   FUNCTION-NAME: verbinde
//
//   CLASS: gate_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Ein Gatter wird in die Input/Output Liste einer
//	Line eingefuegt. Der Port des Gatters wird in connected_to_a an der
//	entsprechenden Stelle vermerkt.
//
//   FORMAL PARAMETERS: gate_C *gate_item_p: das entsprechende Gatter
//		io_t gate_io_e: Der Port der Gatters, wo die Line angeschlossen wird
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: io_t: Port, an dem das Gatter angeschlossen wurde
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
io_t gate_liste_C::verbinde(gate_C *gate_item_p, io_t gate_io_e)
	{
	gate_C **tmp_liste_a;
#ifndef OPT_SPACE
        io_t *tmp_connected_to_a;
#endif

	number_elements_i++;
	if (number_elements_i > max_no_io_i)
		error("too many fanout-branches at some signal");
	if (number_elements_i >= max_elements_i)
		{
		tmp_liste_a = new gate_C *[2 * max_elements_i];
#ifndef OPT_SPACE
                tmp_connected_to_a = new io_t[2 * max_elements_i];
#endif
		for (int i=0;i<number_elements_i - 1;i++)
			{
			tmp_liste_a[i] = liste_a[i];
#ifndef OPT_SPACE
                        tmp_connected_to_a[i] = connected_to_a[i];
#endif
			}//for
		delete[] liste_a;
		liste_a = tmp_liste_a;
#ifndef OPT_SPACE
                delete[] connected_to_a;
                connected_to_a = tmp_connected_to_a;
#endif
		max_elements_i = 2 * max_elements_i;
		}//if
	liste_a[number_elements_i - 1] = gate_item_p;
#ifndef OPT_SPACE
        connected_to_a[number_elements_i - 1] = gate_io_e;
#else
        gate_io_e = gate_io_e;
#endif
	return((io_t) (number_elements_i - 1));
	}//verbinde

void gate_C::print_all(my_ofstream &datei_F)
	{ // gibt die Belegung des Gatters aus (DEBUG)
	datei_F << "Adresse   " << this << "\n";
	datei_F << "Name:   " << name_sC << "\n";
   	datei_F << "Inputliste:   " << input_p << "\n";
	datei_F << "Outputliste:   " << output_p << "\n";
	datei_F << "Number Inputs:   " << no_input_i << "\n";
	datei_F << "Number Outputs:   " << no_output_i << "\n";
	datei_F << "Gate Type:   " << gate_e << "\n";
	datei_F << "Gate in Feedback:   " << feedback_b << "\n";
	datei_F << "Element in Feedback:   " << feedback_b << "\n";
	datei_F << "Pfadrekonvergenz an Element:   " << reconvergence_b << "\n";
	datei_F << "##### Inputs\n";
	input_p->print_all(datei_F);
	datei_F << "##### Outputs\n";
	output_p->print_all(datei_F);
	datei_F << "\n\n***********\n";
	}//print_all

void line_C::print_all(my_ofstream &datei_F)
	{ // gibt die Belegung der Line aus (DEBUG)
	datei_F << "Adresse   " << this << "\n";
	datei_F << "Name:   " << name_sC << "\n";
	datei_F << "Nummer:   " << number_i << "\n";
	datei_F << "Im Eingangskegel:   " << input_kegel_b << "\n";
	datei_F << "Im Ausgangskegel:   " << output_kegel_b << "\n";
	datei_F << "Primaer Eingang:   " << prime_input_b << "\n";
	datei_F << "Primaer Ausgang:   " << prime_output_b << "\n";
	datei_F << "Fanout:   " << fanout_b << "\n";
	datei_F << "Plane Number:   " << plane_no_i << "\n";
	datei_F << "Output Depth:   " << output_depth_i << "\n";
	datei_F << "Line Type:   " << line_type_e << "\n";
	datei_F << "Element in Feedback:   " << feedback_b << "\n";
	datei_F << "Init Value:   " << init_value_e << "\n";
	datei_F << "Good Value:   " << good_value_e << "\n";
	datei_F << "Bad Value:   " << bad_value_e << "\n";
	datei_F << "Only Value:   " << only_value_e << "\n";
	datei_F << "Vorgaenger:   " << vorgaenger_p << "\n";
	datei_F << "Nachfolger:   " << nachfolger_p << "\n";
	datei_F << "Rising Test erledigt:   " << rising_test_b << "\n";
	datei_F << "Falling Test erledigt:   " << falling_test_b << "\n";
	datei_F << "Stuck at 0 redundant:   " << s_a_0_untestable_b << "\n";
	datei_F << "Stuck at 1 redundant:   " << s_a_1_untestable_b << "\n";
	datei_F << "Stuck at 0 aborted:   " << s_a_0_aborted_b << "\n";
	datei_F << "Stuck at 1 aborted:   " << s_a_1_aborted_b << "\n";
	datei_F << "Test erledigt:   " << test_done_b << "\n";
	datei_F << "Stuck at Test erledigt:   " << stuck_at_test_b << "\n";
	datei_F << "Stuck at 0 Test erledigt:   " << s_a_0_test_b << "\n";
	datei_F << "Stuck at 1 Test erledigt:   " << s_a_1_test_b << "\n";
	datei_F << "0 Controllability:   " << zero_contby_f << "\n";
	datei_F << "1 Controllability:   " << one_contby_f << "\n";
	datei_F << "Gesamt Controllability:   " << contby_f << "\n";
	datei_F << "Observability:   " << observaby_f << "\n";
	datei_F << "Testability:   " << testaby_f << "\n";
	datei_F << "##### Vorgaenger\n";
	vorgaenger_p->print_all(datei_F);
	datei_F << "##### Nachfolger\n";
	nachfolger_p->print_all(datei_F);
	datei_F << "\n\n***********\n";
	}//print_all

//*********************************************************************
//
//   FUNCTION-NAME: calculate_planes
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuer alle Nachfolgenden Lines wird calculate_planes
//	aufgerufen.
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::calculate_planes()
{
line_C *line_item_p;

forall(line_item_p,*output_p)
	line_item_p->calculate_planes();
}//calculate_planes

//*********************************************************************
//
//   FUNCTION-NAME: calculate_planes
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuer alle Nachfolgenden Gatter wird calculate_planes
//	aufgerufen. Die Nummer der Schaltungsebene, in der sich die Line befindet,
//	ist die hoechste Nummer des Vorgaengers + 1
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void line_C::calculate_planes()
{
static int line_number_i = 1;
int worst_plane_no_i = 0;
boolean fail_b = FALSE;
gate_C *gate_item_p;
line_C *line_item_p;

if (plane_no_i != 0)
	return;
if (prime_input_b == TRUE)
	plane_no_i = 1;
else
	{
	forall(line_item_p,*vorgaenger_p->gib_only_gate()->gib_inputs())
		{
		int akt_plane_no_i;
		
		akt_plane_no_i = line_item_p->gib_plane_no();
		if (akt_plane_no_i == 0)
			fail_b = TRUE; // nicht return, da Liste abgeschlossen werden muss
		worst_plane_no_i = (worst_plane_no_i > akt_plane_no_i) ? worst_plane_no_i
									: akt_plane_no_i;
			// Die schlechteste plane Nummer der Vorgaenger ermitteln
		}//for
	if (fail_b == TRUE)
		return; // plane_no_i eines Vorgaengers noch nicht berechnet
	plane_no_i = worst_plane_no_i + 1;
	}//else
number_i = line_number_i++;

	// Aufruf fuer alle Nachfolger
if (prime_output_b == FALSE)
	{
	gate_item_p = nachfolger_p->gib_only_gate();
	gate_item_p->calculate_planes();
	}//if
}//calculate_planes

//*********************************************************************
//
//   FUNCTION-NAME: calculate_depth_to_output
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuer alle Vorgaenger Lines wird calculate_depth_to_output
//	aufgerufen. Die Entfernung der Schaltungsebene, in der sich die Line befindet,
//	zum Ausgang ist die niedrigste Nummer der Nachfolger + 1
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void line_C::calculate_depth_to_output()
{
int best_depth_no_i = max_number_lines_i;
boolean fail_b = FALSE;
gate_C *gate_item_p;
line_C *line_item_p;

if (output_depth_i != 0)
	return;
if (prime_output_b == TRUE)
	output_depth_i = 1;
else
	{
	forall(gate_item_p,*nachfolger_p)
	   {forall(line_item_p,*gate_item_p->gib_outputs())
		{
		int akt_output_depth_i;
		
		akt_output_depth_i = line_item_p->gib_output_depth();
		if (akt_output_depth_i == 0)
			fail_b = TRUE; // nicht return, da Liste abgeschlossen werden muss
		best_depth_no_i = (best_depth_no_i < akt_output_depth_i) ? best_depth_no_i
									: akt_output_depth_i;
			// Die beste Tiefe der Nachfolger ermitteln
		}}//forall
	if (fail_b == TRUE)
		return; // output_depth_i eines Nachfolgers noch nicht berechnet
	output_depth_i = best_depth_no_i + 1;
	}//else

	// Aufruf fuer alle Vorgaenger
if (prime_input_b == FALSE)
   {
   gate_item_p = vorgaenger_p->gib_only_gate();
   for (int i=0;i<gate_item_p->no_inputs();i++)
	(*gate_item_p->gib_inputs())[i]->calculate_depth_to_output();
   }//if
}//calculate_depth_to_output

//*********************************************************************
//
//   FUNCTION-NAME: calculate_type
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuer alle Nachfolgenden Lines wird calculate_type
//	aufgerufen.
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void gate_C::calculate_type()
{
line_C *line_item_p;

forall(line_item_p,*output_p)
	line_item_p->calculate_type();
}//calculate_type

//*********************************************************************
//
//   FUNCTION-NAME: calculate_type
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuer alle Nachfolgenden Gatter wird calculate_type
//	aufgerufen. Es wird berechnet, ob die entsprechende Line eine FREE_LINE,
//	eine BOUND_LINE oder eine HEAD_LINE ist.
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void line_C::calculate_type()
{
line_t akt_line_type_e = FREE_LINE;
boolean fail_b = FALSE;
line_C *line_item_p;
gate_C *gate_item_p;

if (prime_input_b == TRUE)
	{  // Input ist immer FREE_LINE, wenn er Fanout hat sogar HEAD_LINE
	if ((prime_output_b == FALSE) && (nachfolger_p->gib_only_gate()->gib_type() == FANOUT))
		{
		line_type_e = HEAD_LINE;
		}//if
	else
		line_type_e = FREE_LINE;
	free_lines_C.fuege_ein(this);
	}//if
else
	{  // Line Typ des Vorgaengers ermitteln
	forall(line_item_p,*vorgaenger_p->gib_only_gate()->gib_inputs())
		switch (line_item_p->gib_type())
		   {
		   case UNDEFINED_LINE:
			fail_b = TRUE; // nicht return, da Liste abgeschlossen werden muss
			break;
		   case BOUND_LINE:
		   case HEAD_LINE:
			akt_line_type_e = BOUND_LINE;
			break;
		   case FREE_LINE:
			break; // nothing
		   }//switch
	if (fail_b == TRUE)
		return; // line_type_e eines Vorgaengers noch nicht berechnet
		// Line Typ berechnen
	if ((akt_line_type_e == FREE_LINE) && (prime_output_b == FALSE) &&
	    (nachfolger_p->gib_only_gate()->gib_type() == FANOUT))
		{
		line_type_e = HEAD_LINE;
		free_lines_C.fuege_ein(this);
		}//if
	else
		line_type_e = akt_line_type_e;
	if (line_type_e == FREE_LINE)
		free_lines_C.fuege_ein(this);
	}//else

	// Aufruf fuer alle Nachfolger
if (prime_output_b == FALSE)
	{
	gate_item_p = nachfolger_p->gib_only_gate();
	gate_item_p->calculate_type();
	}//if
}//calculate_type

//*********************************************************************
//
//   FUNCTION-NAME: test_done_or_aborted
//
//   CLASS: line_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion stellt fest, ob ein Element nicht mehr als
//	Zielfehler auftreten kann.
//
//   FORMAL PARAMETERS: keine
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn Element getestet oder alle Tests aborted
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean line_C::test_done_or_aborted()
{
if (test_done_b == TRUE)	// Test bereits generiert
	return(TRUE);
if ((prime_input_b == FALSE) && ((*vorgaenger_p)[0]->gib_type() == BLOCK))
	return(FALSE);
if ((s_a_1_untestable_b == FALSE) && (s_a_1_aborted_b == FALSE))
   if ((s_a_0_untestable_b == TRUE) || (s_a_0_aborted_b == TRUE))
	if ((s_a_1_test_b == FALSE) && (s_a_1_untestable_b == FALSE) && (s_a_1_aborted_b == FALSE))
		return(FALSE);
	else
		return(TRUE);
if ((s_a_0_untestable_b == FALSE) && (s_a_0_aborted_b == FALSE))
   if ((s_a_1_untestable_b == TRUE) || (s_a_1_aborted_b == TRUE))
	if ((s_a_0_test_b == FALSE) && (s_a_0_untestable_b == FALSE) && (s_a_0_aborted_b == FALSE))
		return(FALSE);
	else
		return(TRUE);
if ((s_a_1_untestable_b == FALSE) && (s_a_1_aborted_b == FALSE))
   if (rising_test_b == FALSE)
	return(FALSE);
if ((s_a_0_untestable_b == FALSE) && (s_a_0_aborted_b == FALSE))
   if (falling_test_b == FALSE)
	return(FALSE);
return(TRUE);
}//test_done_or_aborted

void protocol_stack_C::push(line_C *line_item_p,boolean opt_b,boolean bound_in_b,boolean bound_out_b,
			    boolean df_in_b,boolean df_out_b,value_t old_good_e,value_t new_good_e,
			    value_t old_bad_e,value_t new_bad_e)
{
#if DEBUG
if ((opt_b == FALSE) && (imp_in_b == FALSE) && (imp_out_b == FALSE) && (bound_in_b == FALSE) &&
    (bound_out_b == FALSE) && (df_in_b == FALSE) && (df_out_b == FALSE) && (old_e == UNDEFINED_VALUE) &&
    (new_e == UNDEFINED_VALUE))
	error("protocol_stack_C::push:  element doesn't have any information");
if ((opt_b == TRUE) && (new_e == UNDEFINED_VALUE))
	error("protocol_stack_C::push:  Optional assignment without any value");
if (number_elements_i == max_elements_i)
	{
	protocol_stack_a[number_elements_i] = new protocol_type_C();
	if (protocol_stack_a[number_elements_i] == NULL)
		error("no memory available");
	max_elements_i++;
	}//if
#endif
if (bound_in_b == TRUE)
	ujust_bound_changed_b = TRUE;
if (number_elements_i >= max_elements_i)
	error("protocol_stack_C::push:  there`s not enough memory for protocol pointer");
protocol_stack_a[number_elements_i]->line_p = line_item_p;
protocol_stack_a[number_elements_i]->set_optional(opt_b);
protocol_stack_a[number_elements_i]->set_ujust_bound_in(bound_in_b);
protocol_stack_a[number_elements_i]->set_ujust_bound_out(bound_out_b);
protocol_stack_a[number_elements_i]->set_d_front_in(df_in_b);
protocol_stack_a[number_elements_i]->set_d_front_out(df_out_b);
protocol_stack_a[number_elements_i]->set_old_good_value(old_good_e);
protocol_stack_a[number_elements_i]->set_new_good_value(new_good_e);
protocol_stack_a[number_elements_i]->set_old_bad_value(old_bad_e);
protocol_stack_a[number_elements_i]->set_new_bad_value(new_bad_e);
#if DEBUG
if ((protocol_stack_a[number_elements_i]->ujust_bound_in() == TRUE) &&
    (unjustified_bound_line_C.element_in_liste(protocol_stack_a[number_elements_i]->line_p) == FALSE))
	error("protocol_stack_C::push: Element not correct");
if ((protocol_stack_a[number_elements_i]->ujust_bound_out() == TRUE) &&
    (unjustified_bound_line_C.element_in_liste(protocol_stack_a[number_elements_i]->line_p) == TRUE))
	error("protocol_stack_C::push:  Element not correct");
#endif
number_elements_i++;
}//push

protocol_type_C *protocol_stack_C::pop()
{
if (number_elements_i == 0)
	return(NULL);
number_elements_i--;
return(protocol_stack_a[number_elements_i]);
}//pop

//*********************************************************************
//
//   FUNCTION-NAME: element_in_liste
//
//   CLASS: objective_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion stellt fest, ob ein Objective einer Line in der Liste
//	vorhanden ist.
//
//   FORMAL PARAMETERS: line_C *line_item_p: die Line, von der die Objective gesucht wird
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn die Objective in der Liste ist
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean objective_liste_C::element_in_liste(line_C *line_item_p,boolean fuege_aus_b)
{
objective_type_u * ausgefuegtes_element_p;

for(int i = 0;i<number_elements_i;i++)
   if (liste_a[i]->line_p == line_item_p)
	if (fuege_aus_b == FALSE)
		return(TRUE);
	else
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return(FALSE);
liste_C::fuege_aus();
if (liste_a[number_elements_i]->line_p == line_item_p)
	return TRUE;
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}//element_in_liste

my_ofstream& my_ofstream::operator<<(const char* s)
{
f << s << flush;
return(*this);
}//operator<<

my_ofstream& my_ofstream::operator<<(int c)
{
f << c;
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(long c)
{
f << c;
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(void *c)
{
f << c;
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(double c)
{
f << c;
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(boolean b)
{
switch(b)
   {
   case FALSE:
	f << "FALSE";
	break;
   case TRUE:
	f << "TRUE";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

#ifndef OPT_SPACE
my_ofstream& my_ofstream::operator<<(object_t e)
{
switch(e)
   {
   case GATE:
	f << "GATE";
	break;
   case LINE:
	f << "LINE";
	break;
   case UNDEFINED_OBJECT:
	f << "UNDEFINED_OBJECT";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(value_t e)
{
switch(e)
   {
   case VAL_0:
	f << "VAL_0";
	break;
   case VAL_1:
	f << "VAL_1";
	break;
   case VAL_0S:
	f << "VAL_0S";
	break;
   case VAL_1S:
	f << "VAL_1S";
	break;
   case VAL_0X:
	f << "VAL_0X";
	break;
   case VAL_1X:
	f << "VAL_1X";
	break;
   case VAL_D:
	f << "VAL_D";
	break;
   case VAL_D_BAR:
	f << "VAL_D_BAR";
	break;
   case VAL_X:
	f << "VAL_X";
	break;
   case UNDEFINED_VALUE:
	f << "UNDEFINED_VALUE";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(gate_t e)
{
switch(e)
   {
   case AND:
	f << "AND";
	break;
   case OR:
	f << "OR";
	break;
   case NAND:
	f << "NAND";
	break;
   case NOR:
	f << "NOR";
	break;
   case EXOR:
	f << "EXOR";
	break;
   case INVERTER:
	f << "INVERTER";
	break;
   case DRIVER:
	f << "DRIVER";
	break;
   case BLOCK:
	f << "BLOCK";
	break;
   case D_LATCH:
	f << "D_LATCH";
	break;
   case D_FLIP_FLOP:
	f << "D_FLIP_FLOP";
	break;
   case FANOUT:
	f << "FANOUT";
	break;
   case UNDEFINED_GATE:
	f << "UNDEFINED_GATE";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(line_t e)
{
switch(e)
   {
   case FREE_LINE:
	f << "FREE_LINE";
	break;
   case BOUND_LINE:
	f << "BOUND_LINE";
	break;
   case HEAD_LINE:
	f << "HEAD_LINE";
	break;
   case UNDEFINED_LINE:
	f << "UNDEFINED_LINE";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<
#endif

my_ofstream& my_ofstream::operator<<(fan_result_t e)
{
switch(e)
   {
   case SUCCESS:
	f << "SUCCESS";
	break;
   case ABORTED_FAULT:
	f << "ABORTED_FAULT";
	break;
   case REDUNDANT_FAULT:
	f << "REDUNDANT_FAULT";
	break;
   case INCONSISTENT:
	f << "INCONSISTENT";
	break;
   case NO_IMPLICATION:
	f << "NO_IMPLICATION";
	break;
   case IMPLICATION_DONE:
	f << "IMPLICATION_DONE";
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

my_ofstream& my_ofstream::operator<<(io_t e)
{
if (int(e) < 20)
	f<<"I"<<int(e)+1;
if ((int(e) > 19) && (int(e) < 40))
	f<<"O"<<int(e)-19;
switch(e)
   {
   case SET:
	f << "SET";
	break;
   case RESET:
	f << "RESET";
	break;
   case DATA:
	f << "DATA";
	break;
   case CLOCK:
	f << "CLOCK";
	break;
   case INPUT_J:
	f << "INPUT_J";
	break;
   case INPUT_K:
	f << "INPUT_K";
	break;
   case OUTPUT_Q:
	f << "OUTPUT_Q";
	break;
   case OUTPUT_Q_BAR:
	f << "OUTPUT_Q_BAR";
	break;
   case UNDEFINED_IO:
	f << "UNDEFINED_IO";
	break;
   default:
	break;
   }//switch
return(*this);
}//my_ofstream::operator<<

void line_liste_C::merge_list(line_liste_C *list_p)
{
line_C **hilf_liste_p;
int i;

number_elements_i += list_p->no_elements()-1;
hilf_liste_p = new line_C *[number_elements_i];
for (i=0;i<number_elements_i-list_p->no_elements()+1;i++)
	hilf_liste_p[i] = liste_a[i];
for (i=number_elements_i-list_p->no_elements()+1;i<number_elements_i;i++)
	hilf_liste_p[i] = (*list_p)[i-number_elements_i+list_p->no_elements()];
delete[] liste_a;
liste_a = hilf_liste_p;
}
