#ifndef gate_liste_C_h
#define gate_liste_C_h
#include "liste_C.h"
#ifdef FRAMEWORK
#include "cfidr.h"
#endif

//*********************************************************************
//
//   CLASS-NAME: gate_liste_C Unterklasse von liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Gatterlisten und alle notwendigen
//	Operationen auf Gatterlisten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port sowie ohne Argument
//			ohne Argumente => generische Liste
//		 Destruktor loescht Liste
//		 print_all: gibt Inhalt aller Listenelemente aus (DEBUG)
//		 fuege_ein: fuegt Element ein (siehe friends.h)
//		 fuege_aus: fuegt Element aus Liste aus (gate_C* Argument)
//		 element_in_liste: prueft, ob Element gate_C* in Liste ist
//		 search: siehe friends.h
//		 next: gibt aktuelles Element von Liste aus (aktuell entspricht
//			aktual_no_i), wenn Liste geschlossen ist (closed_b == TRUE)
//			beim letzten Element wird Liste geoeffnet
//		 verbinde: siehe friends.h
//		 gib_only_gate: wenn ein Element in der Liste ist, wird dieses
//			Ausgegeben, sonst Fehlermeldung
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class gate_liste_C : public liste_C {
public:
   gate_liste_C(int listengroesse_i);
   gate_liste_C(){}
   void init(int size_i);
   void resize();
   ~gate_liste_C(){if (max_elements_i > 0) delete[] liste_a;}
   gate_C *operator [] (int i){return(liste_a[i]);}
   void print_all(ofstream& datei_F);
   void fuege_ein(gate_C *gate_item_p);
   void fuege_aus(gate_C *gate_item_p);
   boolean element_in_liste(gate_C *,boolean = FALSE);
   void verbinde(gate_C *);
   gate_C *gib_only_gate();
   void loesche_liste();
   void loesche_liste_und_pointer();
   void change_connection(char *name_s,gate_C *gate_item_p);
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(cfidrViewIdT);
#endif
private:
   gate_C **liste_a;  // Liste mit Blocken, die an die aktuelle Line
		      // angeschlossen sind.
};
#endif
