//*********************************************************************
//
//   FILE-NAME: implication.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet die Implikation
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
#include "extern.h"
#include "protocol_stack_C.h"
#include "line_value_liste_C.h"
#include "gate_C.h"
#include "line_C.h"
#include "line_liste_C.h"
#include "gate_liste_C.h"

	//Globale Variablen
boolean d_front_changed_in_implication_b;
extern boolean d_front_changed_b;
extern line_liste_C unjustified_bound_line_C;
extern line_liste_C d_front_C;
extern line_liste_C implication_line_C;
extern line_value_liste_C zielfehler_C;
line_liste_C hilf_imp_line_C;
extern protocol_stack_C protocol_C;
boolean bound_line_in_back_implication_ausgefuegt_b;
extern boolean testing_phase_b;
extern boolean only_iddq_test_b;
extern boolean iddq_stuck_on_test_b;
boolean weak_test_b;
boolean input_kegel_changed_b = FALSE;
gate_C *inconsistent_gate_p;

	// Externe Funktionen
extern void clear_hazard_bits(gate_C*);
extern value_t mynot(value_t);
extern line_C *ziel_line_p;

value_t myand(value_t val1_e,value_t val2_e)
{
if ((val1_e == VAL_0) || (val2_e == VAL_0))
	return(VAL_0);
if ((val1_e == VAL_0S) || (val2_e == VAL_0S))
	return(VAL_0);
if ((val1_e == VAL_X) || (val2_e == VAL_X))
	return(VAL_X);
return(VAL_1);
}//and


value_t myor(value_t val1_e,value_t val2_e)
{
if ((val1_e == VAL_1) || (val2_e == VAL_1))
	return(VAL_1);
if ((val1_e == VAL_1S) || (val2_e == VAL_1S))
	return(VAL_1);
if ((val1_e == VAL_X) || (val2_e == VAL_X))
	return(VAL_X);
return(VAL_0);
}//or

value_t myexor(value_t val1_e,value_t val2_e)
{
if ((val1_e == VAL_X) || (val2_e == VAL_X))
	return(VAL_X);
if ((((val1_e == VAL_0) || (val1_e == VAL_0S)) && ((val2_e == VAL_0) || (val2_e == VAL_0S))) ||
    (((val1_e == VAL_1) || (val1_e == VAL_1S)) && ((val2_e == VAL_1) || (val2_e == VAL_1S))))
	return(VAL_0);
return(VAL_1);
}//exor

//*********************************************************************
//
//   FUNCTION-NAME: try_global_imp
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Versuch einer globalen Implikation mittels der Werte,
//	die durch die Constraint Analyse entstanden sind.
//
//   FORMAL PARAMETERS: None
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t gate_C::try_global_imp()
{
int j,constr_index_i;
boolean erfolg_b = FALSE;
boolean implication_done_b = FALSE;
cube_list_t *source_list_p = constraints_a[0],*target_list_p = constraints_a[1];
belegung_t *source_bel_p,*target_bel_p;

if (((*output_p)[0]->in_output_kegel() == TRUE) || ((*output_p)[0] == ziel_line_p))
	return(NO_IMPLICATION); //Voruebergehend abgeschaltet

while(source_list_p != NULL)
	{
	source_bel_p = source_list_p->to_belegung_p;
	target_bel_p = target_list_p->to_belegung_p;
	j=0;
	while(source_bel_p != NULL)
		{
		if ((source_bel_p->val_e != VAL_X) && (source_bel_p->val_e == (*input_p)[j]->get_good_value()))
			{
			if (target_bel_p->val_e == IMPOSSIBLE_VALUE)
				return(INCONSISTENT);
			erfolg_b = TRUE;
			constr_index_i = j;
			}//if
		source_bel_p = source_bel_p->next_p;
		target_bel_p = target_bel_p->next_p;
		j++;
		}//while
	source_bel_p = source_list_p->to_belegung_p;
	target_bel_p = target_list_p->to_belegung_p;
	j=0;
	if (erfolg_b == TRUE)
		while(source_bel_p != NULL)
			{
			if ((target_bel_p->val_e != VAL_X) && (constr_index_i != j))
				{
				if (target_bel_p->val_e == mynot((*input_p)[j]->get_good_value()))
					return(INCONSISTENT);
				if ((*input_p)[j]->get_good_value() == VAL_X)
					{
					(*input_p)[j]->set_good_value(target_bel_p->val_e);
					if ((*input_p)[j]->in_input_kegel() == TRUE)
						input_kegel_changed_b = TRUE;
					unjustified_bound_line_C.fuege_ein((*input_p)[j]);
					protocol_C.push((*input_p)[j],FALSE,TRUE,FALSE,FALSE,FALSE,VAL_X,target_bel_p->val_e);
					if ((*input_p)[j]->vorgaenger()->gib_only_gate()->backward_implication() == INCONSISTENT)
						return(INCONSISTENT);
					implication_done_b = TRUE;
					}//if
				}//if
			j++;
			source_bel_p = source_bel_p->next_p;
			target_bel_p = target_bel_p->next_p;
			}//while
	erfolg_b = FALSE;
	source_list_p = source_list_p->next_p;
	target_list_p = target_list_p->next_p;
	}//while
if (implication_done_b == TRUE)
	return(SUCCESS);
else
	return(NO_IMPLICATION);
}//try_global_imp

//*********************************************************************
//
//   FUNCTION-NAME: global_implication
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Versuch einer globalen Implikation mittels der Werte,
//	die durch die Lernphase entstanden sind.
//
//   FORMAL PARAMETERS: None
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t line_C::global_implication()
{
line_value_liste_C *imp_liste_p;

for (int j=0;j<2;j++)
   {
   if (j==0)
	if (good_value_e == VAL_0)
		imp_liste_p = &global_implications[0];
	else
		imp_liste_p = &global_implications[1];
   else
	if (good_value_e == VAL_0)
		imp_liste_p = &tmp_global_implications[0];
	else
		imp_liste_p = &tmp_global_implications[1];
   for (int i=0;i<imp_liste_p->no_elements();i++)
   	{
   	if (((*imp_liste_p)[i]->line_p->get_good_value() != (*imp_liste_p)[i]->val_e) &&
   	    ((*imp_liste_p)[i]->line_p->get_good_value() != VAL_X))
   		return(INCONSISTENT);
   	else if ((*imp_liste_p)[i]->line_p->get_good_value() == (*imp_liste_p)[i]->val_e)
   		continue;
   	else
   		{
   		(*imp_liste_p)[i]->line_p->set_good_value((*imp_liste_p)[i]->val_e);
		if ((*imp_liste_p)[i]->line_p->in_input_kegel() == TRUE)
			input_kegel_changed_b = TRUE;
   		if ((*imp_liste_p)[i]->line_p->gib_type() == BOUND_LINE)
   			{
   			unjustified_bound_line_C.fuege_ein((*imp_liste_p)[i]->line_p);
   			protocol_C.push((*imp_liste_p)[i]->line_p,FALSE,TRUE,FALSE,FALSE,FALSE,VAL_X,(*imp_liste_p)[i]->val_e);
   			}//if
		else
   			protocol_C.push((*imp_liste_p)[i]->line_p,FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,(*imp_liste_p)[i]->val_e);
	   	if (((*imp_liste_p)[i]->line_p->is_primary_output() == FALSE) &&
	   	    ((*imp_liste_p)[i]->line_p->nachfolger()->gib_only_gate()->forward_implication() == INCONSISTENT))
	   		return(INCONSISTENT);
	   	if (((*imp_liste_p)[i]->line_p->is_primary_input() == FALSE) &&
	   	    ((*imp_liste_p)[i]->line_p->vorgaenger()->gib_only_gate()->backward_implication() == INCONSISTENT))
	   		return(INCONSISTENT);
		}//else
   	}//for
   }//for
return(SUCCESS);
}//global_implication

//*********************************************************************
//
//   FUNCTION-NAME: forward_implication
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuehrt ein Vorwaertsimplikation im Sinne des Fan-Algorithmus
//	durch.
//
//   FORMAL PARAMETERS: None
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t gate_C::forward_implication()
{
line_C *gate_output_p = (*output_p)[0],*line_item_p;
value_t good_value_e = VAL_X,bad_value_e = VAL_X,controlling_value_e = UNDEFINED_VALUE;
fan_result_t result_e = NO_IMPLICATION,res_e = NO_IMPLICATION;
boolean good_implication_done_b = FALSE,bad_implication_done_b = FALSE;
boolean good_output_was_x_b = TRUE,anything_done_b = FALSE;

clear_hazard_bits(this);
switch (gate_e)
	{
	case AND:
	case NAND:
		controlling_value_e = VAL_0;
		good_value_e = VAL_1;
		{forall(line_item_p,*input_p)
			good_value_e = myand(good_value_e,line_item_p->get_good_value());
			}//forall
		if (gate_e == NAND)
			good_value_e = mynot(good_value_e);
		break;
	case OR:
	case NOR:
		controlling_value_e = VAL_1;
		good_value_e = VAL_0;
		{forall(line_item_p,*input_p)
			good_value_e = myor(good_value_e,line_item_p->get_good_value());
			}//forall
		if (gate_e == NOR)
			good_value_e = mynot(good_value_e);
		break;
	case INVERTER:
		good_value_e = mynot((*input_p)[0]->get_good_value());
		break;
	case DRIVER:
		good_value_e = (*input_p)[0]->get_good_value();
		break;
	case FANOUT:
		good_value_e = (*input_p)[0]->get_good_value();
		break;
	case EXOR:
		controlling_value_e = VAL_X;
		good_value_e = myexor((*input_p)[0]->get_good_value(),(*input_p)[1]->get_good_value());
		break;
	case BLOCK:
	  {
		cube_list_t *cube_list_p;
		belegung_t *belegung_p;
		int j,k;
		value_t output_val_e = VAL_X;
		boolean implication_impossible_b = FALSE;
	
		controlling_value_e = VAL_X;
		for(k=0;k<2;k++)
			{
			for (cube_list_p = block_cubes_a[k];cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
			   {
			   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
				{
				if (((*input_p)[j]->get_good_value() == VAL_X) ||
				    (belegung_p->val_e == VAL_X))
					continue;
				if ((belegung_p->val_e == VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0S))
					break;
				if ((belegung_p->val_e == VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1S))
					break;
				}//for
			   if (j==no_input_i)
				if ((good_value_e == VAL_X) || ((k == 0) && (good_value_e == VAL_0)) ||
				    ((k == 1) && (good_value_e == VAL_1)))
					good_value_e = (k==0)?VAL_0:VAL_1;
				else
					implication_impossible_b = TRUE;
			   }//for
			}//for
		if (implication_impossible_b == TRUE)
			good_value_e = VAL_X;
		break;
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::forward_implication: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("gate_C::forward_implication: undefined gate found");
	}//switch
if (gate_e == FANOUT)
	{
	if (good_value_e != VAL_X)
	   {forall(gate_output_p,*output_p)
		{
		if (gate_output_p->get_good_value() == VAL_X)
			{
			gate_output_p->set_good_value(good_value_e);
			if (gate_output_p->in_input_kegel() == TRUE)
				input_kegel_changed_b = TRUE;
			protocol_C.push(gate_output_p,FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,good_value_e);
			result_e = SUCCESS;
			good_implication_done_b = TRUE;
			anything_done_b = TRUE;
			}//if
		if (gate_output_p->get_good_value() != good_value_e)
			return(INCONSISTENT);
		else
			good_implication_done_b = TRUE;
		}}//forall
	}//if
else if (good_value_e != VAL_X)
	{
	if (gate_output_p->get_good_value() == VAL_X)
		{
		gate_output_p->set_in_forw_imp();
		gate_output_p->set_good_value(good_value_e);
		if (gate_output_p->in_input_kegel() == TRUE)
			input_kegel_changed_b = TRUE;
		protocol_C.push(gate_output_p,FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,good_value_e);
		result_e = SUCCESS;
		good_implication_done_b = TRUE;
		anything_done_b = TRUE;
		}//if
	else
		good_output_was_x_b = FALSE;
	if (gate_output_p->get_good_value() != good_value_e)
		return(INCONSISTENT);
	else
		good_implication_done_b = TRUE;
	}//else if
if (((*output_p)[0]->in_output_kegel() == TRUE) && ((*output_p)[0] != ziel_line_p))
   {
   switch (gate_e)
	{
	case AND:
	case NAND:
		bad_value_e = VAL_1;
		{forall(line_item_p,*input_p)
			if (line_item_p->in_output_kegel() == FALSE)
				bad_value_e = myand(bad_value_e,line_item_p->get_good_value());
			else
				bad_value_e = myand(bad_value_e,line_item_p->get_bad_value());
			}//forall
		if (gate_e == NAND)
			bad_value_e = mynot(bad_value_e);
		break;
	case OR:
	case NOR:
		bad_value_e = VAL_0;
		{forall(line_item_p,*input_p)
			if (line_item_p->in_output_kegel() == FALSE)
				bad_value_e = myor(bad_value_e,line_item_p->get_good_value());
			else
				bad_value_e = myor(bad_value_e,line_item_p->get_bad_value());
			}//forall
		if (gate_e == NOR)
			bad_value_e = mynot(bad_value_e);
		break;
	case INVERTER:
		bad_value_e = mynot((*input_p)[0]->get_bad_value());
		break;
	case DRIVER:
		bad_value_e = (*input_p)[0]->get_bad_value();
		break;
	case EXOR:
		value_t val_0,val_1;

		if ((*input_p)[0]->in_output_kegel() == FALSE)
			val_0 = (*input_p)[0]->get_good_value();
		else
			val_0 = (*input_p)[0]->get_bad_value();
		if ((*input_p)[1]->in_output_kegel() == FALSE)
			val_1 = (*input_p)[1]->get_good_value();
		else
			val_1 = (*input_p)[1]->get_bad_value();
		bad_value_e = myexor(val_0,val_1);
		break;
	case FANOUT:
		bad_value_e = (*input_p)[0]->get_bad_value();
		break;
	case BLOCK:
	  {
		cube_list_t *cube_list_p;
		belegung_t *belegung_p;
		int j,k;
		value_t output_val_e = VAL_X;
		boolean implication_impossible_b = FALSE;
		boolean val_x_found_b = FALSE;

		for(k=0;k<2;k++)
			{
			for (cube_list_p = block_cubes_a[k];cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
			   {
			   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
				{
				value_t hilf_val_e;

				if ((*input_p)[j]->in_output_kegel() == TRUE)
					hilf_val_e = (*input_p)[j]->get_bad_value();
				else
					hilf_val_e = (*input_p)[j]->get_good_value();
				if (hilf_val_e == VAL_X)
					{
					val_x_found_b = TRUE;
					continue;
					}//if
				if (belegung_p->val_e == VAL_X)
					continue;
				if ((belegung_p->val_e == VAL_0) && (hilf_val_e != VAL_0))
					break;
				if ((belegung_p->val_e == VAL_1) && (hilf_val_e != VAL_1))
					break;
				}//for
			   if (j==no_input_i)
				if ((bad_value_e == VAL_X) || ((k == 0) && (bad_value_e == VAL_0)) ||
				    ((k == 1) && (bad_value_e == VAL_1)))
					bad_value_e = (k==0)?VAL_0:VAL_1;
				else
					implication_impossible_b = TRUE;
			   }//for
			}//for
		if (implication_impossible_b == TRUE)
			if (val_x_found_b == TRUE)
				bad_value_e = VAL_X;
			else		// Weak Test
				{
				bad_value_e = mynot((*output_p)[0]->get_good_value());
				weak_test_b = TRUE;
				}//else
		break;
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::forward_implication: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("gate_C::forward_implication: undefined gate found");
	}//switch
   if (gate_e == FANOUT)
	{
	if (bad_value_e != VAL_X)
	   {forall(gate_output_p,*output_p)
		{
		if (gate_output_p->get_bad_value() == VAL_X)
			{
			gate_output_p->set_bad_value(bad_value_e);
			result_e = SUCCESS;
			protocol_C.push(gate_output_p,FALSE,FALSE,FALSE,FALSE,FALSE,UNDEFINED_VALUE,UNDEFINED_VALUE,VAL_X,bad_value_e);
			bad_implication_done_b = TRUE;
			anything_done_b = TRUE;
			}//if
		if ((gate_output_p->get_bad_value() != bad_value_e) && (ziel_line_p != gate_output_p))
			return(INCONSISTENT);
		else
			bad_implication_done_b = TRUE;
		}}//forall
	}//if
   else if (bad_value_e != VAL_X)
	{
	if (gate_output_p->get_bad_value() == VAL_X)
		{
		gate_output_p->set_bad_value(bad_value_e);
		protocol_C.push(gate_output_p,FALSE,FALSE,FALSE,FALSE,FALSE,UNDEFINED_VALUE,UNDEFINED_VALUE,VAL_X,bad_value_e);
		result_e = SUCCESS;
		bad_implication_done_b = TRUE;
		anything_done_b = TRUE;
		}//if
	if ((gate_output_p->get_bad_value() != bad_value_e) && (ziel_line_p != gate_output_p))
		return(INCONSISTENT);
	else
		bad_implication_done_b = TRUE;
	}//else if
   }//if
if (((*output_p)[0]->get_good_value() != VAL_X) && ((*output_p)[0]->get_bad_value() != VAL_X) &&
    (only_iddq_test_b == FALSE) && (iddq_stuck_on_test_b == FALSE))
	{
	boolean input_in_d_front_b = FALSE;

	forall(line_item_p,*input_p)
		if (d_front_C.element_in_liste(line_item_p,TRUE) == TRUE)
			{
			protocol_C.push(line_item_p,FALSE,FALSE,FALSE,FALSE,TRUE);
			input_in_d_front_b = TRUE;
			d_front_changed_b = TRUE;
			}//if
	if (input_in_d_front_b == TRUE)
	   {forall(line_item_p,*output_p)
		if ((line_item_p->get_good_value() != VAL_X) && (line_item_p->get_bad_value() != VAL_X) &&
		    (line_item_p->get_good_value() != line_item_p->get_bad_value()))
			{
			result_e = SUCCESS;
			d_front_C.fuege_ein(line_item_p);
			protocol_C.push(line_item_p,FALSE,FALSE,FALSE,TRUE);
			}//if
	   }//forall
	if (d_front_C.no_elements() == 0)
		return(INCONSISTENT);
	}//if
if ((good_implication_done_b == TRUE) &&
    ((bad_implication_done_b == TRUE) || ((*output_p)[0]->in_output_kegel() == FALSE) ||
     ((*output_p)[0] == ziel_line_p)))
	{
	if (unjustified_bound_line_C.element_in_liste((*output_p)[0],TRUE) == TRUE)
		protocol_C.push((*output_p)[0],FALSE,FALSE,TRUE);
	}//if
if (gate_e == FANOUT)
	{
	if (anything_done_b == TRUE)
	   {forall(gate_output_p,*output_p)
		{
		if ((good_implication_done_b == TRUE) &&
		    ((bad_implication_done_b == TRUE) || ((*input_p)[0]->in_output_kegel() == FALSE)) &&
		    (unjustified_bound_line_C.element_in_liste(gate_output_p,TRUE) == TRUE))
		        protocol_C.push(gate_output_p,FALSE,FALSE,TRUE);
		if ((result_e == SUCCESS) && (gate_output_p->is_primary_output() == FALSE))
			res_e = gate_output_p->nachfolger()->gib_only_gate()->forward_implication();
		if (res_e == INCONSISTENT)
			return(res_e);
		}}//forall
	return(result_e);
	}//if
if (good_output_was_x_b == FALSE)
	{
	int no_x_good_values_i = 0;
	boolean entry_b = TRUE;
	
	forall(line_item_p,*input_p)
		if (line_item_p->get_good_value() == VAL_X)
			no_x_good_values_i++;
		else if (line_item_p->get_good_value() == controlling_value_e)
			entry_b = FALSE;
	if (((no_x_good_values_i == 1) && (entry_b == TRUE)) || (gate_e == BLOCK))
		{
		res_e = backward_implication();
		if (res_e == INCONSISTENT)
			return(INCONSISTENT);
		}//if
	}//if
if ((result_e == SUCCESS) && (gate_output_p->is_primary_output() == FALSE))
	res_e = gate_output_p->nachfolger()->gib_only_gate()->forward_implication();
if (res_e == INCONSISTENT)
	return(INCONSISTENT);
return(result_e);
}//forward_implication

//*********************************************************************
//
//   FUNCTION-NAME: backward_implication
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuehrt ein Rueckwaertsimplikation im Sinne des Fan-Algorithmus
//	durch.
//
//   FORMAL PARAMETERS: Boolean do_anything_b: wird nur in hazard_test fuer Bloecke benoetigt
//	wenn diese Variable TRUE angibt, wird keine Wertzuweisung durchgefuehrt.
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t gate_C::backward_implication(boolean do_anything_b)
{
line_C *gate_output_p = (*output_p)[0],*line_item_p;
value_t good_value_e;
fan_result_t res_e = NO_IMPLICATION;
int no_x_good_values_i = 0;
value_t controlling_value_e,out_of_controlling_value_e;
boolean good_controlling_value_found_b = FALSE,erfolg_b = FALSE;
static int mask_bits_a[max_number_gate_inputs_i];

clear_hazard_bits(this);
if ((gate_e != FANOUT) && (gate_output_p->get_good_value() == VAL_X) && (gate_output_p->get_bad_value() == VAL_X))
	error("gate_C::backward_implication: output not covered");
if (do_anything_b == TRUE)// && (testing_phase_b == TRUE))
   {
   if (try_global_imp() == INCONSISTENT)
	return(INCONSISTENT);
   if (gate_output_p->global_implication() == INCONSISTENT)
	return(INCONSISTENT);
   }//if
switch (gate_e)
	{
	case AND:
		controlling_value_e = VAL_0;
		out_of_controlling_value_e = VAL_0;
		break;
	case NAND:
		controlling_value_e = VAL_0;
		out_of_controlling_value_e = VAL_1;
		break;
	case OR:
		controlling_value_e = VAL_1;
		out_of_controlling_value_e = VAL_1;
		break;
	case NOR:
		controlling_value_e = VAL_1;
		out_of_controlling_value_e = VAL_0;
		break;
	case INVERTER:
		good_value_e = mynot(gate_output_p->get_good_value());
		break;
	case DRIVER:
		good_value_e = gate_output_p->get_good_value();
		break;
	case FANOUT:
		good_value_e = (*input_p)[0]->get_good_value();
		{forall(gate_output_p,*output_p)
			{
			if (gate_output_p->get_good_value() != VAL_X)
				{
				if (good_value_e == VAL_X)
					good_value_e = gate_output_p->get_good_value();
				if (good_value_e != gate_output_p->get_good_value())
					return(INCONSISTENT);
				}//if
			}}//forall
		break;
	case EXOR:
		break;
	case BLOCK:
	  {
		cube_list_t *cube_list_p;
		belegung_t *belegung_p,*cube_p = NULL,*cube_bel_p;
		int i,j,k;
		boolean eine_kube_b = TRUE,complement_cube_b = FALSE;
		boolean val_x_found_b = FALSE;
		boolean belegung_durchgefuehrt_b = FALSE;
	
		for(i=0;i<max_number_gate_inputs_i;i++)
			mask_bits_a[i] = 0;
		if ((*output_p)[0]->get_good_value() == VAL_1)
			{
			cube_list_p = block_cubes_a[1];
			k = 1;
			}//if
		else if ((*output_p)[0]->get_good_value() == VAL_0)
			{
			cube_list_p = block_cubes_a[0];
			k = 0;
			}//elif
		else
			error("backward_implication: block has X at output");
		for (j=0;j<no_input_i;j++)
			if (((*input_p)[j]->get_good_value() == VAL_X) ||
			    (((*input_p)[j]->in_output_kegel() == TRUE) &&
			     ((*input_p)[j]->get_bad_value() == VAL_X)))
				{
				val_x_found_b = TRUE;
				break;
				}//if
		for (;cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
		   {
		   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
			{
			if (((*input_p)[j]->get_good_value() == VAL_X) || (belegung_p->val_e == VAL_X))
				continue;
			if ((belegung_p->val_e == VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0))
				break;
			if ((belegung_p->val_e == VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1))
				break;
			}//for
		   if (j==no_input_i)
			if (cube_p == NULL)
				cube_p = cube_list_p->to_belegung_p; //Diese Kube kann angewandt werden
			else
			   {
			   boolean value_nonequal_x_found_b = FALSE;

			   eine_kube_b = FALSE;
			   for (i=0,cube_bel_p=cube_p,belegung_p=cube_list_p->to_belegung_p;
				belegung_p!=NULL;i++,cube_bel_p=cube_bel_p->next_p,belegung_p=belegung_p->next_p)
				{
				if ((cube_bel_p->val_e == belegung_p->val_e) && (cube_bel_p->val_e != VAL_X))
				   {
				   if (mask_bits_a[i] == 0)
					value_nonequal_x_found_b = TRUE;
				   }//if
				else
					mask_bits_a[i] = 1;
				}//for
			   if (value_nonequal_x_found_b == FALSE)
			      if ((val_x_found_b == TRUE) || 
				  (unjustified_bound_line_C.element_in_liste((*output_p)[0]) == FALSE))
				 return(NO_IMPLICATION);
			      else
				 return(forward_implication());
			   }//else
		   }//for
		if (cube_p == NULL) // kein Match fuer die Kuben
			return(INCONSISTENT);
		if (do_anything_b == FALSE)
			return(SUCCESS);
		for (j=0,belegung_p=cube_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
			if (((*input_p)[j]->get_good_value() == VAL_X) && (belegung_p->val_e != VAL_X) &&
			    (mask_bits_a[j] == 0) && (belegung_p->val_e != VAL_X))
				{
				(*input_p)[j]->set_good_value(belegung_p->val_e);
				if ((*input_p)[j]->in_input_kegel() == TRUE)
					input_kegel_changed_b = TRUE;
				belegung_durchgefuehrt_b = TRUE;
				if ((*input_p)[j]->gib_type() == BOUND_LINE)
				   {
				   unjustified_bound_line_C.fuege_ein((*input_p)[j]);
				   protocol_C.push((*input_p)[j],FALSE,TRUE,FALSE,FALSE,FALSE,VAL_X,belegung_p->val_e);
				   }//if
				else
				   protocol_C.push((*input_p)[j],FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,belegung_p->val_e);
				}//if
		val_x_found_b = FALSE;
		for (j=0;j<no_input_i;j++)
			if (((*input_p)[j]->get_good_value() == VAL_X) ||
			    (((*input_p)[j]->in_output_kegel() == TRUE) &&
			     ((*input_p)[j]->get_bad_value() == VAL_X)))
				{
				val_x_found_b = TRUE;
				break;
				}//if
		for (cube_list_p = block_cubes_a[1-k];cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
		   {
		   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
			{
			if (((*input_p)[j]->get_good_value() == VAL_X) || (belegung_p->val_e == VAL_X))
				continue;
			if ((belegung_p->val_e == VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0))
				break;
			if ((belegung_p->val_e == VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1))
				break;
			}//for
		   if (j==no_input_i)
			complement_cube_b = TRUE;
		   }//for
		if ((((eine_kube_b == TRUE) && (complement_cube_b == FALSE)) || (val_x_found_b == FALSE)) &&
		    (unjustified_bound_line_C.element_in_liste(gate_output_p) == TRUE))
			{
			unjustified_bound_line_C.fuege_aus(gate_output_p);
			protocol_C.push(gate_output_p,FALSE,FALSE,TRUE);
			bound_line_in_back_implication_ausgefuegt_b = TRUE;
			belegung_durchgefuehrt_b = TRUE;
			}//if
		for (j=0;j<no_input_i;j++)
			if ((*input_p)[j]->get_good_value() != VAL_X)
				{
				if ((*input_p)[j]->is_primary_input() == FALSE)
					if ((*input_p)[j]->vorgaenger()->gib_only_gate()->backward_implication() == INCONSISTENT)
						return(INCONSISTENT);
				}//if
		if ((gate_output_p->in_output_kegel() == TRUE) && (belegung_durchgefuehrt_b == TRUE) &&
		    (gate_output_p != ziel_line_p))
			if (forward_implication() == INCONSISTENT)
				return(INCONSISTENT);
		return(SUCCESS);
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::backward_implication: for sequential gates not implemented");
	case UNDEFINED_GATE:
		error("gate_C::backward_implication: undefined gate found");
	}//switch
{forall(line_item_p,*input_p)
	{
	if (line_item_p->get_good_value() == VAL_X)
		no_x_good_values_i++;
	if ((gate_e == AND) || (gate_e == NAND) || (gate_e == OR) || (gate_e == NOR))
		if (line_item_p->get_good_value() == controlling_value_e)
			good_controlling_value_found_b = TRUE;
	}}//forall
switch (gate_e)
	{
	case AND:
	case NAND:
	case OR:
	case NOR:
		boolean good_implication_erfolglos_b;
		boolean good_implication_done_b;
		line_C *set_line_p;

		good_implication_erfolglos_b = FALSE;
		good_implication_done_b = FALSE;
		set_line_p = NULL;
		if ((good_controlling_value_found_b == TRUE) &&
		    (gate_output_p->get_good_value() == mynot(out_of_controlling_value_e)))
			return(INCONSISTENT);
		if ((good_controlling_value_found_b == FALSE) && (no_x_good_values_i == 0) &&
		    (gate_output_p->get_good_value() == out_of_controlling_value_e))
			return(INCONSISTENT);
		if ((good_controlling_value_found_b == TRUE) &&
		    (gate_output_p->get_good_value() == out_of_controlling_value_e))
			good_implication_done_b = TRUE;
		if (((good_controlling_value_found_b == FALSE) && (no_x_good_values_i > 1) &&
		     (gate_output_p->get_good_value() == out_of_controlling_value_e)) ||
		    (gate_output_p->get_good_value() == VAL_X))
			good_implication_erfolglos_b = TRUE;
		if ((good_controlling_value_found_b == FALSE) && (no_x_good_values_i == 0) &&
		    (gate_output_p->get_good_value() == mynot(out_of_controlling_value_e)))
			good_implication_done_b = TRUE;
		if (good_implication_erfolglos_b == TRUE)
			return(NO_IMPLICATION);
		if ((good_implication_erfolglos_b == FALSE) && (good_implication_done_b == FALSE))
			{
			if (gate_output_p->get_good_value() == out_of_controlling_value_e)
				{
				if (no_x_good_values_i != 1)
					error("backward_implication  uncorrect");
				forall(line_item_p,*input_p)
					{
					if (line_item_p->get_good_value() == controlling_value_e)
						error("backward_implication uncorrect");
					if (line_item_p->get_good_value() == VAL_X)
						if (set_line_p == NULL)
							{
							set_line_p = line_item_p;
							set_line_p->set_good_value(controlling_value_e);
							if (set_line_p->in_input_kegel() == TRUE)
								input_kegel_changed_b = TRUE;
							if (set_line_p->gib_type() == BOUND_LINE)
								{
								unjustified_bound_line_C.fuege_ein(set_line_p);
								protocol_C.push(set_line_p,FALSE,TRUE,FALSE,FALSE,
								FALSE,VAL_X,controlling_value_e);
								}//if
							else
								protocol_C.push(set_line_p,FALSE,FALSE,FALSE,FALSE,
								FALSE,VAL_X,controlling_value_e);
							if (line_item_p->is_primary_input() == FALSE)
								res_e = (*line_item_p->vorgaenger())[0]->backward_implication();
							if (res_e == INCONSISTENT)
								return(INCONSISTENT);
							}//if
						else
							error("backward_implication uncorrect");
					}//forall
				if ((gate_output_p->in_output_kegel() == TRUE) &&
				    (gate_output_p != ziel_line_p))
					if (forward_implication() == INCONSISTENT)
						return(INCONSISTENT);
				}//if
			else
				{
				forall(line_item_p,*input_p)
					if (line_item_p->get_good_value() == VAL_X)
						{
						line_item_p->set_good_value(mynot(controlling_value_e));
						if (line_item_p->in_input_kegel() == TRUE)
							input_kegel_changed_b = TRUE;
						if (line_item_p->gib_type() == BOUND_LINE)
							{
							unjustified_bound_line_C.fuege_ein(line_item_p);
							protocol_C.push(line_item_p,FALSE,TRUE,FALSE,FALSE,
							FALSE,VAL_X,mynot(controlling_value_e));
							}//if
						else
							protocol_C.push(line_item_p,FALSE,FALSE,FALSE,FALSE,
							FALSE,VAL_X,mynot(controlling_value_e));
						if (line_item_p->is_primary_input() == FALSE)
							res_e = (*line_item_p->vorgaenger())[0]->backward_implication();
						if (res_e == INCONSISTENT)
							return(INCONSISTENT);
						}//if
				if ((gate_output_p->in_output_kegel() == TRUE) &&
				    (gate_output_p != ziel_line_p))
					if (forward_implication() == INCONSISTENT)
						return(INCONSISTENT);
				}//else
			good_implication_done_b = TRUE;
			}//if
		if (good_implication_done_b == TRUE)
		   if (unjustified_bound_line_C.element_in_liste(gate_output_p) == TRUE)
			{
			boolean erfolg_b = TRUE;

			if ((gate_output_p->in_output_kegel() == TRUE) && (gate_output_p != ziel_line_p))
			   {forall(line_item_p,*input_p)
				if ((line_item_p->get_good_value() == VAL_X) ||
				    ((line_item_p->in_output_kegel() == TRUE) &&
				     (line_item_p->get_bad_value() == VAL_X)))
					erfolg_b = FALSE;}
			if (erfolg_b == TRUE)
				{
				unjustified_bound_line_C.fuege_aus(gate_output_p);
				protocol_C.push(gate_output_p,FALSE,FALSE,TRUE);
				bound_line_in_back_implication_ausgefuegt_b = TRUE;
				}//if
			}//if
		return(SUCCESS);
	case INVERTER:
	case DRIVER:
	case FANOUT:
		if (good_value_e != VAL_X)
			{
			if ((*input_p)[0]->get_good_value() == VAL_X)
				{
				erfolg_b = TRUE;
				(*input_p)[0]->set_good_value(good_value_e);
				if ((*input_p)[0]->in_input_kegel() == TRUE)
					input_kegel_changed_b = TRUE;
				if ((*input_p)[0]->gib_type() == BOUND_LINE)
					{
					unjustified_bound_line_C.fuege_ein((*input_p)[0]);
					protocol_C.push((*input_p)[0],FALSE,TRUE,FALSE,FALSE,FALSE,VAL_X,good_value_e);
					}//if
				else
					protocol_C.push((*input_p)[0],FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,good_value_e);
				}//if
			if ((*input_p)[0]->get_good_value() != good_value_e)
				return(INCONSISTENT);
			}//if
		if (good_value_e != VAL_X)
			{forall(line_item_p,*output_p)
				if (unjustified_bound_line_C.element_in_liste(line_item_p,TRUE) == TRUE)
					{
					protocol_C.push(line_item_p,FALSE,FALSE,TRUE);
					bound_line_in_back_implication_ausgefuegt_b = TRUE;
					}}//if
		if (erfolg_b == TRUE)
			{
			if ((*input_p)[0]->is_primary_input() == FALSE)
				{
				res_e = (*(*input_p)[0]->vorgaenger())[0]->backward_implication();
				if (res_e == INCONSISTENT)
					return(INCONSISTENT);
				}//if
			if (gate_e == FANOUT)
				{
				res_e = this->forward_implication();
				if (res_e == INCONSISTENT)
					return(INCONSISTENT);
				}//if
			return(SUCCESS);
			}//if
		return(NO_IMPLICATION);
	case EXOR:
		line_C *nox_good_input_p;
		line_C *x_good_input_p;
		value_t good_val_e;
		
		nox_good_input_p = NULL;
		x_good_input_p = NULL;
		good_val_e = VAL_X;
		res_e = NO_IMPLICATION;
		if ((*input_p)[0]->get_good_value() != VAL_X)
			nox_good_input_p = (*input_p)[0];
		else
			x_good_input_p = (*input_p)[0];
		if ((*input_p)[1]->get_good_value() != VAL_X)
			{
			nox_good_input_p = (*input_p)[1];
			x_good_input_p = (*input_p)[0];
			}//if
		else
			x_good_input_p = (*input_p)[1];
		if (gate_output_p->get_good_value() == VAL_X)
			nox_good_input_p = NULL;
		if (nox_good_input_p != NULL)
			{
			if (gate_output_p->get_good_value() == nox_good_input_p->get_good_value())
				good_val_e = VAL_0;
			else
				good_val_e = VAL_1;
			}//if
		if (good_val_e != VAL_X)
		   if (x_good_input_p->get_good_value() == VAL_X)
			{
			x_good_input_p->set_good_value(good_val_e);
			if (x_good_input_p->in_input_kegel() == TRUE)
				input_kegel_changed_b = TRUE;
			if (x_good_input_p->gib_type() == BOUND_LINE)
				{
				unjustified_bound_line_C.fuege_ein(x_good_input_p);
				protocol_C.push(x_good_input_p,FALSE,TRUE,FALSE,FALSE,FALSE,VAL_X,good_val_e);
				}//if
			else
				protocol_C.push(x_good_input_p,FALSE,FALSE,FALSE,FALSE,FALSE,VAL_X,good_val_e);
			res_e = SUCCESS;
			}//if
		   else if (x_good_input_p->get_good_value() != good_val_e)
			return(INCONSISTENT);
		   else
			res_e = IMPLICATION_DONE;
		if (res_e == NO_IMPLICATION)
			return(NO_IMPLICATION);
		if ((res_e == SUCCESS) || (res_e == IMPLICATION_DONE))
			if (unjustified_bound_line_C.element_in_liste(gate_output_p) == TRUE)
				{
				boolean erfolg_b = TRUE;
	
				if ((gate_output_p->in_output_kegel() == TRUE) && (gate_output_p != ziel_line_p))
				   {forall(line_item_p,*input_p)
					if ((line_item_p->get_good_value() == VAL_X) ||
					    ((line_item_p->in_output_kegel() == TRUE) &&
					     (line_item_p->get_bad_value() == VAL_X)))
						erfolg_b = FALSE;}
				if (erfolg_b == TRUE)
					{
					unjustified_bound_line_C.fuege_aus(gate_output_p);
					protocol_C.push(gate_output_p,FALSE,FALSE,TRUE);
					bound_line_in_back_implication_ausgefuegt_b = TRUE;
					}//if
				}//if
		if (res_e == SUCCESS)
			{
			if (x_good_input_p->is_primary_input() == FALSE)
				res_e = (*x_good_input_p->vorgaenger())[0]->backward_implication();
			if (res_e == INCONSISTENT)
				return(INCONSISTENT);
			if ((gate_output_p->in_output_kegel() == TRUE) &&
			    (gate_output_p != ziel_line_p))
				if (forward_implication() == INCONSISTENT)
					return(INCONSISTENT);
			}//if
		return(SUCCESS);
	case BLOCK:
		error("gate_C::backward_implication: blocks already managed");
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::backward_implication: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("gate_C::backward_implication: undefined gate found");
	}//switch
}//backward_implication

//*********************************************************************
//
//   FUNCTION-NAME: implication
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuehrt die Implikationen durch
//
//   FORMAL PARAMETERS: None
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t implication()
{
line_C *line_item_p;
fan_result_t res_e = SUCCESS;
boolean erfolg_b = TRUE;

{forall(line_item_p,implication_line_C)
	{
	if (line_item_p->is_primary_input() == FALSE)
		res_e = (*line_item_p->vorgaenger())[0]->backward_implication();
	if (res_e == INCONSISTENT)
		return(INCONSISTENT);
	if (line_item_p->is_primary_output() == FALSE)
		res_e = (*line_item_p->nachfolger())[0]->forward_implication();
	if (res_e == INCONSISTENT)
		return(INCONSISTENT);
	}}//forall
implication_line_C.loesche_liste();
{forall(line_item_p,d_front_C)
	implication_line_C.fuege_ein(line_item_p);
}//forall
{forall(line_item_p,implication_line_C)
        {
        if (line_item_p->is_primary_output() == FALSE)
                res_e = (*line_item_p->nachfolger())[0]->forward_implication();
        if (res_e == INCONSISTENT)
                return(INCONSISTENT);
	}}//forall
bound_line_in_back_implication_ausgefuegt_b = TRUE;
while (bound_line_in_back_implication_ausgefuegt_b == TRUE)
   {
   bound_line_in_back_implication_ausgefuegt_b = FALSE;
   implication_line_C.loesche_liste();
   {forall(line_item_p,unjustified_bound_line_C)
   	implication_line_C.fuege_ein(line_item_p);
   }//forall
   {forall(line_item_p,implication_line_C)
           {
           res_e = (*line_item_p->vorgaenger())[0]->backward_implication();
           if (res_e == INCONSISTENT)
                   return(INCONSISTENT);
   	if (res_e == SUCCESS)
   		erfolg_b = TRUE;
   	}}//forall
   }//while
return(SUCCESS);
}//implication

//*********************************************************************
//
//   FUNCTION-NAME: fast_forward_implication
//
//   CLASS: gate_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Fuehrt ein Vorwaertsimplikation im Sinne des Fan-Algorithmus
//	durch.
//
//   FORMAL PARAMETERS: None
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: fan_result_t SUCCESS, bzw. INCONSITENT
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
fan_result_t gate_C::fast_forward_implication()
{
line_C *gate_output_p = (*output_p)[0],*line_item_p;
value_t good_value_e = VAL_X,bad_value_e = VAL_X;
fan_result_t result_e = NO_IMPLICATION,res_e = NO_IMPLICATION;

switch (gate_e)
	{
	case AND:
	case NAND:
		good_value_e = VAL_1;
		{forall(line_item_p,*input_p)
			good_value_e = myand(good_value_e,line_item_p->get_good_value());
			}//forall
		if (gate_e == NAND)
			good_value_e = mynot(good_value_e);
		break;
	case OR:
	case NOR:
		good_value_e = VAL_0;
		{forall(line_item_p,*input_p)
			good_value_e = myor(good_value_e,line_item_p->get_good_value());
			}//forall
		if (gate_e == NOR)
			good_value_e = mynot(good_value_e);
		break;
	case INVERTER:
		good_value_e = mynot((*input_p)[0]->get_good_value());
		break;
	case DRIVER:
		good_value_e = (*input_p)[0]->get_good_value();
		break;
	case FANOUT:
		good_value_e = (*input_p)[0]->get_good_value();
		break;
	case EXOR:
		good_value_e = myexor((*input_p)[0]->get_good_value(),(*input_p)[1]->get_good_value());
		break;
	case BLOCK:
	  {
		cube_list_t *cube_list_p;
		belegung_t *belegung_p;
		int j,k;
		value_t output_val_e = VAL_X;
		boolean implication_impossible_b = FALSE;
	
		for(k=0;k<2;k++)
			{
			for (cube_list_p = block_cubes_a[k];cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
			   {
			   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
				{
				if (((*input_p)[j]->get_good_value() == VAL_X) ||
				    (belegung_p->val_e == VAL_X))
					continue;
				if ((belegung_p->val_e == VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0) && ((*input_p)[j]->get_good_value() != VAL_0S))
					break;
				if ((belegung_p->val_e == VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1) && ((*input_p)[j]->get_good_value() != VAL_1S))
					break;
				}//for
			   if (j==no_input_i)
				if ((good_value_e == VAL_X) || ((k == 0) && (good_value_e == VAL_0)) ||
				    ((k == 1) && (good_value_e == VAL_1)))
					good_value_e = (k==0)?VAL_0:VAL_1;
				else
					implication_impossible_b = TRUE;
			   }//for
			}//for
		if (implication_impossible_b == TRUE)
			good_value_e = VAL_X;
		break;
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::fast_forward_implication: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("gate_C::fast_forward_implication: undefined gate found");
	}//switch
if (gate_e == FANOUT)
	{
	if (good_value_e != VAL_X)
	   {forall(gate_output_p,*output_p)
		{
		if (gate_output_p->get_good_value() == VAL_X)
			{
			gate_output_p->set_good_value(good_value_e);
			result_e = SUCCESS;
			}//if
		if (gate_output_p->get_good_value() != good_value_e)
			{
			inconsistent_gate_p = this;
			return(INCONSISTENT);
			}//if
		}}//forall
	}//if
else if (good_value_e != VAL_X)
	{
	if (gate_output_p->get_good_value() == VAL_X)
		{
		gate_output_p->set_good_value(good_value_e);
		result_e = SUCCESS;
		}//if
	if (gate_output_p->get_good_value() != good_value_e)
		{
		inconsistent_gate_p = this;
		return(INCONSISTENT);
		}//if
	}//else if
if (((*output_p)[0]->in_output_kegel() == TRUE) && (ziel_line_p != gate_output_p))
   {
   switch (gate_e)
	{
	case AND:
	case NAND:
		bad_value_e = VAL_1;
		{forall(line_item_p,*input_p)
			if (line_item_p->in_output_kegel() == FALSE)
				bad_value_e = myand(bad_value_e,line_item_p->get_good_value());
			else
				bad_value_e = myand(bad_value_e,line_item_p->get_bad_value());
			}//forall
		if (gate_e == NAND)
			bad_value_e = mynot(bad_value_e);
		break;
	case OR:
	case NOR:
		bad_value_e = VAL_0;
		{forall(line_item_p,*input_p)
			if (line_item_p->in_output_kegel() == FALSE)
				bad_value_e = myor(bad_value_e,line_item_p->get_good_value());
			else
				bad_value_e = myor(bad_value_e,line_item_p->get_bad_value());
			}//forall
		if (gate_e == NOR)
			bad_value_e = mynot(bad_value_e);
		break;
	case INVERTER:
		bad_value_e = mynot((*input_p)[0]->get_bad_value());
		break;
	case DRIVER:
		bad_value_e = (*input_p)[0]->get_bad_value();
		break;
	case EXOR:
		value_t val_0,val_1;

		if ((*input_p)[0]->in_output_kegel() == FALSE)
			val_0 = (*input_p)[0]->get_good_value();
		else
			val_0 = (*input_p)[0]->get_bad_value();
		if ((*input_p)[1]->in_output_kegel() == FALSE)
			val_1 = (*input_p)[1]->get_good_value();
		else
			val_1 = (*input_p)[1]->get_bad_value();
		bad_value_e = myexor(val_0,val_1);
		break;
	case FANOUT:
		bad_value_e = (*input_p)[0]->get_bad_value();
		break;
	case BLOCK:
	  {
		cube_list_t *cube_list_p;
		belegung_t *belegung_p;
		int j,k;
		value_t output_val_e = VAL_X;
		boolean implication_impossible_b = FALSE;
		boolean val_x_found_b = FALSE;
	
		for(k=0;k<2;k++)
			{
			for (cube_list_p = block_cubes_a[k];cube_list_p!=NULL;cube_list_p = cube_list_p->next_p)
			   {
			   for (j=0,belegung_p=cube_list_p->to_belegung_p;j<no_input_i;j++,belegung_p=belegung_p->next_p)
				{
				value_t hilf_val_e;

				if ((*input_p)[j]->in_output_kegel() == TRUE)
					hilf_val_e = (*input_p)[j]->get_bad_value();
				else
					hilf_val_e = (*input_p)[j]->get_good_value();
				if (hilf_val_e == VAL_X)
					{
					val_x_found_b = TRUE;
					continue;
					}//if
				if (belegung_p->val_e == VAL_X)
					continue;
				if ((belegung_p->val_e == VAL_0) && (hilf_val_e != VAL_0) && (hilf_val_e != VAL_0S))
					break;
				if ((belegung_p->val_e == VAL_1) && (hilf_val_e != VAL_1) && (hilf_val_e != VAL_1S))
					break;
				}//for
			   if (j==no_input_i)
				if ((bad_value_e == VAL_X) || ((k == 0) && (bad_value_e == VAL_0)) ||
				    ((k == 1) && (bad_value_e == VAL_1)))
					bad_value_e = (k==0)?VAL_0:VAL_1;
				else
					implication_impossible_b = TRUE;
			   }//for
			}//for
		if (implication_impossible_b == TRUE)
			if (val_x_found_b == TRUE)
				bad_value_e = VAL_X;
			else		// Weak Test
				{
				bad_value_e = mynot((*output_p)[0]->get_good_value());
				weak_test_b = TRUE;
				}//else
		break;
	  }
	case D_FLIP_FLOP:
	case D_LATCH:
		error("gate_C::fast_forward_implication: not implemented for sequential gates");
	case UNDEFINED_GATE:
		error("gate_C::fast_forward_implication: undefined gate found");
	}//switch
   if (gate_e == FANOUT)
	{
	if (bad_value_e != VAL_X)
	   {forall(gate_output_p,*output_p)
		{
		if (gate_output_p->get_bad_value() == VAL_X)
			{
			gate_output_p->set_bad_value(bad_value_e);
			result_e = SUCCESS;
			}//if
		if ((gate_output_p->get_bad_value() != bad_value_e) && (ziel_line_p != gate_output_p))
			{
			inconsistent_gate_p = this;
			return(INCONSISTENT);
			}//if
		}}//forall
	}//if
   else if (bad_value_e != VAL_X)
	{
	if (gate_output_p->get_bad_value() == VAL_X)
		{
		gate_output_p->set_bad_value(bad_value_e);
		result_e = SUCCESS;
		}//if
	if ((gate_output_p->get_bad_value() != bad_value_e) && (ziel_line_p != gate_output_p))
		{
		inconsistent_gate_p = this;
		return(INCONSISTENT);
		}//if
	}//else if
   }//if
if (gate_e == FANOUT)
	{
	{forall(gate_output_p,*output_p)
		{
		if ((result_e == SUCCESS) && (gate_output_p->is_primary_output() == FALSE))
			res_e = gate_output_p->nachfolger()->gib_only_gate()->fast_forward_implication();
		if (res_e == INCONSISTENT)
			return(res_e);
		}}//forall
	return(result_e);
	}//if
if ((result_e == SUCCESS) && (gate_output_p->is_primary_output() == FALSE))
	res_e = gate_output_p->nachfolger()->gib_only_gate()->fast_forward_implication();
if (res_e == INCONSISTENT)
	return(INCONSISTENT);
return(result_e);
}//fast_forward_implication
