#ifndef line_liste_C_h
#define line_liste_C_h
#include "liste_C.h"
#ifdef FRAMEWORK
#include "cfidr.h"
#endif

//*********************************************************************
//
//   CLASS-NAME: line_liste_C Unterklasse von liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Linelisten und alle notwendigen
//	Operationen auf Linelisten.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port sowie ohne Argument
//			ohne Argumente => generische Liste
//		 Destruktor loescht Liste
//		 print_all: gibt Inhalt aller Listenelemente aus (DEBUG)
//		 fuege_ein: fuegt Element ein (siehe friends.h)
//		 fuege_aus: fuegt Element aus Liste aus (gate_C* Argument)
//		 element_in_liste: prueft, ob Element gate_C* in Liste ist
//		 next: gibt aktuelles Element von Liste aus (aktuell entspricht
//			aktual_no_i), wenn Liste geschlossen ist (closed_b == TRUE)
//			beim letzten Element wird Liste geoeffnet
//		 search: siehe friends.h
//		 verbinde: siehe friends.h
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class line_liste_C: public liste_C {
public:
   line_liste_C(){}
   line_liste_C(int listengroesse_i);
   void init(int size_i);
   void merge_list(line_liste_C*);
   void resize();
   ~line_liste_C(){delete[] liste_a;}
   line_C *operator [] (int i){return(liste_a[i]);}
   void print_all(ofstream& datei_F);
   void fuege_ein(line_C *line_item_p);
   void fuege_aus(line_C *line_item_p,boolean = FALSE);
   boolean element_in_liste(line_C *,boolean = FALSE);
   void verbinde(line_C *, int);
   line_C *gib_only_line();
   void change_connection(char *name_s,line_C *line_item_p);
#ifdef FRAMEWORK
   friend void cfidr_ConnectMacros(cfidrViewIdT);
#endif
private:
   line_C **liste_a;  // Liste mit Lines, die an den aktuellen Block
                     // angeschlossen sind.
};
#endif
