#include "line_value_liste_C.h"
#include "string_C.h"
#include "line_C.h"

extern line_value_liste_C hilf_C;
extern stat_t statistic_u;
extern line_value_liste_C zielfehler_C;
extern boolean stuck_open_test_b,transition_test_b;

void line_value_liste_C::init(int size_i)
{
liste_a = new line_value_t *[size_i];
if (liste_a == NULL)
	error("No more memory available");
max_elements_i = size_i;
for (int i=0;i<max_elements_i;i++)
	liste_a[i] = new line_value_t;
}//init

boolean line_value_liste_C::element_in_liste(line_C *line_item_p,value_t val_e,boolean fuege_aus_b)
{
int i=0;
line_value_t *ausgefuegtes_element_p;

for (;i < number_elements_i;i++)
   if ((liste_a[i]->line_p == line_item_p) && (liste_a[i]->val_e == val_e))
	if (fuege_aus_b == FALSE)
		return TRUE;
	else
		{
                ausgefuegtes_element_p = liste_a[i];
                break;
		}//else
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return FALSE;
liste_C::fuege_aus();
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}/*element_in_liste*/

line_value_t* line_value_liste_C::find_a_aequi_class_member(int i)
{
int j;
for (j=0 ; j < number_elements_i ; j++)
   if (((liste_a[j]->line_p->gib_aequiklass_at_0_nr_i() == i ) && (liste_a[j]->val_e == VAL_0))
       || ((liste_a[j]->line_p->gib_aequiklass_at_1_nr_i() == i ) && (liste_a[j]->val_e == VAL_1)))
		return this->liste_a[j];

return NULL;
}//find_a_aequi_class_member

void line_value_liste_C::fuege_ein(line_C *line_item_p,value_t val_e,boolean sort_b)
{
if ((this == &hilf_C) && (number_elements_i > max_elements_i/2) &&
    (element_in_liste(line_item_p,val_e) == TRUE))
	return;
liste_C::fuege_ein();
if (number_elements_i > max_elements_i)
        {
        int i;

	if (number_elements_i > statistic_u.number_lines_i + statistic_u.number_fanout_branches_i)
		error("line_value_liste_C::fuege_ein: Listen overflow");
        max_elements_i += 50;
        if (max_elements_i > 50)
                {
                line_value_t **tmp_p;

                tmp_p = new line_value_t *[max_elements_i-50];
                for (i=0;i<max_elements_i-50;i++)
                        tmp_p[i] = liste_a[i];
                delete[] liste_a;
                liste_a = new line_value_t *[max_elements_i];
                for (i=0;i<max_elements_i-50;i++)
                        liste_a[i] = tmp_p[i];
		delete[] tmp_p;
		}//if
        else
                liste_a = new line_value_t *[max_elements_i];
        for (i=max_elements_i-50;i<max_elements_i;i++)
                {
                liste_a[i] = new line_value_t;
                liste_a[i]->line_p = NULL;
                liste_a[i]->val_e = UNDEFINED_VALUE;
		}//for
	}//if
liste_a[number_elements_i - 1]->line_p = line_item_p;
liste_a[number_elements_i - 1]->val_e = val_e;
if ((this == &zielfehler_C) && (sort_b == TRUE))
   {	// sortiere Zielfehler Liste
   int upper_i=number_elements_i-1,lower_i=-1,middle_i=0;
   line_value_t *hilf_p;
   double prod_i,prod_mid_i;

   if (val_e == VAL_0)
     if ((stuck_open_test_b == FALSE) && (transition_test_b == FALSE))
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby();
     else
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby() - 1.0;
   else if (val_e == VAL_1)
     if ((stuck_open_test_b == FALSE) && (transition_test_b == FALSE))
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby();
     else
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby() - 1.0;
   else if (val_e == VAL_U0)
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_zero_contby();
   else if (val_e == VAL_U1)
	prod_i = line_item_p->gib_observaby() * line_item_p->gib_one_contby();
   else
	prod_i = line_item_p->gib_testaby();
   hilf_p = liste_a[number_elements_i-1];
   while (lower_i < upper_i - 1)
   	{
   	middle_i = (upper_i+lower_i)/2;
	if (liste_a[middle_i]->val_e == VAL_0)
		prod_mid_i = liste_a[middle_i]->line_p->gib_observaby() * liste_a[middle_i]->line_p->gib_zero_contby();
	else if (liste_a[middle_i]->val_e == VAL_1)
		prod_mid_i = liste_a[middle_i]->line_p->gib_observaby() * liste_a[middle_i]->line_p->gib_one_contby();
	else
		prod_mid_i = liste_a[middle_i]->line_p->gib_testaby();
	if (prod_i > prod_mid_i)
   		lower_i = middle_i;
   	else
   		upper_i = middle_i;
   	}//while
   for (middle_i=number_elements_i-1;middle_i>upper_i;middle_i--)
   	liste_a[middle_i] = liste_a[middle_i-1];
   liste_a[upper_i] = hilf_p;
   }//if
return;
}/*fuege_ein*/

void line_value_liste_C::fuege_aus(line_C *line_item_p,value_t val_e)
{
int i;
line_value_t *ausgefuegtes_element_p;

liste_C::fuege_aus();
if ((liste_a[number_elements_i]->line_p == line_item_p) && (liste_a[number_elements_i]->val_e == val_e))
	return;
for (i=0;i <= number_elements_i;i++)
	if ((liste_a[i]->line_p == line_item_p) && (liste_a[i]->val_e == val_e))
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/
