#include "liste_C.h"
#include "string_C.h"
#include "modify.h"

//*********************************************************************
//
//   CLASS-NAME: liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Listen und alle notwendigen
//	Operationen auf Listen.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port_t sowie ohne Argument
//			2. Konstruktor definiert generische Listen (erweiterbar)
//		 Destruktor loescht connected_to_a array
//		 fuege_ein: fuegt in generische Listen ein Element ein
//		 print_all: gibt Inhalt der Listenelemente aus
//		 fuege_aus: fuegt Element in Liste aus
//		 reset_liste: setzt closed_b flag auf TRUE und spult an den
//			Anfang der Liste zurueck
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
liste_C::liste_C()
{
number_elements_i = 0;
generisch_b = TRUE;
max_elements_i = 0;
}//liste_C

liste_C::liste_C(int listengroesse_i)
{
generisch_b = FALSE;
number_elements_i = 0;
max_elements_i = listengroesse_i;
}//liste_C

void liste_C::fuege_ein()
{
if (generisch_b == FALSE)
	error("fuege_ein: not allowed for non-generic lists");
number_elements_i++;
}//fuege_ein

void liste_C::print_all(ofstream& datei_F)
{
datei_F << "\t" << "Anzahl Elemente:   " << number_elements_i << "\n";
#ifndef OPT_SPACE
//for (int i=0;i<number_elements_i;i++)
//datei_F << "\t" << "connected_to[" << i << "]:   " << connected_to_a[i] << "\n";
#endif
}//print_all

void liste_C::fuege_aus()
{
if (number_elements_i == 0)
	error("fuege_aus:  list is empty");
if (generisch_b == FALSE)
	error("fuege_aus: not allowed for non-generic lists");
number_elements_i--;
}//fuege_aus

boolean liste_C::is_empty()
{
return((number_elements_i == 0)?TRUE:FALSE);
}//is_empty
