#ifndef liste_C_h
#define liste_C_h
#include "consts.h"
#include "prot.h"

//*********************************************************************
//
//   CLASS-NAME: liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Listen und alle notwendigen
//	Operationen auf Listen.
//
//   OPERATOREN: keine
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer und port_t sowie ohne Argument
//			2. Konstruktor definiert generische Listen (erweiterbar)
//		 Destruktor loescht connected_to_a array
//		 fuege_ein: fuegt in generische Listen ein Element ein
//		 print_all: gibt Inhalt der Listenelemente aus
//		 fuege_aus: fuegt Element in Liste aus
//		 reset_liste: setzt closed_b flag auf TRUE und spult an den
//			Anfang der Liste zurueck
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class liste_C {
public:
   liste_C();
   liste_C(int listengroesse_i);
   ~liste_C()
	{
#ifndef OPT_SPACE
	delete[] connected_to_a;
#endif
	}
   void del_conn_to()
	{
#ifndef OPT_SPACE
	delete[] connected_to_a;
#endif
	}
   void fuege_ein();
   void print_all(ofstream& datei_F);
   void fuege_aus();
   boolean is_empty();
   int no_elements(){return(number_elements_i);}
   void loesche_liste(){number_elements_i = 0;}
protected:
   boolean generisch_b;
   int number_elements_i; // Anzahl der Elemente in der Liste
   int max_elements_i;
};
#endif
