//*********************************************************************
//
//   FILE-NAME: main.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet das Hauptprogramm
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
// #define clock_t long
#include "extern.h"
#include "definitions.h"
#include "prot.h"
#include "protocol_stack_C.h"
#include "objective_liste_C.h"
#include "line_value_liste_C.h"
#include "line_line_liste_C.h"
#include "line_C.h"
#include "gate_C.h"
#include "modify.h"
#ifdef FRAMEWORK
#include "cfidr.h"
#include "cfidrprototypes.h"
#endif
#include <sys/types.h>
#include <asm/param.h>

	// Prototypen
extern void gib_redundanz_aborted_klassen_anzahl();
extern void read_circuit();
extern void transform_circuit();
extern void praeprocessing(boolean);
extern void test_circuit();
extern void simulate_circuit();
//extern void check_implication();
extern void proof();
extern void set_time();
extern void add_time(clock_t&);
void nachanalyse();
void listen_init();
#ifdef FRAMEWORK
cfidrViewIdT cfidr_ReadCircuit(char*,char*,char*);
void write_circuit();
#endif
extern "C" void __PC0__PCSTART();
extern "C" void __PC0__PCEXIT();

gate_liste_C blocks_C;
gate_liste_C tested_blocks_C;
extern line_liste_C lines_C;
//extern boolean read_edif_called_b;
extern line_liste_C input_lines_C;
extern line_liste_C output_lines_C;
extern line_liste_C pseudo_inputs_C;
extern line_liste_C pseudo_outputs_C;
extern gate_liste_C gates_C;
extern protocol_stack_C protocol_C;
extern objective_liste_C current_objectives_C;
extern objective_liste_C head_objectives_C;
extern objective_liste_C fanout_objectives_C;
extern gate_liste_C tmp_gate_liste_C;
extern gate_liste_C selected_path_C;
extern line_liste_C unjustified_bound_line_C;
extern line_liste_C unjustified_free_line_C;
extern line_liste_C d_front_C;
extern line_liste_C implication_line_C;
extern line_liste_C tmp_line_liste_C;
extern line_liste_C hilf_imp_line_C;
extern line_value_liste_C zielfehler_C;
extern line_value_liste_C hilf_C;
extern line_line_liste_C zielfehler2_C;
extern line_liste_C free_lines_C;
extern line_liste_C off_path_signals_C;
extern line_liste_C off_path_signals_save_C;
extern line_liste_C off_path_signals_tmp_C;
extern line_liste_C red_abo_liste_C; //Eb!!!30.6

extern int no_red_classes_i;
extern int no_non_robust_pattern_i;
extern int no_testpattern_i;
extern int no_weak_tests_i;
extern int no_redundant_path_i;
extern int no_aborted_path_i;
extern int max_number_backtracks_i;
extern int inits_i,tests_i;
extern int nr_redFaults;
extern long cpu_tpg_l;
extern long cpu_fs_l;
extern long cpu_sons_l;
long cpu_prae_l;
extern int backtrack_counter_i;
extern int reject_counter_i;
extern boolean only_iddq_test_b;
extern boolean use_3_phases_b;
extern boolean only_stuck_at_test_b;
extern boolean stuck_at_test_without_branches_b;
extern boolean path_delay_test_b;
extern boolean transition_test_b;
extern boolean stuck_open_test_b;
extern boolean iddq_stuck_on_test_b;
extern boolean bridging_iddq_b;
extern boolean bridging_b;
extern boolean hazard_test_ein_b;
int aequivalenzen_zahl_i = 0; //Eb!!!30.6
int redundanz_klassen_zahl_i;
int aborted_klassen_zahl_i;

void milef_syntax()
{
#ifdef FRAMEWORK
cout << "\n\nCalling Syntax of MILEF:\n";
cout << "Please use milef <library_name> <cell_name> <view_name> <number_of_backtracks> <fault_model>\n";
cout << "No parameter is optional, all parameters are required\n\n";
cout << "For the number of backtracks you can use any";
cout << " integer value\n10 is recommended\n\nThe following fault models are supported:\n\t";
cout << "IDDQ: Stuck-at fault model, overcurrent measurement\n\tSTUCK_AT: Simple stuck-at fault model";
cout << "\n\tSTUCK_AT_WITHOUT_BRANCHES: Stuck-at without generating tests for fanout branches";
cout << "\n\tSTUCK_ON: Stuck_on fault model with overcurrent detection\n\t";
cout << "TRANSITION: Switching and observing a simple transition at every signal of the circuit\n\t";
cout << "STUCK_OPEN: The Stuck-open fault model switching single input transistions at primitive gates\n\t";
cout << "BRIDGING_IDDQ: Bridging faults with overcurrent detection\n\t";
cout << "BRIDGING: Bridging fault detection with propagation\n\t";
cout << "PATH_DELAY: Path delay fault model switching single paths\n";
#else
cout << "\n\nCalling Syntax of MILEF:\n";
cout << "Please use milef <circuit_name> <number_of_backtracks> <fault_model> <2phases or fault_simu>\n";
cout << "Only the last parameter is optional, the first three parameters are required\n\n";
cout << "A circuit name must end with:\n\t.cir: when it is described on gate-level\n\t";
cout << ".net: if it is a spice netlist\n\nFor the number of backtracks you can use any";
cout << " integer value\n10 is recommended\n\nThe following fault models are supported:\n\t";
cout << "IDDQ: Stuck-at fault model, overcurrent measurement\n\tSTUCK_AT: Simple stuck-at fault model";
cout << "\n\tSTUCK_AT_WITHOUT_BRANCHES: Stuck-at without generating tests for fanout branches";
cout << "\n\tSTUCK_ON: Stuck_on fault model with overcurrent detection\n\t";
cout << "TRANSITION: Switching and observing a simple transition at every signal of the circuit\n\t";
cout << "STUCK_OPEN: The Stuck-open fault model switching single input transistions at primitive gates\n\t";
cout << "BRIDGING_IDDQ: Bridging faults with overcurrent detection\n\t";
cout << "BRIDGING: Bridging fault detection with propagation\n\t";
cout << "PATH_DELAY: Path delay fault model switching single paths\n";
cout << "\nIf the last parameter is '2phases' the third phase of test generation will not be executed\n";
cout << "If the last parameter is 'fault_simu', only fault simulation is performed with the pattern file\n";
cout << "\t\t\t<circuit_name>.pat\n";
#endif
cout << "\nFor further information look into README and the manual\n\n\n";
cout << "HAPPY TEST GENERATION USING MILEF\n\n";
exit(0);
}//milef_syntax
//*********************************************************************
//
//   FUNCTION-NAME: main
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Hautprogramm: Aufruf von read_circuit, praeprocessing,
//	compute_contby, compute_observaby und fan_alg
//
//   FORMAL PARAMETERS: argc, argv: Schaltungsname kann uebergeben werden
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void mmain(int argc,char *argv[])
{
int stat_level_i = 1;
boolean fault_simu_only_b = FALSE;
#ifdef FRAMEWORK
cfidrViewIdT cfidrViewID;
cfidrErrorT cfidrError;
cfidrStringT cfidrString;
#endif

statistic_u.number_gates_i = 0;
statistic_u.number_or_gates_i = 0;
statistic_u.number_and_gates_i = 0;
statistic_u.number_nand_gates_i = 0;
statistic_u.number_nor_gates_i = 0;
statistic_u.number_exor_gates_i = 0;
statistic_u.number_drivers_i = 0;
statistic_u.number_inverters_i = 0;
statistic_u.number_flipflops_i = 0;
statistic_u.number_blocks_i = 0;
statistic_u.number_lines_i = 0;
statistic_u.number_inputs_i = 0;
statistic_u.number_outputs_i = 0;
statistic_u.number_fanouts_i = 0;
statistic_u.number_fanout_branches_i = 0;
statistic_u.feedback_b = FALSE;
lines_C.init(max_number_lines_i);
input_lines_C.init(max_number_lines_i);
output_lines_C.init(max_number_lines_i);
gates_C.init(max_number_gates_i);
cout << "Automatic Test Pattern Generation with MILEF (MIxed LEvel FAN)\n\n";
cout << "\t\tMILEF Version 2.2 May 1994\n\t\t  written by Uwe Glaeser at GMD";
cout << "\n\t\t  please send bug reports to glaeser@borneo.gmd.de";
cout << "\n\t\tMILEF includes:" << flush;
//__PC0__PCSTART();
init_ctest();
#ifdef FRAMEWORK
if ((argc > 1) && (strcasecmp(argv[1],"write") == 0))
	{
	if (argc >= 3)
	        strcpy(schaltungsname_s,argv[2]);
	else
	   milef_syntax();
	read_circuit();
	write_circuit();
	}//if
if (argc < 6)
   milef_syntax();
if (argc >= 4)
	strcpy(schaltungsname_s,argv[2]);
else
	strcpy(schaltungsname_sC,"NO_CIRCUIT");
if (argc > 4)
	max_number_backtracks_i = atoi(argv[4]);
else
	max_number_backtracks_i = 10;
if (argc > 5)
	if (strncasecmp(argv[5],"IDDQ",4) == 0)
		only_iddq_test_b = TRUE;
	else if (strncasecmp(argv[5],"STUCK_AT",8) == 0)
		{
		only_stuck_at_test_b = TRUE;
		if (strncasecmp(argv[5],"STUCK_AT_WITHOUT_BRANCHES",25) == 0)
			stuck_at_test_without_branches_b = TRUE;
		}//else if
	else if (strncasecmp(argv[5],"PATH_DELAY",10) == 0)
		path_delay_test_b = TRUE;
	else if (strncasecmp(argv[5],"TRANSITION",10) == 0)
		transition_test_b = TRUE;
	else if (strncasecmp(argv[5],"STUCK_OPEN",10) == 0)
		stuck_open_test_b = TRUE;
	else if (strncasecmp(argv[5],"STUCK_ON",10) == 0)
		iddq_stuck_on_test_b = TRUE;
	else if (strncasecmp(argv[5],"BRIDGING_IDDQ",13) == 0)
		bridging_iddq_b = TRUE;
	else if (strncasecmp(argv[5],"BRIDGING",10) == 0)
		bridging_b = TRUE;
	else
		{
		transition_test_b = TRUE;
		warning("Fault Model set to Multiple-input-Transition");
		}//else
else
	only_iddq_test_b = FALSE;
if (argc > 6)
   if (strncasecmp(argv[6],"2PHASES",7) == 0)
      use_3_phases_b = FALSE;
   else if (strncasecmp(argv[6],"FAU",3) == 0)
      fault_simu_only_b = TRUE;
   else if (strncasecmp(argv[6],"ONL",3) == 0)
      fault_simu_only_b = TRUE;
   else
      milef_syntax();
cfidrViewID = cfidr_ReadCircuit(argv[1],argv[2],argv[3]);
#else
if (argc >= 2)
	strcpy(schaltungsname_s,argv[1]);
else
   milef_syntax();
if (argc > 2)
	max_number_backtracks_i = atoi(argv[2]);
else
   milef_syntax();
if (argc > 3)
	if (strncasecmp(argv[3],"IDDQ",4) == 0)
		only_iddq_test_b = TRUE;
	else if (strncasecmp(argv[3],"STUCK_AT",8) == 0)
		{
		only_stuck_at_test_b = TRUE;
		if (strncasecmp(argv[3],"STUCK_AT_WITHOUT_BRANCHES",25) == 0)
			stuck_at_test_without_branches_b = TRUE;
		}//else if
	else if (strncasecmp(argv[3],"PATH_DELAY",10) == 0)
		path_delay_test_b = TRUE;
	else if (strncasecmp(argv[3],"TRANSITION",10) == 0)
		transition_test_b = TRUE;
	else if (strncasecmp(argv[3],"STUCK_OPEN",10) == 0)
		stuck_open_test_b = TRUE;
	else if (strncasecmp(argv[3],"STUCK_ON",8) == 0)
		iddq_stuck_on_test_b = TRUE;
	else if (strncasecmp(argv[3],"BRIDGING_IDDQ",13) == 0)
		bridging_iddq_b = TRUE;
	else if (strncasecmp(argv[3],"BRIDGING",10) == 0)
		bridging_b = TRUE;
	else
		{
		transition_test_b = TRUE;
		warning("Fault Model set to Multiple-input-Transition");
		}//else
else
   milef_syntax();
if (argc > 4)
   if (strncasecmp(argv[4],"2PHASES",7) == 0)
      use_3_phases_b = FALSE;
   else if (strncasecmp(argv[4],"3PHASES",7) == 0)
      use_3_phases_b = TRUE;
   else if (strncasecmp(argv[4],"FAU",3) == 0)
      fault_simu_only_b = TRUE;
   else if (strncasecmp(argv[4],"ONL",3) == 0)
      fault_simu_only_b = TRUE;
   else
      milef_syntax();
read_circuit();
#endif
lambda_f = 100.0 / (double(statistic_u.number_gates_i) * double(statistic_u.number_gates_i));
transform_circuit();
set_time();
listen_init();
//if (strcmp(schaltungsname_s,"IMPLICATIONCHECK")
//	{
//	check_implication();
//	exit(0);
//	}//if
cout << "Check_Circuit\n" << flush;
proof();
cout << "Preprocessing\n" << flush;
praeprocessing(fault_simu_only_b);
add_time(cpu_prae_l);
if (fault_simu_only_b == TRUE)
   cout << "Simulate ";
else
   cout << "Test ";
if (only_iddq_test_b == TRUE)
	cout << "Circuit for IDDQ-measurement\n" << flush;
else if (only_stuck_at_test_b == TRUE)
	if (stuck_at_test_without_branches_b == TRUE)
		cout << "Circuit for Stuck-at Faults without testing Fanout Branches\n" << flush;
	else
		cout << "Circuit for Stuck-at Faults\n" << flush;
else if (path_delay_test_b == TRUE)
	cout << "Circuit for Path Delay faults\n" << flush;
else if (transition_test_b == TRUE)
	cout << "Circuit for Transition faults without robustness checks\n" << flush;
else if (stuck_open_test_b == TRUE)
	cout << "Circuit for Stuck-open faults\n" << flush;
else if (iddq_stuck_on_test_b == TRUE)
	cout << "Circuit for Stuck-on faults with IDDQ\n" << flush;
else if (bridging_iddq_b == TRUE)
	cout << "Circuit for Bridging faults with IDDQ\n" << flush;
else if (bridging_b == TRUE)
	cout << "Circuit for Bridging faults with Voltage based detection\n" << flush;
else	
	cout << "Circuit for Transition faults\n" << flush;
if (fault_simu_only_b == TRUE)
   simulate_circuit();
else
   test_circuit();
// cout << "Print Debug Data\n" << flush; 
// print_all();

#ifdef FRAMEWORK
cfidrViewSave(cfidrViewID, &cfidrError);
if (cfidrError != CFIDR_NO_ERROR)
	{
	cfidrString = cfidrPIGetErrorText(cfidrError, &cfidrError);
	error (cfidrString);
	}/*if*/

	cout << " Close Database \n" << flush;
cfidrPIQuit(&cfidrError);   /* leave database */
if (cfidrError != CFIDR_NO_ERROR)
	{
	cfidrString = cfidrPIGetErrorText(cfidrError, &cfidrError);
	error (cfidrString);
	}/*if*/
#endif

if ((statistic_u.number_blocks_i > 0) && ((iddq_stuck_on_test_b == TRUE) || (stuck_open_test_b == TRUE)))
	print_mixed_statistic(&stat_level_i);
}

//*********************************************************************
//
//   FUNCTION-NAME: print_result
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Druckt das Ergebnis der Testmustergenerierung in das
//	<Schaltung>.stat File.
//
//   FORMAL PARAMETERS: void
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
void print_result()
{
int number_of_faults_i;
ifstream fliste_F;
ofstream datei_F,stat_F,red_F;
line_C *line_item_p;
boolean erfolg_b;
long min_i,sec_i,hou_i;
int no_redundant_i=0,no_aborted_i=0;
double fehlerueberdeckung_f;
long hilf_l;
static double robuste_fehlerueberdeckung_f = 0.0;
int total_i=0,unrobust_i=0,robust_i=0;

get_statistics(&total_i,&unrobust_i,&robust_i);
datei_F.open((char *)(string_C(schaltungsname_s) + ".stat"),ios::app);
red_F.open((char *)(string_C(schaltungsname_s) + ".red"));
stat_F.open((char *)("statistik"),ios::app);
stat_F << schaltungsname_s << "\t";
if (only_stuck_at_test_b == TRUE) gib_redundanz_aborted_klassen_anzahl(); //Eb!!!30.6
if ((path_delay_test_b == FALSE) && (bridging_iddq_b == FALSE) && (bridging_b == FALSE))
   {
   datei_F << "\n\n\nRedundant Faults (s_a_1 and s_a_0):\n";
   erfolg_b = FALSE;
   {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_0_untestable_b == TRUE) && (line_item_p->s_a_1_untestable_b == TRUE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
		red_F << "s-a-0 " << line_item_p->name_sC << "\n";
		red_F << "s-a-1 " << line_item_p->name_sC << "\n";
   		no_redundant_i+=2;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   datei_F << "\ns_a_0 Redundant Faults:\n";
   erfolg_b = FALSE;
   {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_0_untestable_b == TRUE) && (line_item_p->s_a_1_untestable_b == FALSE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
		red_F << "s-a-0 " << line_item_p->name_sC << "\n";
   		no_redundant_i++;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   datei_F << "\ns_a_1 Redundant Faults:\n";
   erfolg_b = FALSE;
   {
   forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_1_untestable_b == TRUE) && (line_item_p->s_a_0_untestable_b == FALSE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
		red_F << "s-a-1 " << line_item_p->name_sC << "\n";
   		no_redundant_i++;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   datei_F << "\n\n\nAborted Faults (s_a_1 and s_a_0):\n";
   erfolg_b = FALSE;
   {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_0_aborted_b == TRUE) && (line_item_p->s_a_1_aborted_b == TRUE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_aborted_i+=2;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   datei_F << "\n\n\ns_a_0 Aborted Faults:\n";
   erfolg_b = FALSE;
   {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_0_aborted_b == TRUE) && (line_item_p->s_a_1_aborted_b == FALSE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_aborted_i++;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   datei_F << "\n\n\ns_a_1 Aborted Faults:\n";
   erfolg_b = FALSE;
   {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_1_aborted_b == TRUE) && (line_item_p->s_a_0_aborted_b == FALSE))
   		{
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_aborted_i++;
   		}//if
   }
   if (erfolg_b == FALSE)
   	datei_F << "none\n";
   if ((only_iddq_test_b == FALSE) && (only_stuck_at_test_b == FALSE) && (iddq_stuck_on_test_b == FALSE))
      {
      datei_F << "\n\n\nrising Redundant Faults:\n";
      erfolg_b = FALSE;
      {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_0_aborted_b == FALSE) && (line_item_p->s_a_0_untestable_b == FALSE) &&
	    (line_item_p->rising_untestable_b == TRUE))
   		{
		if ((stuck_open_test_b == TRUE) && ((line_item_p->is_primary_output() == TRUE) ||
						    ((*line_item_p->nachfolger())[0]->gib_type() == BLOCK) ||
						    ((*line_item_p->nachfolger())[0]->no_inputs() < 2)))
		    continue;
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_redundant_i++;
   		}//if
      }
      if (erfolg_b == FALSE)
   	datei_F << "none\n";
      datei_F << "\n\n\nfalling Redundant Faults:\n";
      erfolg_b = FALSE;
      {forall(line_item_p,lines_C)
   	if ((line_item_p->s_a_1_untestable_b == FALSE) && (line_item_p->s_a_1_aborted_b == FALSE) &&
	    (line_item_p->falling_untestable_b == TRUE))
   		{
		if ((stuck_open_test_b == TRUE) && ((line_item_p->is_primary_output() == TRUE) ||
						    ((*line_item_p->nachfolger())[0]->gib_type() == BLOCK) ||
						    ((*line_item_p->nachfolger())[0]->no_inputs() < 2)))
		    continue;
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_redundant_i++;
   		}//if
      }
      if (erfolg_b == FALSE)
   	datei_F << "none\n";
      datei_F << "\n\n\nrising Aborted Faults:\n";
      erfolg_b = FALSE;
      {forall(line_item_p,lines_C)
   	if (((line_item_p->s_a_1_untestable_b == FALSE) && (line_item_p->s_a_0_untestable_b == FALSE) &&
   	     (line_item_p->rising_test_b == FALSE) && (line_item_p->s_a_1_untestable_b == FALSE) &&
   	     (line_item_p->s_a_0_untestable_b == FALSE) && (line_item_p->rising_untestable_b == FALSE)) ||
	    (line_item_p->rising_non_robust_b == TRUE))
		{
		if (((stuck_open_test_b == TRUE) || (transition_test_b == TRUE)) && 
		    ((line_item_p->is_primary_output() == TRUE) ||
		     ((*line_item_p->nachfolger())[0]->gib_type() == BLOCK) ||
		     ((*line_item_p->nachfolger())[0]->no_inputs() < 2)))
		    continue;
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_aborted_i++;
   		}//if
      }
      if (erfolg_b == FALSE)
   	datei_F << "none\n";
      datei_F << "\n\n\nfalling Aborted Faults:\n";
      erfolg_b = FALSE;
      {forall(line_item_p,lines_C)
   	if (((line_item_p->s_a_1_aborted_b == FALSE) && (line_item_p->s_a_0_aborted_b == FALSE) &&
   	     (line_item_p->falling_test_b == FALSE) && (line_item_p->s_a_1_untestable_b == FALSE) &&
   	     (line_item_p->s_a_0_untestable_b == FALSE) && (line_item_p->falling_untestable_b == FALSE)) ||
	    (line_item_p->falling_non_robust_b == TRUE))
   		{
		if (((stuck_open_test_b == TRUE) || (transition_test_b == TRUE)) && 
		    ((line_item_p->is_primary_output() == TRUE) ||
		     ((*line_item_p->nachfolger())[0]->gib_type() == BLOCK) ||
		     ((*line_item_p->nachfolger())[0]->no_inputs() < 2)))
		    continue;
   		erfolg_b = TRUE;
   		datei_F << line_item_p->name_sC << "\n";
   		no_aborted_i++;
   		}//if
      }
      if (erfolg_b == FALSE)
   	datei_F << "none\n";
      }//if
   datei_F << "\n\n\nThe other lines were tested with regard to the fault model\n";
   }//if
else
   {
   no_aborted_i = no_aborted_path_i;
   no_redundant_i = ((bridging_iddq_b == FALSE) && (bridging_iddq_b == FALSE))?no_redundant_path_i:no_red_classes_i;
   if ((bridging_iddq_b == TRUE) || (bridging_b == TRUE))
	 {
	 line_line_C *lili_p;

	 no_aborted_i = 0;
	 no_redundant_i = 0;
	 datei_F << "\n\n\nRedundant Faults:\n";
	 erfolg_b = FALSE;
	 forall(lili_p,zielfehler2_C)
	       {
	       if (lili_p->is_redundant() == TRUE)
		  {
		  datei_F << lili_p->line1_p->name_sC << "  <-->  " << lili_p->line2_p->name_sC << "\n";
		  erfolg_b = TRUE;
		  no_redundant_i++;
		  }//if
	       }//forall
	 if (erfolg_b == FALSE)
   	       datei_F << "none\n";
	 datei_F << "\n\n\nAborted Faults:\n";
	 erfolg_b = FALSE;
	 {forall(lili_p,zielfehler2_C)
	       {
	       if (lili_p->is_aborted() == TRUE)
		  {
		  datei_F << lili_p->line1_p->name_sC << "  <-->  " << lili_p->line2_p->name_sC << "\n";
		  erfolg_b = TRUE;
		  no_aborted_i++;
		  }//if
	       }}//forall
	 if (erfolg_b == FALSE)
   	       datei_F << "none\n";
	 datei_F << "\n\n\nThe other lines were tested with regard to the fault model\n";
	 }//if
   }//else
   
if (reject_counter_i > 0)
	{
	datei_F << "\n\n\nNumber of CTEST/MILEF Backtracks:  " <<  reject_counter_i << "\n";
	cout << "Number of CTEST/MILEF Backtracks:  " <<  reject_counter_i << "\n";
	}//if

if (only_stuck_at_test_b == TRUE)
	{
	datei_F << "\n\n\nNumber of Equivalent Classes : "<< aequivalenzen_zahl_i << "\n";
	cout << "Number of Equivalent Classes : "<< aequivalenzen_zahl_i << "\n";
	}//if
datei_F << "Number of Backtracks:  " <<  backtrack_counter_i << "\n";
cout << "Number of Backtracks:  " <<  backtrack_counter_i << "\n";
stat_F << backtrack_counter_i << "\t";

if (bridging_b == TRUE)
      {
      datei_F << "Number of Electric Untestable Faults:  " <<  nr_redFaults << "\n";
      cout << "Number of Electric Untestable Faults:  " <<  nr_redFaults  << "\n";
      }//if
datei_F << "Number of Redundancies:  " <<  no_redundant_i + nr_redFaults << "\n";
cout << "Number of Redundancies:  " <<  no_redundant_i + nr_redFaults << "\n";
if (only_stuck_at_test_b == TRUE)
	{
	datei_F << "Number of Redundant Classes : " << redundanz_klassen_zahl_i << "\n";
	cout << "Number of Redundant Classes : " << redundanz_klassen_zahl_i << "\n";
	}//if
#if DEBUG
datei_F << "Number of FAN-Aufrufe mit Ergebnis redundant: " << no_red_classes_i << "\n";
cout << "Number of FAN-Aufrufe mit Ergebnis redundant: " << no_red_classes_i << "\n";
#endif
stat_F << no_redundant_i << "\t";

datei_F << "Number of Aborted Faults:  " <<  no_aborted_i << "\n";
cout << "Number of Aborted Faults:  " <<  no_aborted_i << "\n";
if (only_stuck_at_test_b == TRUE)
	{
	datei_F << "Number of Aborted Classes : " << aborted_klassen_zahl_i << "\n";
	cout << "Number of Aborted Classes : " << aborted_klassen_zahl_i << "\n";
	}//if
stat_F << no_aborted_i << "\t";

datei_F << "Number of Robust Patterns:  " <<  no_testpattern_i << "\n";
cout << "Number of Robust Patterns:  " <<  no_testpattern_i << "\n";
stat_F << no_testpattern_i;

if ((only_iddq_test_b == FALSE) && (only_stuck_at_test_b == FALSE) && (path_delay_test_b == FALSE) &&
    (bridging_iddq_b == FALSE) && (bridging_b == FALSE) && (iddq_stuck_on_test_b == FALSE) && 
    (transition_test_b == FALSE))
   {
   datei_F << "Number of non robust patterns:  " <<  no_non_robust_pattern_i << "\n";
   cout << "Number of non robust patterns:  " <<  no_non_robust_pattern_i << "\n";
   stat_F << "+" << no_non_robust_pattern_i;
   cout << "Number of Inits:  " << inits_i << "\n";
   cout << "Number of Tests:  " << tests_i << "\n";
   datei_F << "Number of Inits:  " << inits_i << "\n";
   datei_F << "Number of Tests:  " << tests_i << "\n";
   }//if
else if (no_weak_tests_i>0)
   stat_F << "+0";

if (no_weak_tests_i>0)
	{
	datei_F << "Number of weak Tests:  " <<  no_weak_tests_i << "\n";
	cout << "Number of weak Tests:  " <<  no_weak_tests_i << "\n";
	stat_F << "+" << no_weak_tests_i;
	}//if

stat_F << "\t";
if (path_delay_test_b == FALSE)
   {
   if ((bridging_iddq_b == TRUE) || (bridging_b == TRUE))
      {
      fliste_F.open((char*)(string_C(schaltungsname_s) + ".BF_flt"));
      if (!fliste_F)
	 fehlerueberdeckung_f = double(no_aborted_i * 2) / double(statistic_u.number_lines_i * statistic_u.number_lines_i - statistic_u.number_lines_i);
      else
	 {
	 number_of_faults_i = zielfehler2_C.no_elements() + nr_redFaults;
	 fehlerueberdeckung_f = double(no_aborted_i * 2) / double(number_of_faults_i * number_of_faults_i - number_of_faults_i);
	 }//else
      fliste_F.close();
      }//if
   else if (stuck_at_test_without_branches_b == FALSE)
	fehlerueberdeckung_f = double(no_aborted_i) / double(2 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i));
   else
	fehlerueberdeckung_f = double(no_aborted_i) / double(2 * statistic_u.number_lines_i);
   fehlerueberdeckung_f = 100.0 - fehlerueberdeckung_f * 100.0;
   if (hazard_test_ein_b == TRUE)
	{
	robuste_fehlerueberdeckung_f = double(no_aborted_i + no_redundant_i) / double(2 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i));
	robuste_fehlerueberdeckung_f = 100.0 - robuste_fehlerueberdeckung_f * 100.0;
	}//if
   }//if
else
   fehlerueberdeckung_f = double(no_testpattern_i * 100) / double(no_aborted_i + no_redundant_i +
								no_testpattern_i);

if (((stuck_open_test_b == TRUE) || (iddq_stuck_on_test_b == TRUE)) && (statistic_u.number_blocks_i > 0))
	{
	cout << "robust fault-coverage in complex gates: " << double(robust_i * 10000/total_i)/100 << "%\n";
	datei_F << "robust fault-coverage in complex gates: " << double(robust_i * 10000/total_i)/100 << "%\n";
	cout << "non-robust fault-coverage in complex gates: " << double((robust_i + unrobust_i) * 10000/total_i)/100 << "%\n";
	datei_F << "non-robust fault-coverage in complex gates: " << double((robust_i + unrobust_i) * 10000/total_i)/100 << "%\n";
	}//if
if (only_stuck_at_test_b == TRUE)
	{
	datei_F << "Fault Coverage:  " <<  double(100.0 - (double(aborted_klassen_zahl_i + redundanz_klassen_zahl_i) / double(aequivalenzen_zahl_i) * 100.0)) << " %\n";
	cout << "Fault Coverage:  " <<  100.0 - (double(aborted_klassen_zahl_i + redundanz_klassen_zahl_i) / double(aequivalenzen_zahl_i) * 100.0) << " %\n";
	datei_F << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	cout << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	stat_F << double(int(fehlerueberdeckung_f*10))/10 << "%\t";
	redundanz_klassen_zahl_i = 0;
	aborted_klassen_zahl_i = 0;
	}//if
else if ((bridging_iddq_b == TRUE) || (bridging_b == TRUE))
	{
	fliste_F.open((char*)(string_C(schaltungsname_s) + ".BF_flt"));
   	if (!fliste_F)
	   {
//	   double fc_f = 1.0 - double((no_aborted_i + no_redundant_i) * 2) / double(statistic_u.number_lines_i * statistic_u.number_lines_i - statistic_u.number_lines_i);
//	   fc_f *= 100;
//	   datei_F << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
//	   cout << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
//	   datei_F << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
//	   cout << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
//	   stat_F << double(int(fehlerueberdeckung_f*10))/10 << "%\t";

	   number_of_faults_i = zielfehler2_C.no_elements();
	   double fc_f = double((number_of_faults_i - (no_aborted_i + no_redundant_i)) / double(number_of_faults_i + nr_redFaults)) * 100.0;
	   datei_F << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
	   cout << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
	   datei_F << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	   cout << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	   stat_F << double(int(fehlerueberdeckung_f*10))/10 << "%\t";

	   }//if
	else
	   {
	   number_of_faults_i = zielfehler2_C.no_elements() + nr_redFaults;
	   double fc_f = double((number_of_faults_i - (no_aborted_i + no_redundant_i)) / double(number_of_faults_i)) * 100.0;
	   datei_F << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
	   cout << "Fault Coverage:  " << int(fc_f * 100.0) / 100.0 << " %\n";
	   datei_F << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	   cout << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	   stat_F << double(int(fehlerueberdeckung_f*10))/10 << "%\t";
	   }//else
	}//elif
else if (path_delay_test_b == FALSE)
	{
	if (stuck_open_test_b == TRUE)
		{
		datei_F << "robust Fault Coverage:  " << robuste_fehlerueberdeckung_f << "% \n";
		cout << "robust Fault Coverage:  " << robuste_fehlerueberdeckung_f << " %\n";
		}//if
	datei_F << "Fault Coverage:  " <<  double(100.0 - (double(no_aborted_i + no_redundant_i) / double(2.0 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i)) * 100.0)) << " %\n";
	cout << "Fault Coverage:  " <<  100.0 - (double(no_aborted_i + no_redundant_i) / double(2.0 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i)) * 100.0) << " %\n";
	datei_F << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	cout << "Efficiency of Test generation:  " <<  fehlerueberdeckung_f << " %\n";
	stat_F << double(int(fehlerueberdeckung_f*10))/10 << "%\t";
	}//elif
else
	{
	datei_F << "Fault Coverage:  " << fehlerueberdeckung_f << " %\n";
	cout << "Fault Coverage:  " << fehlerueberdeckung_f << " %\n";
	}//else

sec_i = cpu_tpg_l / HZ;
hilf_l = cpu_tpg_l - sec_i * HZ;
min_i = sec_i / 60;
sec_i -= min_i * 60;
hou_i = min_i / 60;
min_i -= hou_i * 60;
datei_F << "\nCPU time for test generation:  ";
if (hou_i > 0)
	datei_F << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	datei_F << min_i << " min. : ";
datei_F << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";

cout << "CPU time for test generation:  ";
if (hou_i > 0)
	cout << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	cout << min_i << " min. : ";
cout << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";
stat_F << hou_i*3600+min_i*60+sec_i << "\t";

if (path_delay_test_b == FALSE)
   {
   sec_i = cpu_fs_l / HZ;
   hilf_l = cpu_fs_l - sec_i * HZ;
   min_i = sec_i / 60;
   sec_i -= min_i * 60;
   hou_i = min_i / 60;
   min_i -= hou_i * 60;
   datei_F << "\nCPU time for fault simulation:  ";
   if (hou_i > 0)
   	datei_F << hou_i << " h : ";
   if ((hou_i > 0) || (min_i > 0))
   	datei_F << min_i << " min. : ";
   datei_F << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";
   
   cout << "CPU time for fault simulation:  ";
   if (hou_i > 0)
   	cout << hou_i << " h : ";
   if ((hou_i > 0) || (min_i > 0))
   	cout << min_i << " min. : ";
   cout << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";
   stat_F << hou_i*3600+min_i*60+sec_i << "\n";
   }//if

sec_i = cpu_prae_l / HZ;
hilf_l = cpu_prae_l - sec_i * HZ;
min_i = sec_i / 60;
sec_i -= min_i * 60;
hou_i = min_i / 60;
min_i -= hou_i * 60;
datei_F << "\nCPU time for preprocessing:  ";
if (hou_i > 0)
	datei_F << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	datei_F << min_i << " min. : ";
datei_F << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";

cout << "CPU time for preprocessing:  ";
if (hou_i > 0)
	cout << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	cout << min_i << " min. : ";
cout << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";

sec_i = cpu_sons_l / HZ;
hilf_l = cpu_sons_l - sec_i * HZ;
min_i = sec_i / 60;
sec_i -= min_i * 60;
hou_i = min_i / 60;
min_i -= hou_i * 60;
datei_F << "\nCPU time for rest:  ";
if (hou_i > 0)
	datei_F << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	datei_F << min_i << " min. : ";
datei_F << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";

cout << "CPU time for rest:  ";
if (hou_i > 0)
	cout << hou_i << " h : ";
if ((hou_i > 0) || (min_i > 0))
	cout << min_i << " min. : ";
cout << sec_i << " sec. : " << hilf_l << " sec./" << HZ << "\n";
datei_F.close();
}//print_result

//*********************************************************************
//
//   FUNCTION-NAME: nachanalyse
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Arbeitet das Ergebnis der TPG auf.
//
//   FORMAL PARAMETERS: void
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: void
//
//   MODIFICATION-HISTORY: April 92 aborted auf FALSE setzen nicht mehr
//
//                         noetig,funktion prueft auf inkonsistenzen
//                         (allerdings nicht auf alle)
//
//
//*********************************************************************
void nachanalyse()
{
line_C *line_item_p;

forall(line_item_p,lines_C)
        {
	 if (line_item_p->s_a_0_aborted_b == TRUE)
		if (line_item_p->s_a_0_test_b == TRUE)
			cout << "fatal-Falsch aborted und getestet \n";

	if (line_item_p->s_a_1_aborted_b == TRUE)
		if (line_item_p->s_a_1_test_b == TRUE)
			cout << "fatal-Falsch aborted und getestet \n";

	if ((line_item_p->s_a_1_aborted_b == FALSE) && (line_item_p->s_a_1_untestable_b == FALSE)
		&& (line_item_p->s_a_1_test_b == FALSE))
			cout << "fatal-Falsch :Line nicht markiert \n";

	if ((line_item_p->s_a_0_aborted_b == FALSE) && (line_item_p->s_a_0_untestable_b == FALSE)
		&& (line_item_p->s_a_0_test_b == FALSE))
                        cout << "fatal-Falsch :Line nicht markiert \n";

	if ((line_item_p->s_a_0_aborted_b == FALSE) && (line_item_p->s_a_0_untestable_b == FALSE)
		&& (line_item_p->s_a_0_test_b == FALSE))
			cout << "fatal-Falsch:Line nicht markiert \n";

	if (((line_item_p->stuck_at_test_b == FALSE || line_item_p->test_done_b == FALSE))
		&& (line_item_p->s_a_1_test_b == TRUE) && (line_item_p->s_a_0_test_b == TRUE))
			cout << "fatal-Falsch:Line nicht als getestet markiert \n";
	}//forall
}//nachanalyse

void listen_init()
{
lines_C.resize();
//if (read_edif_called_b == FALSE)
//   {
   input_lines_C.resize();
   output_lines_C.resize();
//   }//if
gates_C.resize();
protocol_C.init();
current_objectives_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
head_objectives_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
fanout_objectives_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
tmp_gate_liste_C.init(statistic_u.number_gates_i);
selected_path_C.init(statistic_u.number_gates_i);
unjustified_bound_line_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
unjustified_free_line_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
d_front_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
implication_line_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
tmp_line_liste_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
hilf_imp_line_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
if ((stuck_open_test_b == FALSE) && (transition_test_b == FALSE) && 
    (bridging_iddq_b == FALSE) && (bridging_b == FALSE))
   zielfehler_C.init(2*(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i));
else if ((bridging_iddq_b == FALSE) && (bridging_b == FALSE))
   zielfehler_C.init(4*(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i));
else
   zielfehler2_C.init(statistic_u.number_lines_i * statistic_u.number_lines_i / 2);
if ((bridging_iddq_b == FALSE) && (bridging_b == FALSE))
   hilf_C.init(2*(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i));
free_lines_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
off_path_signals_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
off_path_signals_save_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
off_path_signals_tmp_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i);
red_abo_liste_C.init(statistic_u.number_lines_i+statistic_u.number_fanout_branches_i); //Eb!!!30.6
pseudo_inputs_C.init(statistic_u.number_lines_i+statistic_u.number_flipflops_i);
pseudo_outputs_C.init(statistic_u.number_lines_i+statistic_u.number_flipflops_i);
if (statistic_u.number_blocks_i > 0)
   {
   gate_C *gate_item_p;
   
   blocks_C.init(statistic_u.number_blocks_i);
   tested_blocks_C.init(statistic_u.number_blocks_i);
   forall(gate_item_p,gates_C)
	if (gate_item_p->gib_type() == BLOCK)
		blocks_C.fuege_ein(gate_item_p);
   }//if
}//listen_init
