#include "objective_liste_C.h"
#include "string_C.h"
#include "line_C.h"
#include "modify.h"

extern objective_liste_C fanout_objectives_C;

void objective_liste_C::init(int size_i)
{
liste_a = new objective_type_u *[size_i];
if (liste_a == NULL)
	error("No more memory available");
max_elements_i = size_i;
for(int i=0;i<size_i;i++)
	{
	liste_a[i] = new objective_type_u;
	if (liste_a[i] == NULL)
		error("No more memory available");
	}//for
}

objective_liste_C::~objective_liste_C()
{
for(int i=0;i<max_elements_i;i++)
	delete liste_a[i];
delete[] liste_a;
}

objective_type_u *objective_liste_C::pop()
{
number_elements_i--;
return(liste_a[number_elements_i]);
}//pop

void objective_liste_C::print_data()
{
ofstream datei_F("objective_liste");
for(int i = 0;i<number_elements_i;i++)
	{
	datei_F << liste_a[i]->line_p->get_name() << "  n0:";
	datei_F << liste_a[i]->n0_i << "  n1:";
	datei_F << liste_a[i]->n1_i << "\n";
	}//for
}//print_data

void objective_liste_C::fuege_ein(line_C *line_item_p,int no_0_i,int no_1_i)
{
liste_a[number_elements_i]->line_p = line_item_p;
liste_a[number_elements_i]->n0_i = no_0_i;
liste_a[number_elements_i]->n1_i = no_1_i;
if (this == &fanout_objectives_C)
   {
   int upper_i=number_elements_i,lower_i=-1,middle_i=0;
   objective_type_u *hilf_p;

   hilf_p = liste_a[number_elements_i];
   while (lower_i < upper_i - 1)
   	{
   	middle_i = (upper_i+lower_i)/2;
   	if ((liste_a[middle_i]->line_p->gib_plane_no() < line_item_p->gib_plane_no()) ||
   	    ((liste_a[middle_i]->line_p->gib_plane_no() == line_item_p->gib_plane_no()) &&
   	     (liste_a[middle_i]->line_p->gib_number() < line_item_p->gib_number())))
   		lower_i = middle_i;
   	else
   		upper_i = middle_i;
   	}//while
   for (middle_i=number_elements_i;middle_i>upper_i;middle_i--)
   	liste_a[middle_i] = liste_a[middle_i-1];
   liste_a[upper_i] = hilf_p;
   }//if
number_elements_i++;
}//fuege_ein

void objective_liste_C::fuege_aus(line_C *line_item_p)
{
int i;
objective_type_u * ausgefuegtes_element_p;

liste_C::fuege_aus();
if (liste_a[number_elements_i]->line_p == line_item_p)
	return;
for (i=0;i <= number_elements_i;i++)
	if (liste_a[i]->line_p == line_item_p)
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if (i > number_elements_i)
	error("fuege_aus: element not found in list");
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return;
}/*fuege_aus*/

//*********************************************************************
//
//   FUNCTION-NAME: element_in_liste
//
//   CLASS: objective_liste_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   FUNCTIONAL-DESCRIPTION: Diese Funktion stellt fest, ob ein Objective einer Line in der Liste
//	vorhanden ist.
//
//   FORMAL PARAMETERS: line_C *line_item_p: die Line, von der die Objective gesucht wird
//
//   IMPLICIT INPUT/OUTPUT: NONE
//
//   FUNCTION-VALUE: boolean: TRUE, wenn die Objective in der Liste ist
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
boolean objective_liste_C::element_in_liste(line_C *line_item_p,boolean fuege_aus_b)
{
objective_type_u * ausgefuegtes_element_p;
int i;

for(i = 0;i<number_elements_i;i++)
   if (liste_a[i]->line_p == line_item_p)
	if (fuege_aus_b == FALSE)
		return(TRUE);
	else
		{
		ausgefuegtes_element_p = liste_a[i];
		break;
		}//if
if ((fuege_aus_b == FALSE) || (i >= number_elements_i))
	return(FALSE);
liste_C::fuege_aus();
if (liste_a[number_elements_i]->line_p == line_item_p)
	return TRUE;
for(;i<number_elements_i;i++)
	liste_a[i] = liste_a[i+1];
liste_a[number_elements_i] = ausgefuegtes_element_p;
return TRUE;
}//element_in_liste
