#include "protocol_stack_C.h"
#include "string_C.h"
#include "line_C.h"
#include "modify.h"

extern stat_t statistic_u;
extern boolean ujust_bound_changed_b;

void protocol_stack_C::init()
{
int i;

max_elements_i = 10 * (statistic_u.number_lines_i + statistic_u.number_fanout_branches_i);
protocol_stack_a = new protocol_type_C*[max_elements_i];
if (protocol_stack_a == NULL)
	error("No more memory available");
for (i=0;i<max_elements_i;i++)
	{
	protocol_stack_a[i] = new protocol_type_C;
	if (protocol_stack_a[i] == NULL)
		error("No more memory available");
	}//for
}//protocol_stack_C

void protocol_stack_C::print_data()
{
ofstream datei_F;

datei_F.open("protocol_C.debug");
for(int i = 0;i<number_elements_i;i++)
	{
	datei_F << "********** Element_ Nr.:  " << i << "\n";
	datei_F << "Line:  " << protocol_stack_a[i]->line_p->get_name() << "\n";
	datei_F << "Optionale Zuweisung:  " << protocol_stack_a[i]->optional() << "\n";
	datei_F << "Bound Liste eingefuegt:  " << protocol_stack_a[i]->ujust_bound_in() << "\n";
	datei_F << "Bound Liste ausgefuegt:  " << protocol_stack_a[i]->ujust_bound_out() << "\n";
	datei_F << "D_Front eingefuegt:  " << protocol_stack_a[i]->d_front_in() << "\n";
	datei_F << "D_Front ausgefuegt:  " << protocol_stack_a[i]->d_front_out() << "\n";
	datei_F << "Alter Gut-Wert:  " << protocol_stack_a[i]->old_good_value() << "\n";
	datei_F << "Neuer Gut-Wert:  " << protocol_stack_a[i]->new_good_value() << "\n";
	datei_F << "Alter Schlecht-Wert:  " << protocol_stack_a[i]->old_bad_value() << "\n";
	datei_F << "Neuer Schlecht-Wert:  " << protocol_stack_a[i]->new_bad_value() << "\n";
	}//for
datei_F.close();
}//print_data

void protocol_stack_C::push(line_C *line_item_p,boolean opt_b,boolean bound_in_b,boolean bound_out_b,
			    boolean df_in_b,boolean df_out_b,value_t old_good_e,value_t new_good_e,
			    value_t old_bad_e,value_t new_bad_e)
{
#if DEBUG
if ((opt_b == FALSE) && (imp_in_b == FALSE) && (imp_out_b == FALSE) && (bound_in_b == FALSE) &&
    (bound_out_b == FALSE) && (df_in_b == FALSE) && (df_out_b == FALSE) && (old_e == UNDEFINED_VALUE) &&
    (new_e == UNDEFINED_VALUE))
	error("protocol_stack_C::push:  element doesn't have any information");
if ((opt_b == TRUE) && (new_e == UNDEFINED_VALUE))
	error("protocol_stack_C::push:  Optional assignment without any value");
if (number_elements_i == max_elements_i)
	{
	protocol_stack_a[number_elements_i] = new protocol_type_C();
	if (protocol_stack_a[number_elements_i] == NULL)
		error("no memory available");
	max_elements_i++;
	}//if
#endif
if (bound_in_b == TRUE)
	ujust_bound_changed_b = TRUE;
if (number_elements_i >= max_elements_i)
	error("protocol_stack_C::push:  there`s not enough memory for protocol pointer");
protocol_stack_a[number_elements_i]->line_p = line_item_p;
protocol_stack_a[number_elements_i]->set_optional(opt_b);
protocol_stack_a[number_elements_i]->set_ujust_bound_in(bound_in_b);
protocol_stack_a[number_elements_i]->set_ujust_bound_out(bound_out_b);
protocol_stack_a[number_elements_i]->set_d_front_in(df_in_b);
protocol_stack_a[number_elements_i]->set_d_front_out(df_out_b);
protocol_stack_a[number_elements_i]->set_old_good_value(old_good_e);
protocol_stack_a[number_elements_i]->set_new_good_value(new_good_e);
protocol_stack_a[number_elements_i]->set_old_bad_value(old_bad_e);
protocol_stack_a[number_elements_i]->set_new_bad_value(new_bad_e);
#if DEBUG
if ((protocol_stack_a[number_elements_i]->ujust_bound_in() == TRUE) &&
    (unjustified_bound_line_C.element_in_liste(protocol_stack_a[number_elements_i]->line_p) == FALSE))
	error("protocol_stack_C::push: Element not correct");
if ((protocol_stack_a[number_elements_i]->ujust_bound_out() == TRUE) &&
    (unjustified_bound_line_C.element_in_liste(protocol_stack_a[number_elements_i]->line_p) == TRUE))
	error("protocol_stack_C::push:  Element not correct");
#endif
number_elements_i++;
}//push

protocol_type_C *protocol_stack_C::pop()
{
if (number_elements_i == 0)
	return(NULL);
number_elements_i--;
return(protocol_stack_a[number_elements_i]);
}//pop
