/**********************************************************************
*
*   FILE-NAME: read_circuit_l.l
*
*   CREATION-DATE: August 91
*
*   FILE-DESCRIPTION: Dieses File beinhaltet die lexikalische Analyse der Eingabe
*
*   MODIFICATION-HISTORY:
*
**********************************************************************/
%{
#include <strings.h>
#include "extern.h"
#include "y.tab.h"

// extern "C" void	bcopy(const void *, void *, int);
extern YYSTYPE yylval;
extern int yylineno,yycolumn;
extern FILE *listfile;

int bstrlen(char *s){return(strlen(s) + 1);}
int bstrlen(unsigned char *s)
{
int l=1;
while (*s++ != '\0')l++;
return(l);
}//bstrlen
void list (unsigned char *s)
{
#if DEBUG
fprintf(listfile,"\n %s  Line: %d, Column: %d",s,yylineno,yycolumn);
#else
unsigned char *t = s;
#endif
}
void list (char *s)
{
#if DEBUG
fprintf(listfile,"\n %s  Line: %d, Column: %d",s,yylineno,yycolumn);
#else
char *t = s;
#endif
}

%}
%%

[nN]ode				{ yycolumn += 4; 
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext));
				  list(yytext); return(NODE);
				}
[cC]ircuit				{ yycolumn += 7; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(CIRCUIT);
				}
[cC]on				{ yycolumn += 3; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(CON);
				}
rd                              { yycolumn += 2;
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(RD);
                                }
fd                              { yycolumn += 2;
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(FD);
                                }
rdt                             { yycolumn += 3;
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(RDT);
                                }
fdt                             { yycolumn += 3;
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(FDT);
                                }
[iI]nput			{ yycolumn += 5; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(INPUT);
				}
[oO]utput			{ yycolumn += 6; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(OUTPUT);
				}
[sS]trobe			{ yycolumn += 6; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(STROBE);
				}
STROBEALL			{
				  yycolumn += 9; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(STROBEALL);
				}
begin				{ yycolumn += 5; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(DBEGIN);
				}
delay				{ yycolumn += 5; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(DELAY);
				}
end\.				{ yycolumn += 3; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(DEND);
				}
bit				{ yycolumn += 3; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(BIT);
				}
[aA]nd_[1-9][0-9]?	                { yycolumn += 3; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(AND_GATE);
				}
[oO]r_[1-9][0-9]?	                { yycolumn += 2; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(OR_GATE);
				}
[nN]and_[1-9][0-9]?	        { yycolumn += 4; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(NAND_GATE);
				}
[nN]or_[1-9][0-9]?	                { yycolumn += 3; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(NOR_GATE);
				}
[eE]xor				{ yycolumn += 4; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(EXOR_GATE);
				}
[Bb]lock_[1-9][0-9]?		{ yycolumn += 6; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(BLOCK_GATE);
				}
[tT]net_[1-9][0-9]?	        { yycolumn += 6; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(BLOCK_GATE);
				}
[iI]nverter			{ yycolumn += 8; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(INVERTER_GATE);
				}
[dD]river			{ yycolumn += 6; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(DRIVER_GATE);
				}
[dD]flipflop			{ yycolumn += 9; 
				  list(yytext);
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(FLIPFLOP_GATE);
				}
[:\;\=,()]			{ yycolumn ++; 
				  list(yytext); return(yytext[0]);
				}
[0-9]+				{ yycolumn += bstrlen(yytext) - 1; 
				  list(yytext);
				  yylval.ival_i = atoi((char*)yytext); return(NUMBER);
				}	
[\\a-zA-Z_][\\\/\*\!\%\.a-zA-Z_0-9\[\]\+\-\"\<\>\@]*	{ yycolumn += bstrlen(yytext) - 1;
				  list(yytext); 
				  bcopy(yytext,(&yylval)->sval_s,bstrlen(yytext)); return(NAME);
				}
"\n"				{ yycolumn = 1;yylineno++;
				  list(yytext);
				}
" "				{ yycolumn++;list(yytext);
				}
"{".*"}"			{ yycolumn += bstrlen(yytext) - 1;
				}
