%{
/**********************************************************************
*
*   FILE-NAME: read_circuit_y.y
*
*   CREATION-DATE: August 91
*
*   FILE-DESCRIPTION: Dieses File beinhaltet den Parser der Eingabedatei
*
*   MODIFICATION-HISTORY:
*
**********************************************************************/
#include "extern.h"
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloca.h>
#include "line_liste_C.h"
#include "line_C.h"
#include "gate_liste_C.h"
#include "gate_C.h"

extern int yylex(void);
extern int yylineno,yycolumn;
void yyerror(char *s)
	{
	cout << "\nLine: " << yylineno << ", Column: " << yycolumn;
	error(s);
	}
extern "C" int yywrap(){return(1);}
extern void read_edif(char*);

extern FILE *yyin;
FILE *listfile,*ausgabe;
int yylineno = 0;
int yycolumn = 1;
int rd_i = 1000,fd_i = 1000,rdt_i = 10,fdt_i = 10;
int i,invert;
int j = 1;
int eingaenge = 0;
char hilf[10];
char inlist[50];
line_liste_C io_lines_C;
gate_liste_C read_gates_C;
extern line_liste_C lines_C,input_lines_C,output_lines_C,pseudo_inputs_C,pseudo_outputs_C;
extern gate_liste_C gates_C;

%}

%start prog

%union  {
	int ival_i;
	char sval_s[stringsize_i];
	}

%token <sval_s> CIRCUIT NODE CON INPUT OUTPUT STROBE DBEGIN DEND AND_GATE OR_GATE 
%token <sval_s> NAND_GATE NOR_GATE STROBEALL BIT DELAY EXOR_GATE DRIVER_GATE FLIPFLOP_GATE
%token <sval_s> INVERTER_GATE BLOCK_GATE NAME RD FD RDT FDT
%token <ival_i> NUMBER

%%

prog	:	decl body
	;

decl 	:	cir_decl node_decl con_decl input_decl output_decl
	;

body	:	strobe_decl DBEGIN netlist DEND
	;

cir_decl :	CIRCUIT NAME ';'
	{
	strcpy(schaltungsname_s,string_C(schaltungsname_s).basename());
	}
	;

node_decl :	NODE nodelist ':' BIT ';'
	{}
	;

nodelist :	NAME
		{// Neue Line
		line_C *line_item_p;
		char *s;

		try {
		s = new char[strlen($1)+1];
		}
		catch(...) {
		  error("No more memory available");
		}
		strcpy(s,$1);
		statistic_u.number_lines_i++;
		try {
		line_item_p = new line_C(s);
		}
		catch(...) {
		  error("No more memory available");
		}
		lines_C.fuege_ein(line_item_p);
		}
	 |	nodelist ',' NAME
		{// Neue Line
		line_C *line_item_p;
		char *s;

		try {
		s = new char[strlen($3)+1];
		}
		catch(...) {
		  error("No more memory available");
		}
		strcpy(s,$3);
		statistic_u.number_lines_i++;
		try {
		line_item_p = new line_C(s);
		}
		catch(...) {
		  error("No more memory available");
		}
		lines_C.fuege_ein(line_item_p);
		}
	;

con_decl :	CON '(' DELAY ':' delay_decl ')' cellitems
	{}
         |	CON '(' DELAY ':' delay_decl ')'
	{}
	;

delay_decl :    NUMBER
         {}
           |    rf_decl ';' rft_decl
         {}
         ;

rf_decl :       RD '=' NUMBER ';' FD '=' NUMBER
                {
		rd_i = $3;
		fd_i = $7;
		}
           ;

rft_decl :      RDT '=' NUMBER ';' FDT '=' NUMBER
                {
		rdt_i = $3;
		fdt_i = $7;
                }
           ;

cellitems : 	cellitems con_decl
                {}
          |     cellitems celllist ':' AND_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$4[strlen($4)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_and_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(AND, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	cellitems celllist ':' OR_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$4[strlen($4)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_or_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(OR, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	cellitems celllist ':' BLOCK_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$4[strlen($4)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_blocks_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(BLOCK, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	cellitems celllist ':' NAND_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$4[strlen($4)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_nand_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(NAND, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	cellitems celllist ':' NOR_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$4[strlen($4)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_nor_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(NOR, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  |	cellitems celllist ':' INVERTER_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_inverters_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(INVERTER, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	cellitems celllist ':' FLIPFLOP_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_flipflops_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(D_FLIP_FLOP, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	cellitems celllist ':' DRIVER_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_drivers_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(DRIVER, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	cellitems celllist ':' EXOR_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_exor_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(EXOR, 2, 1);
		read_gates_C.loesche_liste();
		}
	  | 	celllist ':' AND_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$3[strlen($3)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_and_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(AND, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	celllist ':' OR_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$3[strlen($3)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_or_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(OR, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	celllist ':' BLOCK_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$3[strlen($3)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_blocks_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(BLOCK, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	celllist ':' NAND_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$3[strlen($3)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_nand_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(NAND, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  | 	celllist ':' NOR_GATE ';'
		{
		gate_C *gate_item_p;
		char *hilf_s = &$3[strlen($3)-1];
		
		if (hilf_s[-1] != '_')
		   hilf_s--;
		statistic_u.number_nor_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(NOR, atoi(hilf_s), 1);
		read_gates_C.loesche_liste();
		}
	  |	celllist ':' INVERTER_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_inverters_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(INVERTER, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	celllist ':' FLIPFLOP_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_flipflops_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(D_FLIP_FLOP, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	celllist ':' DRIVER_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_drivers_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(DRIVER, 1, 1);
		read_gates_C.loesche_liste();
		}
	  |	celllist ':' EXOR_GATE ';'
		{
		gate_C *gate_item_p;

		statistic_u.number_exor_gates_i+=read_gates_C.no_elements();
		forall(gate_item_p,read_gates_C)
		   gate_item_p->belege_gate(EXOR, 2, 1);
		read_gates_C.loesche_liste();
		}
	;

celllist :	gate_def
	 |	celllist ',' gate_def
	;

gate_def  :	NAME
		{// Stringliste aufbauen, dann gate Typ alloziieren. Nicht nur AND Gatter hier
		gate_C *gate_item_p;
		 
		statistic_u.number_gates_i++;
		char *s;
		try {
		s = new char[strlen($1)+1];
		}
		catch(...) {
		  error("No more memory available");
		}
		strcpy(s,$1);
		try {
		gate_item_p = new gate_C(s);
		}
		catch(...) {
		  error("No more memory available");
		}
		read_gates_C.fuege_ein(gate_item_p);
		gates_C.fuege_ein(gate_item_p);
		}
	;

input_decl :	INPUT in_itemlist ';'
	{}
	;

in_itemlist :	in_itemlist ',' NAME
		{// Neue Line
		line_C *line_item_p;
		char *s = $3;

		statistic_u.number_inputs_i++;
		line_item_p = search(s,milef_line_tree_root_p);
		if (line_item_p == NULL)
		   {
		   cout << s;
		   error("Line not found in definition");
		   }//if
		line_item_p->set_primary_input();
		input_lines_C.fuege_ein(line_item_p);
		}
	   |	NAME
		{// Neue Line
		line_C *line_item_p;
		char *s = $1;

		statistic_u.number_inputs_i++;
		line_item_p = search(s,milef_line_tree_root_p);
		if (line_item_p == NULL)
		   {
		   cout << s;
		   error("Line not found in definition");
		   }//if
		line_item_p->set_primary_input();
		input_lines_C.fuege_ein(line_item_p);
		}
	    ;

output_decl :	OUTPUT o_itemlist ';'
	{}
	;

o_itemlist :	o_itemlist ',' NAME
		{// Neue Line
		line_C *line_item_p;
		char *s = $3;

		statistic_u.number_outputs_i++;
		line_item_p = search(s,milef_line_tree_root_p);
		if (line_item_p == NULL)
		   {
		   cout << s;
		   error("Line not found in definition");
		   }//if
		line_item_p->set_primary_output();
		output_lines_C.fuege_ein(line_item_p);
		}
           |    NAME
		{// Neue Line
		line_C *line_item_p;
		char *s = $1;

		statistic_u.number_outputs_i++;
		line_item_p = search(s,milef_line_tree_root_p);
		if (line_item_p == NULL)
		   {
		   cout << s;
		   error("Line not found in definition");
		   }//if
		line_item_p->set_primary_output();
		output_lines_C.fuege_ein(line_item_p);
		}
	    ;

strobe_decl :	STROBE STROBEALL ':' strobelist ';'
	{}
	;

strobelist :	NAME
	{}
	|	strobelist ',' NAME
	{}
	;


netlist :	NAME '(' netitemlist 
		{
		gate_C *gate_item_p;

		gate_item_p = search($1,milef_gate_tree_root_p);
		if (gate_item_p == NULL)
		   {
		   cout << $1;
		   error("Gate not found in definition");
		   }//if
		gate_item_p->connect_input(io_lines_C);
		io_lines_C.loesche_liste();
		}
		';' netitemlist ')' ';'
		{
		gate_C *gate_item_p;

		gate_item_p = search($1,milef_gate_tree_root_p);
		if (gate_item_p == NULL)
		   {
		   cout << $1;
		   error("Gate not found in definition");
		   }//if
		gate_item_p->connect_output(io_lines_C);
		io_lines_C.loesche_liste();
		}
	|	netlist NAME '(' netitemlist 
		{
		gate_C *gate_item_p;

		gate_item_p = search($2,milef_gate_tree_root_p);
		if (gate_item_p == NULL)
		   {
		   cout << $2;
		   error("Gate not found in definition");
		   }//if
		gate_item_p->connect_input(io_lines_C);
		io_lines_C.loesche_liste();
		}
		';' netitemlist ')' ';'
		{
		gate_C *gate_item_p;

		gate_item_p = search($2,milef_gate_tree_root_p);
		if (gate_item_p == NULL)
		   {
		   cout << $2;
		   error("Gate not found in definition");
		   }//if
		gate_item_p->connect_output(io_lines_C);
		io_lines_C.loesche_liste();
		}
	;

netitemlist :	NAME
		{
		line_C *line_item_p;
		
		line_item_p = search($1,milef_line_tree_root_p);
		if (line_item_p == NULL)
		      {
		      cout << $1;
		      error("Line not found in list");
		      }//if
		io_lines_C.fuege_ein(line_item_p);
		}
	 |	netitemlist ',' NAME
		{
		line_C *line_item_p;
		
		line_item_p = search($3,milef_line_tree_root_p);
		if (line_item_p == NULL)
		      {
		      cout << $3;
		      error("Line not found in list");
		      }//if
		io_lines_C.fuege_ein(line_item_p);
		}
	;

%%

void read_circuit()
{
io_lines_C.init(max_number_gate_inputs_i);
cout << "Read Circuit   Name = " << schaltungsname_s << "\n" << flush;
//if ((strcmp(&schaltungsname_s[strlen(schaltungsname_s)-4],".edf") == 0) ||
//    (strcmp(&schaltungsname_s[strlen(schaltungsname_s)-5],".edif") == 0))
//   read_edif(schaltungsname_s);
//else
//   {
#if DEBUG
   listfile = fopen("flex_list.lis","w");
#endif
   yylineno = 1;
   yycolumn = 1;
   lines_C.init(max_number_lines_i);
   input_lines_C.init(max_number_lines_i);
   output_lines_C.init(max_number_lines_i);
   pseudo_inputs_C.init(max_number_lines_i);
   pseudo_outputs_C.init(max_number_lines_i);
   gates_C.init(max_number_gates_i);
   if ((yyin = fopen(schaltungsname_s,"r")) == NULL)
      error("file not found");
   read_gates_C.init(max_number_gates_i);
   yyparse();
   read_gates_C.~gate_liste_C();
//   }//else
io_lines_C.~line_liste_C();
}
