#include "string_C.h"

//*********************************************************************
//
//   CLASS-NAME: string_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Strings und alle notwendigen
//	Operationen auf Strings.
//
//   OPERATOREN: +: Konkatenation
//		 =: Zuweisung
//		 ==: Vergleich auf Gleichheit
//		 <<: Ausgabe auf stream
//		 char*: cast Operator fuer char* Typ
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer sowie char* Argument
//		 Destruktor, macht nichts, da Fehler bei delete in Destruktor
//		length: gibt aktuelle Laenge aus
//		max_length: gibt die Groesse des alloziierten Speichers aus
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
string_C::string_C(int size_i)
{
inhalt_s = new char[size_i + 1];
if (inhalt_s == NULL)
	error("No more memory available");
max_groesse_i = size_i;
akt_groesse_i = 0;
strcpy(inhalt_s,"");
}

string_C::string_C(char *name_s)
{
akt_groesse_i = strlen(name_s);
max_groesse_i = akt_groesse_i;
inhalt_s = new char[akt_groesse_i + 1];
if (inhalt_s == NULL)
	error("No more memory available");
strcpy(inhalt_s, name_s);
}

/*
string_C::string_C(string_C &name_sC)
{
char *name_s = name_sC;

akt_groesse_i = strlen(name_s);
max_groesse_i = akt_groesse_i;
inhalt_s = NULL;
inhalt_s = new char[akt_groesse_i + 1];
if (inhalt_s == NULL)
	error("No more memory available");
strcpy(inhalt_s, name_s);
}
*/

string_C& string_C::operator = (string_C s_sC)
{
if (inhalt_s != NULL)
  delete[] inhalt_s;
inhalt_s = new char[s_sC.akt_groesse_i+1];
akt_groesse_i = s_sC.akt_groesse_i;
max_groesse_i = s_sC.max_groesse_i;
strcpy(inhalt_s,s_sC.inhalt_s);
return *this;
}

int string_C::gib_id()
{
char s[10];
int i,j=0;

for (i=0;i<akt_groesse_i;i++)
if (inhalt_s[i] == 'x')
	return(-1);
else if ((inhalt_s[i] >= '0') && (inhalt_s[i] <= '9'))
	s[j++] = inhalt_s[i];
s[j] = '\0';
return (atoi(s));
}//gib_id

boolean string_C::tail(char *s)
{
int i,j;

for (i=0;inhalt_s[i] != '\0';i++);
for (j=0;s[j] != '\0';j++);
for (;j>=0;i--,j--)
if (inhalt_s[i] != s[j])
	return(FALSE);
return(TRUE);
}//tail

char *string_C::basename()
{
static char s[stringsize_i];

for (int i=0;(inhalt_s[i] != '.') && (inhalt_s[i] != '\0');i++)
	{
	s[i] = inhalt_s[i];
	s[i+1] = '\0';
	}//for
return(s);
}//basename

string_C operator + (string_C s1_sC, string_C s2_sC)
	{
	  // Die Konkatenation zweier Strings. Vorsicht: a+b+c geht nicht.
	  // Der Ergebnisstring erhaelt die minimale Groesse.
	string_C result_sC(s2_sC.akt_groesse_i + s1_sC.akt_groesse_i);

	strcpy(result_sC.inhalt_s,s1_sC.inhalt_s);
	strcat(result_sC.inhalt_s,s2_sC.inhalt_s);
	result_sC.akt_groesse_i = s2_sC.akt_groesse_i + s1_sC.akt_groesse_i;
	return(result_sC);
	}

boolean operator == (string_C s1_sC,string_C s2_sC)
	{
	  // Vergleich zweier Strings. Ergebnis wird auf boolean abgebildet.
	if (strcmp(s2_sC.inhalt_s,s1_sC.inhalt_s) == 0)
		return(TRUE);
	else
		return(FALSE);
	}

void string_C::gib_mixed_circuit_id(int &ci_i,int &bl_i)
{
char s[stringsize_i];

sscanf(inhalt_s,"%[A-Z]x%dx%d",s,&ci_i,&bl_i);
}//gib_mixed_circuit_id
