#ifndef string_C_h
#define string_C_h
#include "consts.h"
#include "prot.h"

//*********************************************************************
//
//   CLASS-NAME: string_C
//
//   AUTHOR: Uwe Glaeser
//
//   CREATION-DATE: August 91
//
//   CLASS-DESCRIPTION: Diese Klasse definiert Strings und alle notwendigen
//	Operationen auf Strings.
//
//   OPERATOREN: +: Konkatenation
//		 =: Zuweisung
//		 ==: Vergleich auf Gleichheit
//		 <<: Ausgabe auf stream
//		 char*: cast Operator fuer char* Typ
//
//   FUNKTIONEN: 2 Konstruktoren mit Integer sowie char* Argument
//		 Destruktor, macht nichts, da Fehler bei delete in Destruktor
//		length: gibt aktuelle Laenge aus
//		max_length: gibt die Groesse des alloziierten Speichers aus
//
//   MODIFICATION-HISTORY:
//
//*********************************************************************
class string_C {
public:
   string_C(int size_i = stringsize_i);
   string_C(char *name_s);
   // string_C(string_C &name_sC);
   ~string_C(){/*delete[] inhalt_s;*/}
   operator char *(){return inhalt_s;}
   friend string_C operator + (string_C, string_C);
   friend boolean operator == (string_C,string_C);
   string_C& operator = (string_C s_sC);
   int length(){return(akt_groesse_i);}
   int max_length(){return(max_groesse_i);}
   int gib_id();
   void gib_mixed_circuit_id(int &ci_i,int &bl_i);
   boolean tail(char *s);
   char *basename();
private:
   int akt_groesse_i;  // Aktuelle String Groesse
   int max_groesse_i;  // Maximale String Groesse
   char *inhalt_s;     // Inhalt des Strings
};
const string_C empty_sC = "";
#endif







