// *********************************************************************
//
//   FILE-NAME: transform.c
//
//   CREATION-DATE: August 91
//
//   FILE-DESCRIPTION: Dieses File beinhaltet Routinen fuer veraenderungen
//	in der Schaltung.
//
//   MODIFICATION-HISTORY:
//
// *********************************************************************
#include "extern.h"
#include "line_liste_C.h"
#include "line_C.h"
#include "gate_liste_C.h"
#include "gate_C.h"

extern line_liste_C pseudo_inputs_C;
extern line_liste_C pseudo_outputs_C;

void make_fanout_blocks()
{
line_C *fanout_line_p,*line_item_p;
gate_C *gate_item_p;
int fanout_block_counter_i=1,j;
char *name_s;
char *branch_name_s;
line_liste_C gate_inputs_C,gate_outputs_C;

gate_inputs_C.init(2);
gate_outputs_C.init(max_number_lines_i);
forall(fanout_line_p,lines_C)
        {
        if (fanout_line_p->gib_fanout() == FALSE)
                {
                if (fanout_line_p->nachfolger()->no_elements() == 0)
                        continue;
                gate_item_p = fanout_line_p->nachfolger()->gib_only_gate();
                fanout_line_p->nachfolger()->loesche_liste_und_pointer();
                fanout_line_p->nachfolger()->verbinde(gate_item_p);
                continue;
                }//if
        try {
        name_s = new char[strlen((char*)fanout_line_p->get_name()) + 1];
        }
        catch(...) {
          error("No more memory available");
        }
        strcpy(name_s,(char*)fanout_line_p->get_name());
        statistic_u.number_fanouts_i++;
        j = 0;
        gate_inputs_C.fuege_ein(fanout_line_p);
        if (fanout_line_p->is_primary_output() == TRUE)
                {
                statistic_u.number_fanout_branches_i++;
                j++;
                try {
                branch_name_s = new char[strlen(name_s) + 13];
                sprintf(branch_name_s,"%s->output__%d",name_s,j);
                line_item_p = new line_C(branch_name_s,1);
                }
                catch(...) {
                  error("No more memory available");
                }
                lines_C.fuege_ein(line_item_p);
                line_item_p->set_primary_output();
                fanout_line_p->set_primary_output(FALSE);
                output_lines_C.fuege_aus(fanout_line_p);
                output_lines_C.fuege_ein(line_item_p);
                gate_outputs_C.fuege_ein(line_item_p);
                }//forall
        forall(gate_item_p,*fanout_line_p->nachfolger())
                {
                statistic_u.number_fanout_branches_i++;
                j++;
                line_item_p = (*gate_item_p->gib_outputs())[0];
                try {
                branch_name_s = new char[strlen(name_s) + strlen((char*)line_item_p->get_name()) + 12];
                sprintf(branch_name_s,"%s->%s__%d",name_s,(char*)line_item_p->get_name(),j);
                line_item_p = new line_C(branch_name_s,1);
                }
                catch(...) {
                  error("No more memory available");
                }
                lines_C.fuege_ein(line_item_p);
                gate_item_p->gib_inputs()->change_connection(name_s,line_item_p);
                line_item_p->verbinde(gate_item_p,'I');
                gate_outputs_C.fuege_ein(line_item_p);
                }//forall
        try {
        gate_item_p = new gate_C(name_s);
        }
        catch(...) {
          error("No more memory available");
        }
        gates_C.fuege_ein(gate_item_p);
        gate_item_p->belege_gate(FANOUT,1,j);
        gate_item_p->connect_output(gate_outputs_C);
        gate_outputs_C.loesche_liste();
        fanout_line_p->nachfolger()->loesche_liste_und_pointer();
        gate_item_p->connect_input(gate_inputs_C);
        gate_inputs_C.loesche_liste();
        }//forall
}//make_fanout_blocks

void destroy_unconnected(line_C *line_item_p,gate_C *gate_item_p,int &i)
{
gate_C *gate_p;
line_C *line_p;

cout << "WARNING: " << line_item_p->get_name() << " not connected!!!      DELETING\n" << flush;
if (gate_item_p != NULL)
   if (gate_item_p->gib_type() == FANOUT)
   	{
   	gate_item_p->gib_outputs()->fuege_aus(line_item_p,TRUE);
   	gate_item_p->update_no_outputs();
   	if (gate_item_p->gib_outputs()->no_elements() == 0)
	      {
	      line_p = gate_item_p->gib_inputs()->gib_only_line();
	      if (line_p->is_primary_input() == TRUE)
                 gate_p = NULL;
              else
                 gate_p = line_p->vorgaenger()->gib_only_gate();
	      destroy_unconnected(line_p,gate_p,i);
	      gates_C.fuege_aus(gate_item_p);
	      delete gate_item_p;
	      }//if
	}//if
   else
	{
	forall(line_p,*gate_item_p->gib_inputs())
	      {
	      if (line_p->is_primary_input() == TRUE)
		 gate_p = NULL;
	      else
		 gate_p = (*line_p->vorgaenger())[0];
	      destroy_unconnected(line_p,gate_p,i);
	      }//forall
	gates_C.fuege_aus(gate_item_p);
	delete gate_item_p;
	}//else
lines_C.fuege_aus(line_item_p);
if (line_item_p->is_primary_input() == TRUE)
   input_lines_C.fuege_aus(line_item_p);
delete line_item_p;
i++;
}//destroy_unconnected

void remove_unconnected_outputs()
{
line_C *line_item_p;
gate_C *gate_item_p;
int i;

forall(line_item_p,lines_C)
   {
   if ((line_item_p->is_primary_output() == TRUE) || (line_item_p->nachfolger()->no_elements() > 0))
      continue;
   i = 0;
   if (line_item_p->vorgaenger()->no_elements() > 0)
      gate_item_p = (*line_item_p->vorgaenger())[0];
   else
      gate_item_p = NULL;
   destroy_unconnected(line_item_p,gate_item_p,i);
   forall_index-=i;
   if (forall_index < 0)
      forall_index = -1;
   }//forall
}//remove_unconnected_outputs

void make_comb_circuit()
{
gate_C *gate_item_p;
line_C *input_line_p,*output_line_p;
int i;

for (i=0;i<gates_C.no_elements();i++)
   {
   gate_item_p = gates_C[i];
   if (gate_item_p->gib_type() == D_FLIP_FLOP)
	{
	forall(input_line_p,*gate_item_p->gib_inputs())
	   {
	   input_line_p->set_primary_output();
//	   input_line_p->nachfolger()->loesche_liste();
	   output_lines_C.fuege_ein(input_line_p);
	   }//forall
	{forall(output_line_p,*gate_item_p->gib_outputs())
	   {
	   output_line_p->set_primary_input();
	   input_lines_C.fuege_ein(output_line_p);
//	   output_line_p->vorgaenger()->loesche_liste();
	   }}//forall
	gates_C.fuege_aus(gate_item_p);
//	delete gate_item_p;
	i--;
	}//if
   }//for
}//make_comb_circuit

void merge_gates()
{
line_C *nach_sig_p,*vor_sig_p,*line_item_p;
gate_C *nach_gat_p,*vor_gat_p,*gate_p,*gate_item_p;
int zaehl_i = 0;

forall(gate_item_p,gates_C)
	if (gate_item_p->gib_type() == DRIVER)
		{
		nach_sig_p = (*gate_item_p->gib_outputs())[0];
		vor_sig_p = (*gate_item_p->gib_inputs())[0];
		nach_gat_p = (*nach_sig_p->nachfolger())[0];
		vor_gat_p = (*vor_sig_p->vorgaenger())[0];
		if ((nach_sig_p->is_primary_output() == TRUE) &&
		    (vor_sig_p->is_primary_input() == TRUE))
			continue;
		if (nach_sig_p->is_primary_output() == TRUE)
			{
			nach_sig_p->vorgaenger()->change_connection(gate_item_p->get_name(),vor_gat_p);
			vor_gat_p->gib_outputs()->change_connection(vor_sig_p->get_name(),nach_sig_p);
			gates_C.fuege_aus(gate_item_p);
			delete gate_item_p;
			lines_C.fuege_aus(vor_sig_p);
			delete vor_sig_p;
			}//if
		else
			{
			vor_sig_p->nachfolger()->change_connection(gate_item_p->get_name(),nach_gat_p);
			nach_gat_p->gib_inputs()->change_connection(nach_sig_p->get_name(),vor_sig_p);
			gates_C.fuege_aus(gate_item_p);
			delete gate_item_p;
			lines_C.fuege_aus(nach_sig_p);
			delete nach_sig_p;
			}//else
		}//if
{forall(gate_item_p,gates_C)
	if (gate_item_p->gib_type() == INVERTER)
		{
		if ((*gate_item_p->gib_outputs())[0]->is_primary_output() == TRUE)
			continue;
		gate_p = (*(*gate_item_p->gib_outputs())[0]->nachfolger())[0];
		if (gate_p->gib_type() != INVERTER)
			continue;
		nach_sig_p = (*gate_p->gib_outputs())[0];
		vor_sig_p = (*gate_item_p->gib_inputs())[0];
		nach_gat_p = (*nach_sig_p->nachfolger())[0];
		vor_gat_p = (*vor_sig_p->vorgaenger())[0];
		if ((nach_sig_p->is_primary_output() == TRUE) &&
		    (vor_sig_p->is_primary_input() == TRUE))
			continue;
		if (nach_sig_p->is_primary_output() == TRUE)
			{
			nach_sig_p->vorgaenger()->change_connection(gate_p->get_name(),vor_gat_p);
			vor_gat_p->gib_outputs()->change_connection(vor_sig_p->get_name(),nach_sig_p);
			gates_C.fuege_aus(gate_item_p);
			delete gate_item_p;
			line_item_p = (*gate_p->gib_inputs())[0];
			lines_C.fuege_aus(line_item_p);
			delete line_item_p;
			gates_C.fuege_aus(gate_p);
			delete gate_p;
			lines_C.fuege_aus(vor_sig_p);
			delete vor_sig_p;
			}//if
		else
			{
			vor_sig_p->nachfolger()->change_connection(gate_item_p->get_name(),nach_gat_p);
			nach_gat_p->gib_inputs()->change_connection(nach_sig_p->get_name(),vor_sig_p);
			gates_C.fuege_aus(gate_item_p);
			delete gate_item_p;
			line_item_p = (*gate_p->gib_inputs())[0];
			lines_C.fuege_aus(line_item_p);
			delete line_item_p;
			gates_C.fuege_aus(gate_p);
			delete gate_p;
			lines_C.fuege_aus(nach_sig_p);
			delete nach_sig_p;
			}//else
		}}//if
{forall(gate_item_p,gates_C)
	if ((gate_item_p->gib_type() == AND) && (gate_item_p->gib_type() == NAND) &&
	    (gate_item_p->gib_type() == OR) && (gate_item_p->gib_type() == NOR))
		{
		if ((*gate_item_p->gib_outputs())[0]->is_primary_output() == TRUE)
			continue;
		gate_p = (*(*gate_item_p->gib_outputs())[0]->nachfolger())[0];
		if (gate_p->gib_type() != INVERTER)
			continue;
		nach_sig_p = (*gate_p->gib_outputs())[0];
		vor_sig_p = (*gate_p->gib_inputs())[0];
		nach_sig_p->vorgaenger()->change_connection(gate_p->get_name(),gate_item_p);
		gate_item_p->gib_outputs()->change_connection(vor_sig_p->get_name(),nach_sig_p);
		gate_item_p->invert_type();
		gates_C.fuege_aus(gate_p);
		delete gate_p;
		lines_C.fuege_aus(vor_sig_p);
		delete vor_sig_p;
		}}//if
//{forall(gate_item_p,gates_C)
//	if ((gate_item_p->gib_type() == AND) && (gate_item_p->gib_type() == OR))
//		{
//		if ((*gate_item_p->gib_outputs())[0]->is_primary_output() == TRUE)
//			continue;
//		gate_p = (*(*gate_item_p->gib_outputs())[0]->nachfolger())[0];
//		if (gate_p->gib_type() != gate_item_p->gib_type())
//			continue;
//		line_item_p = (*gate_item_p->gib_outputs())[0];
//		gate_p->gib_inputs()->change_connection(line_item_p->get_name(),(*gate_item_p->gib_inputs())[0]);
//		{forall(vor_sig_p,*gate_item_p->gib_inputs())
//			vor_sig_p->nachfolger()->change_connection(gate_item_p->get_name(),gate_p);}
//		gate_p->gib_inputs()->merge_list(gate_item_p->gib_inputs());
//		gate_p->update_no_inputs();
//		gates_C.fuege_aus(gate_item_p);
//		delete gate_item_p;
//		lines_C.fuege_aus(line_item_p);
//		delete line_item_p;
//		forall_index--;
//		}}//if
//{forall(gate_item_p,gates_C)
//	if (gate_item_p->gib_type() == FANOUT)
//	   {
//	   forall(line_item_p,*gate_item_p->gib_outputs())
//		{
//		if (line_item_p->is_primary_output() == TRUE)
//			continue;
//		gate_p = (*line_item_p->nachfolger())[0];
//		if (gate_p->gib_type() != FANOUT)
//			continue;
//		nach_sig_p = (*gate_p->gib_outputs())[0];
//		gate_item_p->gib_outputs()->change_connection(line_item_p->get_name(),nach_sig_p);
//		nach_sig_p->vorgaenger()->change_connection(gate_p->get_name(),gate_item_p);
//		gate_item_p->gib_outputs()->merge_list(gate_p->gib_outputs());
//		forall(nach_sig_p,*gate_p->gib_outputs())
//			nach_sig_p->vorgaenger()->change_connection(gate_p->get_name(),gate_item_p);
//		cout << line_item_p->get_name() << ": ";
//		lines_C.fuege_aus(line_item_p);
//		delete line_item_p;
//		gates_C.fuege_aus(gate_p);
//		delete gate_p;
//		forall_index--;
//		cout << ++zaehl_i << ". FANOUT ausgefuegt\n";
//		}}}//if
}//merge_gates

void transform_circuit()
{
cout << "Transform Circuit\n" << flush;
make_fanout_blocks();
remove_unconnected_outputs();
//merge_gates();
make_comb_circuit();
}//transform_circuit

void gate_C::invert_type()
{
switch (gate_e)
	{
	case AND:
		gate_e = NAND;
		break;
	case NAND:
		gate_e = AND;
		break;
	case OR:
		gate_e = NOR;
		break;
	case NOR:
		gate_e = OR;
		break;
	default:
                error("gate_C::invert_type: cannot invert this gate type");
	}//switch
}//invert_type

void gate_C::update_no_inputs(){no_input_i = gib_inputs()->no_elements();}
void gate_C::update_no_outputs(){no_output_i = gib_outputs()->no_elements();}
